#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 509
#define LARGE_STATE_COUNT 93
#define SYMBOL_COUNT 243
#define ALIAS_COUNT 0
#define TOKEN_COUNT 106
#define EXTERNAL_TOKEN_COUNT 7
#define FIELD_COUNT 9
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 22

enum {
  anon_sym_DQUOTE = 1,
  aux_sym_legacy_quoted_stmt_token1 = 2,
  anon_sym_TILDE = 3,
  sym_grep_specifier_identifier = 4,
  aux_sym_grep_specifier_token1 = 5,
  anon_sym_PIPE = 6,
  anon_sym_PIPEH = 7,
  anon_sym_AT_AT_DOT = 8,
  anon_sym_AT_AT_EQ = 9,
  anon_sym_AT_AT_AT_EQ = 10,
  anon_sym_AT_AT = 11,
  anon_sym_AT_ATc_COLON = 12,
  anon_sym_AT_AT_ATc_COLON = 13,
  anon_sym_AT_ATC = 14,
  anon_sym_COLON = 15,
  anon_sym_AT_ATdbt = 16,
  anon_sym_AT_ATdbta = 17,
  anon_sym_AT_ATdbtb = 18,
  anon_sym_AT_ATdbts = 19,
  anon_sym_AT_ATt = 20,
  anon_sym_AT_ATb = 21,
  anon_sym_AT_ATi = 22,
  anon_sym_AT_ATii = 23,
  anon_sym_AT_ATiS = 24,
  anon_sym_AT_ATiSS = 25,
  anon_sym_AT_ATis = 26,
  anon_sym_AT_ATiz = 27,
  anon_sym_AT_ATf = 28,
  anon_sym_AT_ATF = 29,
  anon_sym_AT_ATom = 30,
  anon_sym_AT_ATdm = 31,
  anon_sym_AT_ATr = 32,
  anon_sym_AT_ATs_COLON = 33,
  anon_sym_AT = 34,
  anon_sym_AT_BANG = 35,
  anon_sym_AT_LPAREN = 36,
  anon_sym_RPAREN = 37,
  anon_sym_ATa_COLON = 38,
  anon_sym_ATb_COLON = 39,
  anon_sym_ATB_COLON = 40,
  anon_sym_ATe_COLON = 41,
  anon_sym_ATF_COLON = 42,
  anon_sym_ATi_COLON = 43,
  anon_sym_ATk_COLON = 44,
  anon_sym_ATo_COLON = 45,
  anon_sym_ATr_COLON = 46,
  anon_sym_ATf_COLON = 47,
  anon_sym_ATs_COLON = 48,
  anon_sym_ATv_COLON = 49,
  anon_sym_ATx_COLON = 50,
  aux_sym__search_stmt_token1 = 51,
  anon_sym_DOT = 52,
  aux_sym__interpret_stmt_token1 = 53,
  aux_sym__interpret_stmt_token2 = 54,
  aux_sym__interpret_stmt_token3 = 55,
  aux_sym__interpret_stmt_token4 = 56,
  anon_sym_PIPE_DOT = 57,
  anon_sym_DOT_SLASH = 58,
  anon_sym_pfo = 59,
  anon_sym_Cf = 60,
  sym_pf_dot_cmd_identifier = 61,
  sym_pf_dot_full_cmd_identifier = 62,
  aux_sym_pf_cmd_token1 = 63,
  anon_sym_EQ = 64,
  aux_sym__pf_dot_arg_identifier_token1 = 65,
  anon_sym_DOLLAR = 66,
  anon_sym_LPAREN = 67,
  aux_sym_pf_arg_identifier_token1 = 68,
  anon_sym_PERCENT = 69,
  anon_sym_env = 70,
  anon_sym_DOT_DOT_DOT = 71,
  sym_system_identifier = 72,
  sym_question_mark_identifier = 73,
  sym_pointer_identifier = 74,
  sym_macro_identifier = 75,
  anon_sym_SEMI = 76,
  anon_sym_GT = 77,
  anon_sym_GT_GT = 78,
  sym_html_redirect_operator = 79,
  sym_html_append_operator = 80,
  anon_sym_COMMA = 81,
  aux_sym_tmp_eval_arg_token1 = 82,
  sym__eq_sep_key_identifier = 83,
  aux_sym_arg_identifier_token1 = 84,
  aux_sym_spec_arg_identifier_token1 = 85,
  aux_sym_double_quoted_arg_token1 = 86,
  aux_sym_double_quoted_arg_token2 = 87,
  aux_sym_double_quoted_arg_token3 = 88,
  anon_sym_SQUOTE = 89,
  aux_sym_single_quoted_arg_token1 = 90,
  aux_sym_single_quoted_arg_token2 = 91,
  anon_sym_DOLLAR_LPAREN = 92,
  anon_sym_BQUOTE = 93,
  aux_sym__dec_number_token1 = 94,
  aux_sym__dec_number_token2 = 95,
  sym__comment = 96,
  anon_sym_LF = 97,
  anon_sym_CR = 98,
  sym__cmd_identifier = 99,
  sym__help_stmt = 100,
  sym_file_descriptor = 101,
  sym__eq_sep_concat = 102,
  sym__concat = 103,
  sym__concat_pf_dot = 104,
  sym__spec_sep = 105,
  sym_statements = 106,
  sym__statements_singleline = 107,
  sym__statement = 108,
  sym_legacy_quoted_stmt = 109,
  sym__simple_stmt = 110,
  sym__tmp_stmt = 111,
  sym__iter_stmt = 112,
  sym__pipe_stmt = 113,
  sym_grep_stmt = 114,
  sym_grep_specifier = 115,
  sym_html_disable_stmt = 116,
  sym_html_enable_stmt = 117,
  sym_pipe_stmt = 118,
  sym_iter_file_lines_stmt = 119,
  sym_iter_offsets_stmt = 120,
  sym_iter_offsetssizes_stmt = 121,
  sym_iter_hit_stmt = 122,
  sym_iter_interpret_stmt = 123,
  sym_iter_interpret_offsetssizes_stmt = 124,
  sym_iter_comment_stmt = 125,
  sym_iter_dbta_stmt = 126,
  sym_iter_dbtb_stmt = 127,
  sym_iter_dbts_stmt = 128,
  sym_iter_threads_stmt = 129,
  sym_iter_bbs_stmt = 130,
  sym_iter_instrs_stmt = 131,
  sym_iter_import_stmt = 132,
  sym_iter_sections_stmt = 133,
  sym_iter_segments_stmt = 134,
  sym_iter_symbol_stmt = 135,
  sym_iter_string_stmt = 136,
  sym_iter_flags_stmt = 137,
  sym_iter_function_stmt = 138,
  sym_iter_iomap_stmt = 139,
  sym_iter_dbgmap_stmt = 140,
  sym_iter_register_stmt = 141,
  sym_iter_step_stmt = 142,
  sym_tmp_seek_stmt = 143,
  sym_tmp_blksz_stmt = 144,
  sym_tmp_fromto_stmt = 145,
  sym_tmp_arch_stmt = 146,
  sym_tmp_bits_stmt = 147,
  sym_tmp_nthi_stmt = 148,
  sym_tmp_eval_stmt = 149,
  sym_tmp_fs_stmt = 150,
  sym_tmp_reli_stmt = 151,
  sym_tmp_kuery_stmt = 152,
  sym_tmp_fd_stmt = 153,
  sym_tmp_reg_stmt = 154,
  sym_tmp_file_stmt = 155,
  sym_tmp_string_stmt = 156,
  sym_tmp_value_stmt = 157,
  sym_tmp_hex_stmt = 158,
  sym_help_stmt = 159,
  sym_arged_stmt = 160,
  sym__simple_arged_stmt_question = 161,
  sym__simple_arged_stmt = 162,
  sym__search_stmt = 163,
  sym__math_arged_stmt = 164,
  sym__pointer_arged_stmt = 165,
  sym__macro_arged_stmt = 166,
  sym__system_stmt = 167,
  sym__interpret_stmt = 168,
  sym__interpret_search_identifier = 169,
  sym__pf_arged_stmt = 170,
  sym__pf_stmts = 171,
  sym_Cf_cmd = 172,
  sym__Cf_args = 173,
  sym_pf_new_cmd = 174,
  sym_pf_dot_cmd = 175,
  sym_pf_cmd = 176,
  sym_pf_new_args = 177,
  sym_pf_dot_cmd_args = 178,
  sym__pf_dot_arg_identifier = 179,
  sym__pf_arg_parentheses = 180,
  sym_pf_arg_identifier = 181,
  sym__pf_arg = 182,
  sym__pf_dot_arg = 183,
  sym_pf_concatenation = 184,
  sym_pf_dot_concatenation = 185,
  sym_pf_arg = 186,
  sym_pf_dot_arg = 187,
  sym_pf_args = 188,
  sym_pf_dot_args = 189,
  sym__env_stmt = 190,
  sym__env_stmt_identifier = 191,
  sym__last_stmt = 192,
  sym_last_stmt_identifier = 193,
  sym_repeat_stmt = 194,
  sym_eq_sep_args = 195,
  sym_macro_call_content = 196,
  sym_macro_call_full_content = 197,
  sym_macro_content = 198,
  sym_macro_args = 199,
  sym_redirect_stmt = 200,
  sym__redirect_operator = 201,
  sym_fdn_redirect_operator = 202,
  sym_fdn_append_operator = 203,
  sym__arg_with_paren = 204,
  sym__arg = 205,
  sym_arg = 206,
  sym_args = 207,
  sym_tmp_eval_args = 208,
  sym_tmp_eval_arg = 209,
  sym__eq_sep_key_single = 210,
  sym__eq_sep_key_concatenation = 211,
  sym__eq_sep_key = 212,
  sym__eq_sep_val_concatenation = 213,
  sym__eq_sep_val = 214,
  sym_arg_identifier = 215,
  sym_spec_arg_identifier = 216,
  sym_double_quoted_arg = 217,
  sym_single_quoted_arg = 218,
  sym_cmd_substitution_arg = 219,
  sym_concatenation = 220,
  sym__dec_number = 221,
  sym_specifiers = 222,
  sym_cmd_identifier = 223,
  aux_sym_statements_repeat1 = 224,
  aux_sym_statements_repeat2 = 225,
  aux_sym__statements_singleline_repeat1 = 226,
  aux_sym__statements_singleline_repeat2 = 227,
  aux_sym_grep_specifier_repeat1 = 228,
  aux_sym_pf_concatenation_repeat1 = 229,
  aux_sym_pf_dot_concatenation_repeat1 = 230,
  aux_sym_pf_args_repeat1 = 231,
  aux_sym_pf_dot_args_repeat1 = 232,
  aux_sym_macro_content_repeat1 = 233,
  aux_sym_args_repeat1 = 234,
  aux_sym_tmp_eval_args_repeat1 = 235,
  aux_sym_tmp_eval_arg_repeat1 = 236,
  aux_sym__eq_sep_key_concatenation_repeat1 = 237,
  aux_sym__eq_sep_val_concatenation_repeat1 = 238,
  aux_sym_double_quoted_arg_repeat1 = 239,
  aux_sym_single_quoted_arg_repeat1 = 240,
  aux_sym_concatenation_repeat1 = 241,
  aux_sym_specifiers_repeat1 = 242,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_legacy_quoted_stmt_token1] = "legacy_quoted_stmt_token1",
  [anon_sym_TILDE] = "~",
  [sym_grep_specifier_identifier] = "grep_specifier_identifier",
  [aux_sym_grep_specifier_token1] = "grep_specifier_identifier",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPEH] = "|H",
  [anon_sym_AT_AT_DOT] = "@@.",
  [anon_sym_AT_AT_EQ] = "@@=",
  [anon_sym_AT_AT_AT_EQ] = "@@@=",
  [anon_sym_AT_AT] = "@@",
  [anon_sym_AT_ATc_COLON] = "@@c:",
  [anon_sym_AT_AT_ATc_COLON] = "@@@c:",
  [anon_sym_AT_ATC] = "@@C",
  [anon_sym_COLON] = ":",
  [anon_sym_AT_ATdbt] = "@@dbt",
  [anon_sym_AT_ATdbta] = "@@dbta",
  [anon_sym_AT_ATdbtb] = "@@dbtb",
  [anon_sym_AT_ATdbts] = "@@dbts",
  [anon_sym_AT_ATt] = "@@t",
  [anon_sym_AT_ATb] = "@@b",
  [anon_sym_AT_ATi] = "@@i",
  [anon_sym_AT_ATii] = "@@ii",
  [anon_sym_AT_ATiS] = "@@iS",
  [anon_sym_AT_ATiSS] = "@@iSS",
  [anon_sym_AT_ATis] = "@@is",
  [anon_sym_AT_ATiz] = "@@iz",
  [anon_sym_AT_ATf] = "@@f",
  [anon_sym_AT_ATF] = "@@F",
  [anon_sym_AT_ATom] = "@@om",
  [anon_sym_AT_ATdm] = "@@dm",
  [anon_sym_AT_ATr] = "@@r",
  [anon_sym_AT_ATs_COLON] = "@@s:",
  [anon_sym_AT] = "@ ",
  [anon_sym_AT_BANG] = "@!",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_ATa_COLON] = "@a:",
  [anon_sym_ATb_COLON] = "@b:",
  [anon_sym_ATB_COLON] = "@B:",
  [anon_sym_ATe_COLON] = "@e:",
  [anon_sym_ATF_COLON] = "@F:",
  [anon_sym_ATi_COLON] = "@i:",
  [anon_sym_ATk_COLON] = "@k:",
  [anon_sym_ATo_COLON] = "@o:",
  [anon_sym_ATr_COLON] = "@r:",
  [anon_sym_ATf_COLON] = "@f:",
  [anon_sym_ATs_COLON] = "@s:",
  [anon_sym_ATv_COLON] = "@v:",
  [anon_sym_ATx_COLON] = "@x:",
  [aux_sym__search_stmt_token1] = "cmd_identifier",
  [anon_sym_DOT] = ".",
  [aux_sym__interpret_stmt_token1] = "cmd_identifier",
  [aux_sym__interpret_stmt_token2] = "_interpret_stmt_token2",
  [aux_sym__interpret_stmt_token3] = "cmd_identifier",
  [aux_sym__interpret_stmt_token4] = "cmd_identifier",
  [anon_sym_PIPE_DOT] = "|.",
  [anon_sym_DOT_SLASH] = "./",
  [anon_sym_pfo] = "cmd_identifier",
  [anon_sym_Cf] = "cmd_identifier",
  [sym_pf_dot_cmd_identifier] = "cmd_identifier",
  [sym_pf_dot_full_cmd_identifier] = "cmd_identifier",
  [aux_sym_pf_cmd_token1] = "cmd_identifier",
  [anon_sym_EQ] = "=",
  [aux_sym__pf_dot_arg_identifier_token1] = "_pf_dot_arg_identifier_token1",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_LPAREN] = "(",
  [aux_sym_pf_arg_identifier_token1] = "pf_arg_identifier_token1",
  [anon_sym_PERCENT] = "%",
  [anon_sym_env] = "env",
  [anon_sym_DOT_DOT_DOT] = "...",
  [sym_system_identifier] = "system_identifier",
  [sym_question_mark_identifier] = "cmd_identifier",
  [sym_pointer_identifier] = "cmd_identifier",
  [sym_macro_identifier] = "cmd_identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [sym_html_redirect_operator] = "html_redirect_operator",
  [sym_html_append_operator] = "html_append_operator",
  [anon_sym_COMMA] = ",",
  [aux_sym_tmp_eval_arg_token1] = "tmp_eval_arg_token1",
  [sym__eq_sep_key_identifier] = "arg_identifier",
  [aux_sym_arg_identifier_token1] = "arg_identifier_token1",
  [aux_sym_spec_arg_identifier_token1] = "spec_arg_identifier_token1",
  [aux_sym_double_quoted_arg_token1] = "double_quoted_arg_token1",
  [aux_sym_double_quoted_arg_token2] = "double_quoted_arg_token2",
  [aux_sym_double_quoted_arg_token3] = "double_quoted_arg_token3",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_single_quoted_arg_token1] = "single_quoted_arg_token1",
  [aux_sym_single_quoted_arg_token2] = "single_quoted_arg_token2",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__dec_number_token1] = "_dec_number_token1",
  [aux_sym__dec_number_token2] = "_dec_number_token2",
  [sym__comment] = "_comment",
  [anon_sym_LF] = "\n",
  [anon_sym_CR] = "\r",
  [sym__cmd_identifier] = "_cmd_identifier",
  [sym__help_stmt] = "cmd_identifier",
  [sym_file_descriptor] = "file_descriptor",
  [sym__eq_sep_concat] = "_eq_sep_concat",
  [sym__concat] = "_concat",
  [sym__concat_pf_dot] = "_concat_pf_dot",
  [sym__spec_sep] = "_spec_sep",
  [sym_statements] = "statements",
  [sym__statements_singleline] = "_statements_singleline",
  [sym__statement] = "_statement",
  [sym_legacy_quoted_stmt] = "legacy_quoted_stmt",
  [sym__simple_stmt] = "_simple_stmt",
  [sym__tmp_stmt] = "_tmp_stmt",
  [sym__iter_stmt] = "_iter_stmt",
  [sym__pipe_stmt] = "_pipe_stmt",
  [sym_grep_stmt] = "grep_stmt",
  [sym_grep_specifier] = "grep_specifier",
  [sym_html_disable_stmt] = "html_disable_stmt",
  [sym_html_enable_stmt] = "html_enable_stmt",
  [sym_pipe_stmt] = "pipe_stmt",
  [sym_iter_file_lines_stmt] = "iter_file_lines_stmt",
  [sym_iter_offsets_stmt] = "iter_offsets_stmt",
  [sym_iter_offsetssizes_stmt] = "iter_offsetssizes_stmt",
  [sym_iter_hit_stmt] = "iter_hit_stmt",
  [sym_iter_interpret_stmt] = "iter_interpret_stmt",
  [sym_iter_interpret_offsetssizes_stmt] = "iter_interpret_offsetssizes_stmt",
  [sym_iter_comment_stmt] = "iter_comment_stmt",
  [sym_iter_dbta_stmt] = "iter_dbta_stmt",
  [sym_iter_dbtb_stmt] = "iter_dbtb_stmt",
  [sym_iter_dbts_stmt] = "iter_dbts_stmt",
  [sym_iter_threads_stmt] = "iter_threads_stmt",
  [sym_iter_bbs_stmt] = "iter_bbs_stmt",
  [sym_iter_instrs_stmt] = "iter_instrs_stmt",
  [sym_iter_import_stmt] = "iter_import_stmt",
  [sym_iter_sections_stmt] = "iter_sections_stmt",
  [sym_iter_segments_stmt] = "iter_segments_stmt",
  [sym_iter_symbol_stmt] = "iter_symbol_stmt",
  [sym_iter_string_stmt] = "iter_string_stmt",
  [sym_iter_flags_stmt] = "iter_flags_stmt",
  [sym_iter_function_stmt] = "iter_function_stmt",
  [sym_iter_iomap_stmt] = "iter_iomap_stmt",
  [sym_iter_dbgmap_stmt] = "iter_dbgmap_stmt",
  [sym_iter_register_stmt] = "iter_register_stmt",
  [sym_iter_step_stmt] = "iter_step_stmt",
  [sym_tmp_seek_stmt] = "tmp_seek_stmt",
  [sym_tmp_blksz_stmt] = "tmp_blksz_stmt",
  [sym_tmp_fromto_stmt] = "tmp_fromto_stmt",
  [sym_tmp_arch_stmt] = "tmp_arch_stmt",
  [sym_tmp_bits_stmt] = "tmp_bits_stmt",
  [sym_tmp_nthi_stmt] = "tmp_nthi_stmt",
  [sym_tmp_eval_stmt] = "tmp_eval_stmt",
  [sym_tmp_fs_stmt] = "tmp_fs_stmt",
  [sym_tmp_reli_stmt] = "tmp_reli_stmt",
  [sym_tmp_kuery_stmt] = "tmp_kuery_stmt",
  [sym_tmp_fd_stmt] = "tmp_fd_stmt",
  [sym_tmp_reg_stmt] = "tmp_reg_stmt",
  [sym_tmp_file_stmt] = "tmp_file_stmt",
  [sym_tmp_string_stmt] = "tmp_string_stmt",
  [sym_tmp_value_stmt] = "tmp_value_stmt",
  [sym_tmp_hex_stmt] = "tmp_hex_stmt",
  [sym_help_stmt] = "help_stmt",
  [sym_arged_stmt] = "arged_stmt",
  [sym__simple_arged_stmt_question] = "_simple_arged_stmt_question",
  [sym__simple_arged_stmt] = "_simple_arged_stmt",
  [sym__search_stmt] = "arged_stmt",
  [sym__math_arged_stmt] = "_math_arged_stmt",
  [sym__pointer_arged_stmt] = "_pointer_arged_stmt",
  [sym__macro_arged_stmt] = "_macro_arged_stmt",
  [sym__system_stmt] = "_system_stmt",
  [sym__interpret_stmt] = "_interpret_stmt",
  [sym__interpret_search_identifier] = "cmd_identifier",
  [sym__pf_arged_stmt] = "_pf_arged_stmt",
  [sym__pf_stmts] = "_pf_stmts",
  [sym_Cf_cmd] = "arged_stmt",
  [sym__Cf_args] = "args",
  [sym_pf_new_cmd] = "arged_stmt",
  [sym_pf_dot_cmd] = "arged_stmt",
  [sym_pf_cmd] = "arged_stmt",
  [sym_pf_new_args] = "pf_new_args",
  [sym_pf_dot_cmd_args] = "pf_dot_cmd_args",
  [sym__pf_dot_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg_parentheses] = "_pf_arg_parentheses",
  [sym_pf_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg] = "_pf_arg",
  [sym__pf_dot_arg] = "_pf_dot_arg",
  [sym_pf_concatenation] = "pf_concatenation",
  [sym_pf_dot_concatenation] = "pf_concatenation",
  [sym_pf_arg] = "pf_arg",
  [sym_pf_dot_arg] = "pf_arg",
  [sym_pf_args] = "pf_args",
  [sym_pf_dot_args] = "pf_args",
  [sym__env_stmt] = "_env_stmt",
  [sym__env_stmt_identifier] = "cmd_identifier",
  [sym__last_stmt] = "_last_stmt",
  [sym_last_stmt_identifier] = "cmd_identifier",
  [sym_repeat_stmt] = "repeat_stmt",
  [sym_eq_sep_args] = "args",
  [sym_macro_call_content] = "macro_call_content",
  [sym_macro_call_full_content] = "macro_call_full_content",
  [sym_macro_content] = "macro_content",
  [sym_macro_args] = "macro_args",
  [sym_redirect_stmt] = "redirect_stmt",
  [sym__redirect_operator] = "_redirect_operator",
  [sym_fdn_redirect_operator] = "fdn_redirect_operator",
  [sym_fdn_append_operator] = "fdn_append_operator",
  [sym__arg_with_paren] = "args",
  [sym__arg] = "_arg",
  [sym_arg] = "arg",
  [sym_args] = "args",
  [sym_tmp_eval_args] = "args",
  [sym_tmp_eval_arg] = "arg",
  [sym__eq_sep_key_single] = "_eq_sep_key_single",
  [sym__eq_sep_key_concatenation] = "concatenation",
  [sym__eq_sep_key] = "arg",
  [sym__eq_sep_val_concatenation] = "concatenation",
  [sym__eq_sep_val] = "arg",
  [sym_arg_identifier] = "arg_identifier",
  [sym_spec_arg_identifier] = "arg_identifier",
  [sym_double_quoted_arg] = "double_quoted_arg",
  [sym_single_quoted_arg] = "single_quoted_arg",
  [sym_cmd_substitution_arg] = "cmd_substitution_arg",
  [sym_concatenation] = "concatenation",
  [sym__dec_number] = "number",
  [sym_specifiers] = "specifiers",
  [sym_cmd_identifier] = "cmd_identifier",
  [aux_sym_statements_repeat1] = "statements_repeat1",
  [aux_sym_statements_repeat2] = "statements_repeat2",
  [aux_sym__statements_singleline_repeat1] = "_statements_singleline_repeat1",
  [aux_sym__statements_singleline_repeat2] = "_statements_singleline_repeat2",
  [aux_sym_grep_specifier_repeat1] = "grep_specifier_repeat1",
  [aux_sym_pf_concatenation_repeat1] = "pf_concatenation_repeat1",
  [aux_sym_pf_dot_concatenation_repeat1] = "pf_dot_concatenation_repeat1",
  [aux_sym_pf_args_repeat1] = "pf_args_repeat1",
  [aux_sym_pf_dot_args_repeat1] = "pf_dot_args_repeat1",
  [aux_sym_macro_content_repeat1] = "macro_content_repeat1",
  [aux_sym_args_repeat1] = "args_repeat1",
  [aux_sym_tmp_eval_args_repeat1] = "tmp_eval_args_repeat1",
  [aux_sym_tmp_eval_arg_repeat1] = "tmp_eval_arg_repeat1",
  [aux_sym__eq_sep_key_concatenation_repeat1] = "_eq_sep_key_concatenation_repeat1",
  [aux_sym__eq_sep_val_concatenation_repeat1] = "_eq_sep_val_concatenation_repeat1",
  [aux_sym_double_quoted_arg_repeat1] = "double_quoted_arg_repeat1",
  [aux_sym_single_quoted_arg_repeat1] = "single_quoted_arg_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_specifiers_repeat1] = "specifiers_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_legacy_quoted_stmt_token1] = aux_sym_legacy_quoted_stmt_token1,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_grep_specifier_identifier] = sym_grep_specifier_identifier,
  [aux_sym_grep_specifier_token1] = sym_grep_specifier_identifier,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PIPEH] = anon_sym_PIPEH,
  [anon_sym_AT_AT_DOT] = anon_sym_AT_AT_DOT,
  [anon_sym_AT_AT_EQ] = anon_sym_AT_AT_EQ,
  [anon_sym_AT_AT_AT_EQ] = anon_sym_AT_AT_AT_EQ,
  [anon_sym_AT_AT] = anon_sym_AT_AT,
  [anon_sym_AT_ATc_COLON] = anon_sym_AT_ATc_COLON,
  [anon_sym_AT_AT_ATc_COLON] = anon_sym_AT_AT_ATc_COLON,
  [anon_sym_AT_ATC] = anon_sym_AT_ATC,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT_ATdbt] = anon_sym_AT_ATdbt,
  [anon_sym_AT_ATdbta] = anon_sym_AT_ATdbta,
  [anon_sym_AT_ATdbtb] = anon_sym_AT_ATdbtb,
  [anon_sym_AT_ATdbts] = anon_sym_AT_ATdbts,
  [anon_sym_AT_ATt] = anon_sym_AT_ATt,
  [anon_sym_AT_ATb] = anon_sym_AT_ATb,
  [anon_sym_AT_ATi] = anon_sym_AT_ATi,
  [anon_sym_AT_ATii] = anon_sym_AT_ATii,
  [anon_sym_AT_ATiS] = anon_sym_AT_ATiS,
  [anon_sym_AT_ATiSS] = anon_sym_AT_ATiSS,
  [anon_sym_AT_ATis] = anon_sym_AT_ATis,
  [anon_sym_AT_ATiz] = anon_sym_AT_ATiz,
  [anon_sym_AT_ATf] = anon_sym_AT_ATf,
  [anon_sym_AT_ATF] = anon_sym_AT_ATF,
  [anon_sym_AT_ATom] = anon_sym_AT_ATom,
  [anon_sym_AT_ATdm] = anon_sym_AT_ATdm,
  [anon_sym_AT_ATr] = anon_sym_AT_ATr,
  [anon_sym_AT_ATs_COLON] = anon_sym_AT_ATs_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AT_BANG] = anon_sym_AT_BANG,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_ATa_COLON] = anon_sym_ATa_COLON,
  [anon_sym_ATb_COLON] = anon_sym_ATb_COLON,
  [anon_sym_ATB_COLON] = anon_sym_ATB_COLON,
  [anon_sym_ATe_COLON] = anon_sym_ATe_COLON,
  [anon_sym_ATF_COLON] = anon_sym_ATF_COLON,
  [anon_sym_ATi_COLON] = anon_sym_ATi_COLON,
  [anon_sym_ATk_COLON] = anon_sym_ATk_COLON,
  [anon_sym_ATo_COLON] = anon_sym_ATo_COLON,
  [anon_sym_ATr_COLON] = anon_sym_ATr_COLON,
  [anon_sym_ATf_COLON] = anon_sym_ATf_COLON,
  [anon_sym_ATs_COLON] = anon_sym_ATs_COLON,
  [anon_sym_ATv_COLON] = anon_sym_ATv_COLON,
  [anon_sym_ATx_COLON] = anon_sym_ATx_COLON,
  [aux_sym__search_stmt_token1] = sym_cmd_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym__interpret_stmt_token1] = sym_cmd_identifier,
  [aux_sym__interpret_stmt_token2] = aux_sym__interpret_stmt_token2,
  [aux_sym__interpret_stmt_token3] = sym_cmd_identifier,
  [aux_sym__interpret_stmt_token4] = sym_cmd_identifier,
  [anon_sym_PIPE_DOT] = anon_sym_PIPE_DOT,
  [anon_sym_DOT_SLASH] = anon_sym_DOT_SLASH,
  [anon_sym_pfo] = sym_cmd_identifier,
  [anon_sym_Cf] = sym_cmd_identifier,
  [sym_pf_dot_cmd_identifier] = sym_cmd_identifier,
  [sym_pf_dot_full_cmd_identifier] = sym_cmd_identifier,
  [aux_sym_pf_cmd_token1] = sym_cmd_identifier,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym__pf_dot_arg_identifier_token1] = aux_sym__pf_dot_arg_identifier_token1,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [aux_sym_pf_arg_identifier_token1] = aux_sym_pf_arg_identifier_token1,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_env] = anon_sym_env,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [sym_system_identifier] = sym_system_identifier,
  [sym_question_mark_identifier] = sym_cmd_identifier,
  [sym_pointer_identifier] = sym_cmd_identifier,
  [sym_macro_identifier] = sym_cmd_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [sym_html_redirect_operator] = sym_html_redirect_operator,
  [sym_html_append_operator] = sym_html_append_operator,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_tmp_eval_arg_token1] = aux_sym_tmp_eval_arg_token1,
  [sym__eq_sep_key_identifier] = sym_arg_identifier,
  [aux_sym_arg_identifier_token1] = aux_sym_arg_identifier_token1,
  [aux_sym_spec_arg_identifier_token1] = aux_sym_spec_arg_identifier_token1,
  [aux_sym_double_quoted_arg_token1] = aux_sym_double_quoted_arg_token1,
  [aux_sym_double_quoted_arg_token2] = aux_sym_double_quoted_arg_token2,
  [aux_sym_double_quoted_arg_token3] = aux_sym_double_quoted_arg_token3,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_single_quoted_arg_token1] = aux_sym_single_quoted_arg_token1,
  [aux_sym_single_quoted_arg_token2] = aux_sym_single_quoted_arg_token2,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__dec_number_token1] = aux_sym__dec_number_token1,
  [aux_sym__dec_number_token2] = aux_sym__dec_number_token2,
  [sym__comment] = sym__comment,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR] = anon_sym_CR,
  [sym__cmd_identifier] = sym__cmd_identifier,
  [sym__help_stmt] = sym_cmd_identifier,
  [sym_file_descriptor] = sym_file_descriptor,
  [sym__eq_sep_concat] = sym__eq_sep_concat,
  [sym__concat] = sym__concat,
  [sym__concat_pf_dot] = sym__concat_pf_dot,
  [sym__spec_sep] = sym__spec_sep,
  [sym_statements] = sym_statements,
  [sym__statements_singleline] = sym__statements_singleline,
  [sym__statement] = sym__statement,
  [sym_legacy_quoted_stmt] = sym_legacy_quoted_stmt,
  [sym__simple_stmt] = sym__simple_stmt,
  [sym__tmp_stmt] = sym__tmp_stmt,
  [sym__iter_stmt] = sym__iter_stmt,
  [sym__pipe_stmt] = sym__pipe_stmt,
  [sym_grep_stmt] = sym_grep_stmt,
  [sym_grep_specifier] = sym_grep_specifier,
  [sym_html_disable_stmt] = sym_html_disable_stmt,
  [sym_html_enable_stmt] = sym_html_enable_stmt,
  [sym_pipe_stmt] = sym_pipe_stmt,
  [sym_iter_file_lines_stmt] = sym_iter_file_lines_stmt,
  [sym_iter_offsets_stmt] = sym_iter_offsets_stmt,
  [sym_iter_offsetssizes_stmt] = sym_iter_offsetssizes_stmt,
  [sym_iter_hit_stmt] = sym_iter_hit_stmt,
  [sym_iter_interpret_stmt] = sym_iter_interpret_stmt,
  [sym_iter_interpret_offsetssizes_stmt] = sym_iter_interpret_offsetssizes_stmt,
  [sym_iter_comment_stmt] = sym_iter_comment_stmt,
  [sym_iter_dbta_stmt] = sym_iter_dbta_stmt,
  [sym_iter_dbtb_stmt] = sym_iter_dbtb_stmt,
  [sym_iter_dbts_stmt] = sym_iter_dbts_stmt,
  [sym_iter_threads_stmt] = sym_iter_threads_stmt,
  [sym_iter_bbs_stmt] = sym_iter_bbs_stmt,
  [sym_iter_instrs_stmt] = sym_iter_instrs_stmt,
  [sym_iter_import_stmt] = sym_iter_import_stmt,
  [sym_iter_sections_stmt] = sym_iter_sections_stmt,
  [sym_iter_segments_stmt] = sym_iter_segments_stmt,
  [sym_iter_symbol_stmt] = sym_iter_symbol_stmt,
  [sym_iter_string_stmt] = sym_iter_string_stmt,
  [sym_iter_flags_stmt] = sym_iter_flags_stmt,
  [sym_iter_function_stmt] = sym_iter_function_stmt,
  [sym_iter_iomap_stmt] = sym_iter_iomap_stmt,
  [sym_iter_dbgmap_stmt] = sym_iter_dbgmap_stmt,
  [sym_iter_register_stmt] = sym_iter_register_stmt,
  [sym_iter_step_stmt] = sym_iter_step_stmt,
  [sym_tmp_seek_stmt] = sym_tmp_seek_stmt,
  [sym_tmp_blksz_stmt] = sym_tmp_blksz_stmt,
  [sym_tmp_fromto_stmt] = sym_tmp_fromto_stmt,
  [sym_tmp_arch_stmt] = sym_tmp_arch_stmt,
  [sym_tmp_bits_stmt] = sym_tmp_bits_stmt,
  [sym_tmp_nthi_stmt] = sym_tmp_nthi_stmt,
  [sym_tmp_eval_stmt] = sym_tmp_eval_stmt,
  [sym_tmp_fs_stmt] = sym_tmp_fs_stmt,
  [sym_tmp_reli_stmt] = sym_tmp_reli_stmt,
  [sym_tmp_kuery_stmt] = sym_tmp_kuery_stmt,
  [sym_tmp_fd_stmt] = sym_tmp_fd_stmt,
  [sym_tmp_reg_stmt] = sym_tmp_reg_stmt,
  [sym_tmp_file_stmt] = sym_tmp_file_stmt,
  [sym_tmp_string_stmt] = sym_tmp_string_stmt,
  [sym_tmp_value_stmt] = sym_tmp_value_stmt,
  [sym_tmp_hex_stmt] = sym_tmp_hex_stmt,
  [sym_help_stmt] = sym_help_stmt,
  [sym_arged_stmt] = sym_arged_stmt,
  [sym__simple_arged_stmt_question] = sym__simple_arged_stmt_question,
  [sym__simple_arged_stmt] = sym__simple_arged_stmt,
  [sym__search_stmt] = sym_arged_stmt,
  [sym__math_arged_stmt] = sym__math_arged_stmt,
  [sym__pointer_arged_stmt] = sym__pointer_arged_stmt,
  [sym__macro_arged_stmt] = sym__macro_arged_stmt,
  [sym__system_stmt] = sym__system_stmt,
  [sym__interpret_stmt] = sym__interpret_stmt,
  [sym__interpret_search_identifier] = sym_cmd_identifier,
  [sym__pf_arged_stmt] = sym__pf_arged_stmt,
  [sym__pf_stmts] = sym__pf_stmts,
  [sym_Cf_cmd] = sym_arged_stmt,
  [sym__Cf_args] = sym_args,
  [sym_pf_new_cmd] = sym_arged_stmt,
  [sym_pf_dot_cmd] = sym_arged_stmt,
  [sym_pf_cmd] = sym_arged_stmt,
  [sym_pf_new_args] = sym_pf_new_args,
  [sym_pf_dot_cmd_args] = sym_pf_dot_cmd_args,
  [sym__pf_dot_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg_parentheses] = sym__pf_arg_parentheses,
  [sym_pf_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg] = sym__pf_arg,
  [sym__pf_dot_arg] = sym__pf_dot_arg,
  [sym_pf_concatenation] = sym_pf_concatenation,
  [sym_pf_dot_concatenation] = sym_pf_concatenation,
  [sym_pf_arg] = sym_pf_arg,
  [sym_pf_dot_arg] = sym_pf_arg,
  [sym_pf_args] = sym_pf_args,
  [sym_pf_dot_args] = sym_pf_args,
  [sym__env_stmt] = sym__env_stmt,
  [sym__env_stmt_identifier] = sym_cmd_identifier,
  [sym__last_stmt] = sym__last_stmt,
  [sym_last_stmt_identifier] = sym_cmd_identifier,
  [sym_repeat_stmt] = sym_repeat_stmt,
  [sym_eq_sep_args] = sym_args,
  [sym_macro_call_content] = sym_macro_call_content,
  [sym_macro_call_full_content] = sym_macro_call_full_content,
  [sym_macro_content] = sym_macro_content,
  [sym_macro_args] = sym_macro_args,
  [sym_redirect_stmt] = sym_redirect_stmt,
  [sym__redirect_operator] = sym__redirect_operator,
  [sym_fdn_redirect_operator] = sym_fdn_redirect_operator,
  [sym_fdn_append_operator] = sym_fdn_append_operator,
  [sym__arg_with_paren] = sym_args,
  [sym__arg] = sym__arg,
  [sym_arg] = sym_arg,
  [sym_args] = sym_args,
  [sym_tmp_eval_args] = sym_args,
  [sym_tmp_eval_arg] = sym_arg,
  [sym__eq_sep_key_single] = sym__eq_sep_key_single,
  [sym__eq_sep_key_concatenation] = sym_concatenation,
  [sym__eq_sep_key] = sym_arg,
  [sym__eq_sep_val_concatenation] = sym_concatenation,
  [sym__eq_sep_val] = sym_arg,
  [sym_arg_identifier] = sym_arg_identifier,
  [sym_spec_arg_identifier] = sym_arg_identifier,
  [sym_double_quoted_arg] = sym_double_quoted_arg,
  [sym_single_quoted_arg] = sym_single_quoted_arg,
  [sym_cmd_substitution_arg] = sym_cmd_substitution_arg,
  [sym_concatenation] = sym_concatenation,
  [sym__dec_number] = sym__dec_number,
  [sym_specifiers] = sym_specifiers,
  [sym_cmd_identifier] = sym_cmd_identifier,
  [aux_sym_statements_repeat1] = aux_sym_statements_repeat1,
  [aux_sym_statements_repeat2] = aux_sym_statements_repeat2,
  [aux_sym__statements_singleline_repeat1] = aux_sym__statements_singleline_repeat1,
  [aux_sym__statements_singleline_repeat2] = aux_sym__statements_singleline_repeat2,
  [aux_sym_grep_specifier_repeat1] = aux_sym_grep_specifier_repeat1,
  [aux_sym_pf_concatenation_repeat1] = aux_sym_pf_concatenation_repeat1,
  [aux_sym_pf_dot_concatenation_repeat1] = aux_sym_pf_dot_concatenation_repeat1,
  [aux_sym_pf_args_repeat1] = aux_sym_pf_args_repeat1,
  [aux_sym_pf_dot_args_repeat1] = aux_sym_pf_dot_args_repeat1,
  [aux_sym_macro_content_repeat1] = aux_sym_macro_content_repeat1,
  [aux_sym_args_repeat1] = aux_sym_args_repeat1,
  [aux_sym_tmp_eval_args_repeat1] = aux_sym_tmp_eval_args_repeat1,
  [aux_sym_tmp_eval_arg_repeat1] = aux_sym_tmp_eval_arg_repeat1,
  [aux_sym__eq_sep_key_concatenation_repeat1] = aux_sym__eq_sep_key_concatenation_repeat1,
  [aux_sym__eq_sep_val_concatenation_repeat1] = aux_sym__eq_sep_val_concatenation_repeat1,
  [aux_sym_double_quoted_arg_repeat1] = aux_sym_double_quoted_arg_repeat1,
  [aux_sym_single_quoted_arg_repeat1] = aux_sym_single_quoted_arg_repeat1,
  [aux_sym_concatenation_repeat1] = aux_sym_concatenation_repeat1,
  [aux_sym_specifiers_repeat1] = aux_sym_specifiers_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_legacy_quoted_stmt_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_grep_specifier_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_grep_specifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPEH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATC] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbtb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiSS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiz] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATa_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATb_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATB_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATe_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATF_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATi_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATk_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATo_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATr_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATf_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATv_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATx_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__search_stmt_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpret_stmt_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpret_stmt_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpret_stmt_token3] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpret_stmt_token4] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pfo] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_Cf] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_full_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pf_cmd_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__pf_dot_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pf_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_env] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_system_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_question_mark_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_html_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_html_append_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__eq_sep_key_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_spec_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__dec_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__dec_number_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__comment] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [sym__cmd_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__help_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat_pf_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__spec_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_statements] = {
    .visible = true,
    .named = true,
  },
  [sym__statements_singleline] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_legacy_quoted_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__tmp_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__iter_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_grep_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_grep_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_html_disable_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_html_enable_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_file_lines_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsets_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsetssizes_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_hit_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_offsetssizes_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_comment_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbta_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbtb_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbts_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_threads_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_bbs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_instrs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_import_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_sections_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_segments_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_symbol_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_string_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_flags_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_function_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_iomap_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbgmap_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_register_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_step_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_seek_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_blksz_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fromto_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_arch_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_bits_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_nthi_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reli_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_kuery_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fd_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reg_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_file_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_string_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_value_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_hex_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_help_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_arged_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_arged_stmt_question] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__search_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__math_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pointer_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__macro_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__system_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_search_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_stmts] = {
    .visible = false,
    .named = true,
  },
  [sym_Cf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym__Cf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_args] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_dot_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg_parentheses] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_dot_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_args] = {
    .visible = true,
    .named = true,
  },
  [sym__env_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__env_stmt_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__last_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_last_stmt_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_eq_sep_args] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_call_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_call_full_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_args] = {
    .visible = true,
    .named = true,
  },
  [sym_redirect_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__redirect_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_fdn_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_fdn_append_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_with_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_arg] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key_single] = {
    .visible = false,
    .named = true,
  },
  [sym__eq_sep_key_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val] = {
    .visible = true,
    .named = true,
  },
  [sym_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_spec_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_double_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_single_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_substitution_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__dec_number] = {
    .visible = true,
    .named = true,
  },
  [sym_specifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statements_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statements_singleline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statements_singleline_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_grep_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_key_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_val_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_arg = 1,
  field_args = 2,
  field_command = 3,
  field_extra = 4,
  field_id = 5,
  field_name = 6,
  field_redirect_operator = 7,
  field_specifier = 8,
  field_string = 9,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arg] = "arg",
  [field_args] = "args",
  [field_command] = "command",
  [field_extra] = "extra",
  [field_id] = "id",
  [field_name] = "name",
  [field_redirect_operator] = "redirect_operator",
  [field_specifier] = "specifier",
  [field_string] = "string",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 2},
  [8] = {.index = 7, .length = 2},
  [9] = {.index = 7, .length = 2},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 2},
  [14] = {.index = 14, .length = 2},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 3},
  [20] = {.index = 22, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_id, 0},
  [1] =
    {field_command, 0},
  [2] =
    {field_args, 0, .inherited = true},
    {field_command, 0, .inherited = true},
  [4] =
    {field_command, 0, .inherited = true},
  [5] =
    {field_extra, 1},
    {field_id, 0},
  [7] =
    {field_args, 1},
    {field_command, 0},
  [9] =
    {field_args, 0},
    {field_command, 1},
  [11] =
    {field_arg, 0},
    {field_command, 1},
  [13] =
    {field_string, 1},
  [14] =
    {field_args, 2},
    {field_command, 0},
  [16] =
    {field_name, 0},
  [17] =
    {field_command, 0},
    {field_specifier, 2},
  [19] =
    {field_arg, 2},
    {field_command, 0},
    {field_redirect_operator, 1},
  [22] =
    {field_args, 3, .inherited = true},
    {field_command, 3, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = sym_cmd_identifier,
  },
  [7] = {
    [0] = sym_arg_identifier,
  },
  [9] = {
    [0] = sym_cmd_identifier,
  },
  [13] = {
    [0] = sym_cmd_identifier,
  },
  [18] = {
    [0] = sym_arg_identifier,
    [2] = sym_arg_identifier,
  },
  [19] = {
    [0] = sym_pf_arg_identifier,
    [2] = sym_pf_arg_identifier,
  },
  [21] = {
    [1] = sym_pf_arg_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym_tmp_eval_arg_repeat1, 2,
    aux_sym_tmp_eval_arg_repeat1,
    sym_arg_identifier,
  0,
};

static inline bool sym_grep_specifier_identifier_character_set_1(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= '(' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : c <= '>')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '('
        ? c == '#'
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_3(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= '.' || (c < '`'
      ? (c < '='
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == '.'))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= '\'')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '#')))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_tmp_eval_arg_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '"'
      ? (c < '\n'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= '$' || (c < ','
        ? (c >= '\'' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < ','
        ? (c >= '(' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '\\'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '\\' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '='
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_4(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == ','))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ':'
    ? (c < '"'
      ? (c < '\n'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= '"' || (c < ','
        ? (c >= '\'' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '>'
        ? (c >= ':' && c <= ';')
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ':'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == ','))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(166);
      if (lookahead == '\'') ADVANCE(203);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == ',') ADVANCE(179);
      if (lookahead == '.') ADVANCE(134);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '=') ADVANCE(149);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '?') ADVANCE(170);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(181);
      if (lookahead == '\\') ADVANCE(202);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(0)
      if (lookahead != 0) ADVANCE(180);
      END_STATE();
    case 1:
      if (lookahead == ' ') ADVANCE(116);
      if (lookahead == '!') ADVANCE(117);
      if (lookahead == '(') ADVANCE(118);
      if (lookahead == '@') ADVANCE(93);
      if (lookahead == 'B') ADVANCE(17);
      if (lookahead == 'F') ADVANCE(18);
      if (lookahead == 'a') ADVANCE(19);
      if (lookahead == 'b') ADVANCE(20);
      if (lookahead == 'e') ADVANCE(21);
      if (lookahead == 'f') ADVANCE(22);
      if (lookahead == 'i') ADVANCE(23);
      if (lookahead == 'k') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(25);
      if (lookahead == 'r') ADVANCE(26);
      if (lookahead == 's') ADVANCE(27);
      if (lookahead == 'v') ADVANCE(28);
      if (lookahead == 'x') ADVANCE(29);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(15);
      if (lookahead == '%') ADVANCE(182);
      if (lookahead == '\'') ADVANCE(203);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(2)
      if (!sym__eq_sep_key_identifier_character_set_1(lookahead)) ADVANCE(186);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(196);
      if (lookahead == '$') ADVANCE(200);
      if (lookahead == '\\') ADVANCE(202);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(198);
      END_STATE();
    case 4:
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|') ADVANCE(82);
      END_STATE();
    case 5:
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(5)
      if (!aux_sym_spec_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(194);
      END_STATE();
    case 6:
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(156);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(6)
      if (!aux_sym_pf_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 7:
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(157);
      if (lookahead == '.') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(7)
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(153);
      END_STATE();
    case 8:
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(8)
      if (!aux_sym_tmp_eval_arg_token1_character_set_1(lookahead)) ADVANCE(180);
      END_STATE();
    case 9:
      if (lookahead == '#') ADVANCE(204);
      if (lookahead == '\'') ADVANCE(203);
      if (lookahead == '\\') ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(206);
      END_STATE();
    case 10:
      if (lookahead == '#') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(76);
      END_STATE();
    case 11:
      if (lookahead == '$') ADVANCE(191);
      if (lookahead == '{') ADVANCE(54);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(188);
      END_STATE();
    case 12:
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(152);
      if (lookahead == '{') ADVANCE(57);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(153);
      END_STATE();
    case 14:
      if (lookahead == '$') ADVANCE(193);
      if (lookahead == '{') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(194);
      END_STATE();
    case 15:
      if (lookahead == '(') ADVANCE(209);
      if (lookahead == '{') ADVANCE(56);
      if (lookahead != 0) ADVANCE(186);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(146);
      END_STATE();
    case 17:
      if (lookahead == ':') ADVANCE(122);
      END_STATE();
    case 18:
      if (lookahead == ':') ADVANCE(124);
      END_STATE();
    case 19:
      if (lookahead == ':') ADVANCE(120);
      END_STATE();
    case 20:
      if (lookahead == ':') ADVANCE(121);
      END_STATE();
    case 21:
      if (lookahead == ':') ADVANCE(123);
      END_STATE();
    case 22:
      if (lookahead == ':') ADVANCE(129);
      END_STATE();
    case 23:
      if (lookahead == ':') ADVANCE(125);
      END_STATE();
    case 24:
      if (lookahead == ':') ADVANCE(126);
      END_STATE();
    case 25:
      if (lookahead == ':') ADVANCE(127);
      END_STATE();
    case 26:
      if (lookahead == ':') ADVANCE(128);
      END_STATE();
    case 27:
      if (lookahead == ':') ADVANCE(130);
      END_STATE();
    case 28:
      if (lookahead == ':') ADVANCE(131);
      END_STATE();
    case 29:
      if (lookahead == ':') ADVANCE(132);
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(94);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(115);
      END_STATE();
    case 32:
      if (lookahead == ':') ADVANCE(95);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == 'c') ADVANCE(32);
      END_STATE();
    case 34:
      if (lookahead == '>') ADVANCE(177);
      END_STATE();
    case 35:
      if (lookahead == 'b') ADVANCE(40);
      if (lookahead == 'm') ADVANCE(113);
      END_STATE();
    case 36:
      if (lookahead == 'f') ADVANCE(144);
      END_STATE();
    case 37:
      if (lookahead == 'f') ADVANCE(147);
      END_STATE();
    case 38:
      if (lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(41);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 'v') ADVANCE(167);
      END_STATE();
    case 42:
      if (lookahead == '{') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(186);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(45);
      END_STATE();
    case 46:
      if (lookahead == '}') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '}') ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(47);
      END_STATE();
    case 48:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(189);
      END_STATE();
    case 49:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(165);
      END_STATE();
    case 50:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(154);
      END_STATE();
    case 51:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(195);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(212);
      END_STATE();
    case 53:
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(82);
      END_STATE();
    case 54:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(43);
      END_STATE();
    case 55:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(44);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(45);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(46);
      END_STATE();
    case 58:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(47);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 61:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(153);
      END_STATE();
    case 62:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(194);
      END_STATE();
    case 63:
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 64:
      if (eof) ADVANCE(73);
      if (lookahead == '\t') SKIP(64)
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == ' ') ADVANCE(138);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(34);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      END_STATE();
    case 65:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '!') ADVANCE(169);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '%') ADVANCE(166);
      if (lookahead == '(') ADVANCE(173);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == '0') ADVANCE(52);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '=') ADVANCE(149);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '?') ADVANCE(170);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'C') ADVANCE(36);
      if (lookahead == 'H') ADVANCE(34);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == 'e') ADVANCE(39);
      if (lookahead == 'p') ADVANCE(37);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(65)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(211);
      END_STATE();
    case 66:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(155);
      if (lookahead == '\'') ADVANCE(203);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ',') ADVANCE(179);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(187);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(66)
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 67:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(155);
      if (lookahead == '\'') ADVANCE(203);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ',') ADVANCE(179);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(67)
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 68:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(15);
      if (lookahead == '%') ADVANCE(182);
      if (lookahead == '\'') ADVANCE(203);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(183);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(68)
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ',' &&
          lookahead != '=' &&
          lookahead != '\\') ADVANCE(186);
      END_STATE();
    case 69:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(82);
      END_STATE();
    case 70:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(156);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(70)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(164);
      END_STATE();
    case 71:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == '$') ADVANCE(156);
      if (lookahead == '(') ADVANCE(160);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(71)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(164);
      END_STATE();
    case 72:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(216);
      if (lookahead == '\r') ADVANCE(217);
      if (lookahead == '#') ADVANCE(214);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ',') ADVANCE(179);
      if (lookahead == ';') ADVANCE(174);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(181);
      if (lookahead == '`') ADVANCE(210);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(72)
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '(' &&
          lookahead != '\\') ADVANCE(180);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_stmt_token1);
      if (lookahead == '#') ADVANCE(213);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_stmt_token1);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == 'H') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '>') ADVANCE(177);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_3(lookahead)) ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == ')' ||
          lookahead == '@') ADVANCE(82);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(82);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '\r' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          lookahead == '|') ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(82);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(85);
      if (lookahead == '(') ADVANCE(209);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '|') ADVANCE(82);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(85);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(82);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == 'H') ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PIPEH);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_AT_AT_DOT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_AT_AT_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_AT_AT_AT_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_AT_AT);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '@') ADVANCE(33);
      if (lookahead == 'C') ADVANCE(96);
      if (lookahead == 'F') ADVANCE(111);
      if (lookahead == 'b') ADVANCE(103);
      if (lookahead == 'c') ADVANCE(30);
      if (lookahead == 'd') ADVANCE(35);
      if (lookahead == 'f') ADVANCE(110);
      if (lookahead == 'i') ADVANCE(104);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(114);
      if (lookahead == 's') ADVANCE(31);
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_AT_ATc_COLON);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_AT_AT_ATc_COLON);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_AT_ATC);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_AT_ATdbt);
      if (lookahead == 'a') ADVANCE(99);
      if (lookahead == 'b') ADVANCE(100);
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AT_ATdbta);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AT_ATdbtb);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AT_ATdbts);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AT_ATt);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AT_ATb);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_AT_ATi);
      if (lookahead == 'S') ADVANCE(106);
      if (lookahead == 'i') ADVANCE(105);
      if (lookahead == 's') ADVANCE(108);
      if (lookahead == 'z') ADVANCE(109);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AT_ATii);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AT_ATiS);
      if (lookahead == 'S') ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AT_ATiSS);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AT_ATis);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_AT_ATiz);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AT_ATf);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AT_ATF);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AT_ATom);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AT_ATdm);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AT_ATr);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AT_ATs_COLON);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AT_BANG);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_ATa_COLON);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_ATb_COLON);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_ATB_COLON);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_ATe_COLON);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_ATF_COLON);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_ATi_COLON);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_ATk_COLON);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_ATo_COLON);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_ATr_COLON);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_ATf_COLON);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_ATs_COLON);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_ATv_COLON);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_ATx_COLON);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym__search_stmt_token1);
      if (lookahead == '!' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('/' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == ' ') ADVANCE(139);
      if (lookahead == '(') ADVANCE(140);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(137);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token1);
      if (lookahead == '(') ADVANCE(140);
      if (lookahead == '.') ADVANCE(168);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token1);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token2);
      if (lookahead == ' ') ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token3);
      if (lookahead == ' ') ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token4);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PIPE_DOT);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT_SLASH);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_pfo);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_Cf);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_pf_dot_cmd_identifier);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_pf_dot_full_cmd_identifier);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(145);
      if (lookahead == 'o') ADVANCE(143);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == '*' ||
          lookahead == 'c' ||
          lookahead == 'j' ||
          lookahead == 'q' ||
          lookahead == 's') ADVANCE(148);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(146);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(164);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(151);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '{') ADVANCE(154);
      if (lookahead == '.' ||
          lookahead == '=') ADVANCE(153);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(153);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(151);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '}') ADVANCE(153);
      if (aux_sym__pf_dot_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(191);
      if (lookahead == '(') ADVANCE(209);
      if (lookahead == '{') ADVANCE(54);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(188);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '(') ADVANCE(209);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(152);
      if (lookahead == '(') ADVANCE(209);
      if (lookahead == '{') ADVANCE(57);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(153);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(193);
      if (lookahead == '{') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(194);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(') ADVANCE(209);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '{') ADVANCE(165);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(164);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(164);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '>') ADVANCE(177);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead == '}') ADVANCE(164);
      if (lookahead == '\t' ||
          lookahead == '"' ||
          lookahead == '#' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          ('|' <= lookahead && lookahead <= '~')) ADVANCE(44);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(165);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_env);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(137);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_system_identifier);
      if (('!' <= lookahead && lookahead <= '=')) ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_question_mark_identifier);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_pointer_identifier);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_macro_identifier);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_macro_identifier);
      if (lookahead == '*' ||
          lookahead == '-') ADVANCE(172);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_html_redirect_operator);
      if (lookahead == '>') ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_html_append_operator);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      if (lookahead == '>') ADVANCE(177);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(42);
      if (lookahead == '%') ADVANCE(182);
      if (lookahead == '5') ADVANCE(184);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(186);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(42);
      if (lookahead == '%') ADVANCE(182);
      if (lookahead == '>') ADVANCE(177);
      if (!sym__eq_sep_key_identifier_character_set_3(lookahead)) ADVANCE(186);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(42);
      if (lookahead == '%') ADVANCE(182);
      if (lookahead == 'C') ADVANCE(185);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(186);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(42);
      if (lookahead == '%') ADVANCE(182);
      if (lookahead == 's') ADVANCE(186);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(42);
      if (lookahead == '%') ADVANCE(182);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(11);
      if (lookahead == '>') ADVANCE(177);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(48);
      if (lookahead == '}') ADVANCE(188);
      if (aux_sym_arg_identifier_token1_character_set_4(lookahead)) ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == ',') ADVANCE(188);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '{') ADVANCE(189);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(188);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(188);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == '{') ADVANCE(195);
      if (lookahead == ',' ||
          lookahead == ':') ADVANCE(194);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(194);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '\\') ADVANCE(62);
      if (!aux_sym_spec_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '\\') ADVANCE(62);
      if (!aux_sym_spec_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == '}') ADVANCE(194);
      if (aux_sym_spec_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(198);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(198);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      if (lookahead == '(') ADVANCE(209);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(199);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      if (lookahead == '\n' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '\\' ||
          lookahead == '`') ADVANCE(201);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(206);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      if (lookahead == '\n' ||
          lookahead == '\'' ||
          lookahead == '\\') ADVANCE(207);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym__dec_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(aux_sym__dec_number_token2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(212);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead == '"') ADVANCE(214);
      if (lookahead == '\\') ADVANCE(215);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(213);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(213);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_CR);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 65, .external_lex_state = 2},
  [2] = {.lex_state = 65, .external_lex_state = 3},
  [3] = {.lex_state = 65, .external_lex_state = 3},
  [4] = {.lex_state = 65, .external_lex_state = 2},
  [5] = {.lex_state = 65, .external_lex_state = 2},
  [6] = {.lex_state = 65, .external_lex_state = 2},
  [7] = {.lex_state = 65, .external_lex_state = 2},
  [8] = {.lex_state = 65, .external_lex_state = 2},
  [9] = {.lex_state = 65, .external_lex_state = 2},
  [10] = {.lex_state = 65, .external_lex_state = 2},
  [11] = {.lex_state = 65, .external_lex_state = 2},
  [12] = {.lex_state = 65, .external_lex_state = 2},
  [13] = {.lex_state = 65, .external_lex_state = 2},
  [14] = {.lex_state = 65, .external_lex_state = 2},
  [15] = {.lex_state = 65, .external_lex_state = 2},
  [16] = {.lex_state = 65, .external_lex_state = 2},
  [17] = {.lex_state = 65, .external_lex_state = 2},
  [18] = {.lex_state = 65, .external_lex_state = 2},
  [19] = {.lex_state = 65, .external_lex_state = 2},
  [20] = {.lex_state = 65, .external_lex_state = 2},
  [21] = {.lex_state = 65, .external_lex_state = 2},
  [22] = {.lex_state = 65, .external_lex_state = 2},
  [23] = {.lex_state = 65, .external_lex_state = 2},
  [24] = {.lex_state = 65, .external_lex_state = 2},
  [25] = {.lex_state = 65, .external_lex_state = 2},
  [26] = {.lex_state = 65, .external_lex_state = 2},
  [27] = {.lex_state = 65, .external_lex_state = 2},
  [28] = {.lex_state = 65, .external_lex_state = 2},
  [29] = {.lex_state = 65, .external_lex_state = 2},
  [30] = {.lex_state = 65, .external_lex_state = 2},
  [31] = {.lex_state = 65, .external_lex_state = 2},
  [32] = {.lex_state = 65, .external_lex_state = 2},
  [33] = {.lex_state = 65, .external_lex_state = 2},
  [34] = {.lex_state = 65, .external_lex_state = 2},
  [35] = {.lex_state = 65, .external_lex_state = 2},
  [36] = {.lex_state = 65, .external_lex_state = 2},
  [37] = {.lex_state = 65, .external_lex_state = 2},
  [38] = {.lex_state = 65, .external_lex_state = 2},
  [39] = {.lex_state = 65, .external_lex_state = 2},
  [40] = {.lex_state = 65, .external_lex_state = 2},
  [41] = {.lex_state = 65, .external_lex_state = 2},
  [42] = {.lex_state = 65, .external_lex_state = 2},
  [43] = {.lex_state = 66, .external_lex_state = 4},
  [44] = {.lex_state = 66, .external_lex_state = 4},
  [45] = {.lex_state = 66, .external_lex_state = 4},
  [46] = {.lex_state = 66, .external_lex_state = 4},
  [47] = {.lex_state = 66, .external_lex_state = 4},
  [48] = {.lex_state = 66, .external_lex_state = 4},
  [49] = {.lex_state = 66, .external_lex_state = 4},
  [50] = {.lex_state = 66, .external_lex_state = 4},
  [51] = {.lex_state = 66, .external_lex_state = 4},
  [52] = {.lex_state = 66, .external_lex_state = 4},
  [53] = {.lex_state = 66, .external_lex_state = 4},
  [54] = {.lex_state = 66, .external_lex_state = 4},
  [55] = {.lex_state = 66, .external_lex_state = 4},
  [56] = {.lex_state = 66, .external_lex_state = 4},
  [57] = {.lex_state = 70, .external_lex_state = 5},
  [58] = {.lex_state = 66, .external_lex_state = 4},
  [59] = {.lex_state = 66, .external_lex_state = 4},
  [60] = {.lex_state = 66, .external_lex_state = 4},
  [61] = {.lex_state = 66, .external_lex_state = 4},
  [62] = {.lex_state = 66, .external_lex_state = 4},
  [63] = {.lex_state = 66, .external_lex_state = 4},
  [64] = {.lex_state = 66, .external_lex_state = 4},
  [65] = {.lex_state = 66, .external_lex_state = 4},
  [66] = {.lex_state = 66, .external_lex_state = 4},
  [67] = {.lex_state = 66, .external_lex_state = 4},
  [68] = {.lex_state = 66, .external_lex_state = 4},
  [69] = {.lex_state = 66, .external_lex_state = 4},
  [70] = {.lex_state = 66, .external_lex_state = 4},
  [71] = {.lex_state = 70, .external_lex_state = 5},
  [72] = {.lex_state = 68, .external_lex_state = 4},
  [73] = {.lex_state = 71, .external_lex_state = 4},
  [74] = {.lex_state = 71, .external_lex_state = 4},
  [75] = {.lex_state = 66, .external_lex_state = 6},
  [76] = {.lex_state = 66, .external_lex_state = 6},
  [77] = {.lex_state = 66, .external_lex_state = 6},
  [78] = {.lex_state = 66, .external_lex_state = 7},
  [79] = {.lex_state = 66, .external_lex_state = 7},
  [80] = {.lex_state = 66, .external_lex_state = 7},
  [81] = {.lex_state = 66, .external_lex_state = 7},
  [82] = {.lex_state = 66, .external_lex_state = 7},
  [83] = {.lex_state = 66, .external_lex_state = 7},
  [84] = {.lex_state = 66, .external_lex_state = 7},
  [85] = {.lex_state = 66, .external_lex_state = 7},
  [86] = {.lex_state = 66, .external_lex_state = 7},
  [87] = {.lex_state = 66, .external_lex_state = 7},
  [88] = {.lex_state = 66, .external_lex_state = 7},
  [89] = {.lex_state = 66, .external_lex_state = 7},
  [90] = {.lex_state = 66, .external_lex_state = 6},
  [91] = {.lex_state = 66, .external_lex_state = 7},
  [92] = {.lex_state = 66, .external_lex_state = 6},
  [93] = {.lex_state = 68, .external_lex_state = 4},
  [94] = {.lex_state = 70, .external_lex_state = 5},
  [95] = {.lex_state = 66, .external_lex_state = 4},
  [96] = {.lex_state = 70, .external_lex_state = 5},
  [97] = {.lex_state = 71, .external_lex_state = 4},
  [98] = {.lex_state = 66, .external_lex_state = 4},
  [99] = {.lex_state = 70, .external_lex_state = 5},
  [100] = {.lex_state = 70, .external_lex_state = 5},
  [101] = {.lex_state = 70, .external_lex_state = 5},
  [102] = {.lex_state = 71, .external_lex_state = 7},
  [103] = {.lex_state = 70, .external_lex_state = 5},
  [104] = {.lex_state = 70, .external_lex_state = 5},
  [105] = {.lex_state = 70, .external_lex_state = 5},
  [106] = {.lex_state = 71, .external_lex_state = 7},
  [107] = {.lex_state = 71, .external_lex_state = 7},
  [108] = {.lex_state = 71, .external_lex_state = 7},
  [109] = {.lex_state = 71, .external_lex_state = 7},
  [110] = {.lex_state = 71, .external_lex_state = 7},
  [111] = {.lex_state = 71, .external_lex_state = 7},
  [112] = {.lex_state = 71, .external_lex_state = 7},
  [113] = {.lex_state = 69, .external_lex_state = 4},
  [114] = {.lex_state = 68, .external_lex_state = 4},
  [115] = {.lex_state = 71, .external_lex_state = 4},
  [116] = {.lex_state = 69, .external_lex_state = 4},
  [117] = {.lex_state = 65, .external_lex_state = 5},
  [118] = {.lex_state = 0, .external_lex_state = 8},
  [119] = {.lex_state = 72, .external_lex_state = 4},
  [120] = {.lex_state = 0, .external_lex_state = 8},
  [121] = {.lex_state = 65, .external_lex_state = 5},
  [122] = {.lex_state = 0, .external_lex_state = 8},
  [123] = {.lex_state = 65, .external_lex_state = 5},
  [124] = {.lex_state = 0, .external_lex_state = 8},
  [125] = {.lex_state = 65, .external_lex_state = 5},
  [126] = {.lex_state = 65, .external_lex_state = 9},
  [127] = {.lex_state = 65, .external_lex_state = 9},
  [128] = {.lex_state = 65, .external_lex_state = 5},
  [129] = {.lex_state = 72, .external_lex_state = 4},
  [130] = {.lex_state = 65, .external_lex_state = 5},
  [131] = {.lex_state = 65, .external_lex_state = 9},
  [132] = {.lex_state = 0, .external_lex_state = 4},
  [133] = {.lex_state = 0, .external_lex_state = 8},
  [134] = {.lex_state = 69, .external_lex_state = 4},
  [135] = {.lex_state = 0, .external_lex_state = 4},
  [136] = {.lex_state = 0, .external_lex_state = 8},
  [137] = {.lex_state = 0, .external_lex_state = 8},
  [138] = {.lex_state = 0, .external_lex_state = 9},
  [139] = {.lex_state = 65, .external_lex_state = 9},
  [140] = {.lex_state = 0, .external_lex_state = 4},
  [141] = {.lex_state = 65, .external_lex_state = 5},
  [142] = {.lex_state = 69, .external_lex_state = 4},
  [143] = {.lex_state = 0, .external_lex_state = 4},
  [144] = {.lex_state = 69, .external_lex_state = 4},
  [145] = {.lex_state = 0, .external_lex_state = 8},
  [146] = {.lex_state = 65, .external_lex_state = 5},
  [147] = {.lex_state = 72, .external_lex_state = 4},
  [148] = {.lex_state = 0, .external_lex_state = 8},
  [149] = {.lex_state = 65, .external_lex_state = 9},
  [150] = {.lex_state = 0, .external_lex_state = 8},
  [151] = {.lex_state = 69, .external_lex_state = 4},
  [152] = {.lex_state = 0, .external_lex_state = 8},
  [153] = {.lex_state = 65, .external_lex_state = 9},
  [154] = {.lex_state = 65, .external_lex_state = 5},
  [155] = {.lex_state = 65, .external_lex_state = 9},
  [156] = {.lex_state = 0, .external_lex_state = 8},
  [157] = {.lex_state = 0, .external_lex_state = 9},
  [158] = {.lex_state = 65, .external_lex_state = 9},
  [159] = {.lex_state = 65, .external_lex_state = 9},
  [160] = {.lex_state = 65, .external_lex_state = 9},
  [161] = {.lex_state = 0, .external_lex_state = 8},
  [162] = {.lex_state = 0, .external_lex_state = 8},
  [163] = {.lex_state = 65, .external_lex_state = 5},
  [164] = {.lex_state = 65, .external_lex_state = 5},
  [165] = {.lex_state = 65, .external_lex_state = 5},
  [166] = {.lex_state = 65, .external_lex_state = 4},
  [167] = {.lex_state = 69, .external_lex_state = 4},
  [168] = {.lex_state = 65, .external_lex_state = 4},
  [169] = {.lex_state = 65, .external_lex_state = 4},
  [170] = {.lex_state = 0, .external_lex_state = 4},
  [171] = {.lex_state = 0, .external_lex_state = 4},
  [172] = {.lex_state = 0, .external_lex_state = 4},
  [173] = {.lex_state = 65, .external_lex_state = 4},
  [174] = {.lex_state = 0, .external_lex_state = 4},
  [175] = {.lex_state = 65, .external_lex_state = 4},
  [176] = {.lex_state = 0, .external_lex_state = 9},
  [177] = {.lex_state = 0, .external_lex_state = 4},
  [178] = {.lex_state = 0, .external_lex_state = 4},
  [179] = {.lex_state = 0, .external_lex_state = 4},
  [180] = {.lex_state = 0, .external_lex_state = 9},
  [181] = {.lex_state = 0, .external_lex_state = 4},
  [182] = {.lex_state = 0, .external_lex_state = 4},
  [183] = {.lex_state = 69, .external_lex_state = 4},
  [184] = {.lex_state = 64, .external_lex_state = 4},
  [185] = {.lex_state = 69, .external_lex_state = 4},
  [186] = {.lex_state = 0, .external_lex_state = 4},
  [187] = {.lex_state = 0, .external_lex_state = 4},
  [188] = {.lex_state = 0, .external_lex_state = 4},
  [189] = {.lex_state = 0, .external_lex_state = 4},
  [190] = {.lex_state = 0, .external_lex_state = 4},
  [191] = {.lex_state = 0, .external_lex_state = 4},
  [192] = {.lex_state = 65, .external_lex_state = 4},
  [193] = {.lex_state = 0, .external_lex_state = 4},
  [194] = {.lex_state = 0, .external_lex_state = 4},
  [195] = {.lex_state = 0, .external_lex_state = 4},
  [196] = {.lex_state = 0, .external_lex_state = 4},
  [197] = {.lex_state = 0, .external_lex_state = 4},
  [198] = {.lex_state = 0, .external_lex_state = 4},
  [199] = {.lex_state = 0, .external_lex_state = 4},
  [200] = {.lex_state = 0, .external_lex_state = 4},
  [201] = {.lex_state = 0, .external_lex_state = 5},
  [202] = {.lex_state = 0, .external_lex_state = 4},
  [203] = {.lex_state = 0, .external_lex_state = 4},
  [204] = {.lex_state = 0, .external_lex_state = 4},
  [205] = {.lex_state = 0, .external_lex_state = 4},
  [206] = {.lex_state = 0, .external_lex_state = 4},
  [207] = {.lex_state = 0, .external_lex_state = 4},
  [208] = {.lex_state = 0, .external_lex_state = 4},
  [209] = {.lex_state = 0, .external_lex_state = 4},
  [210] = {.lex_state = 0, .external_lex_state = 4},
  [211] = {.lex_state = 0, .external_lex_state = 4},
  [212] = {.lex_state = 0, .external_lex_state = 4},
  [213] = {.lex_state = 0, .external_lex_state = 4},
  [214] = {.lex_state = 0, .external_lex_state = 4},
  [215] = {.lex_state = 0, .external_lex_state = 4},
  [216] = {.lex_state = 0, .external_lex_state = 4},
  [217] = {.lex_state = 0, .external_lex_state = 4},
  [218] = {.lex_state = 0, .external_lex_state = 4},
  [219] = {.lex_state = 0, .external_lex_state = 4},
  [220] = {.lex_state = 0, .external_lex_state = 4},
  [221] = {.lex_state = 0, .external_lex_state = 4},
  [222] = {.lex_state = 0, .external_lex_state = 4},
  [223] = {.lex_state = 0, .external_lex_state = 4},
  [224] = {.lex_state = 0, .external_lex_state = 4},
  [225] = {.lex_state = 0, .external_lex_state = 4},
  [226] = {.lex_state = 0, .external_lex_state = 4},
  [227] = {.lex_state = 0, .external_lex_state = 4},
  [228] = {.lex_state = 0, .external_lex_state = 4},
  [229] = {.lex_state = 0, .external_lex_state = 4},
  [230] = {.lex_state = 0, .external_lex_state = 4},
  [231] = {.lex_state = 0, .external_lex_state = 4},
  [232] = {.lex_state = 0, .external_lex_state = 4},
  [233] = {.lex_state = 0, .external_lex_state = 4},
  [234] = {.lex_state = 0, .external_lex_state = 4},
  [235] = {.lex_state = 0, .external_lex_state = 4},
  [236] = {.lex_state = 0, .external_lex_state = 4},
  [237] = {.lex_state = 0, .external_lex_state = 4},
  [238] = {.lex_state = 0, .external_lex_state = 4},
  [239] = {.lex_state = 0, .external_lex_state = 4},
  [240] = {.lex_state = 0, .external_lex_state = 4},
  [241] = {.lex_state = 0, .external_lex_state = 4},
  [242] = {.lex_state = 0, .external_lex_state = 4},
  [243] = {.lex_state = 0, .external_lex_state = 4},
  [244] = {.lex_state = 0, .external_lex_state = 4},
  [245] = {.lex_state = 0, .external_lex_state = 4},
  [246] = {.lex_state = 0, .external_lex_state = 4},
  [247] = {.lex_state = 0, .external_lex_state = 4},
  [248] = {.lex_state = 0, .external_lex_state = 4},
  [249] = {.lex_state = 0, .external_lex_state = 4},
  [250] = {.lex_state = 0, .external_lex_state = 4},
  [251] = {.lex_state = 0, .external_lex_state = 4},
  [252] = {.lex_state = 0, .external_lex_state = 4},
  [253] = {.lex_state = 0, .external_lex_state = 4},
  [254] = {.lex_state = 0, .external_lex_state = 4},
  [255] = {.lex_state = 0, .external_lex_state = 4},
  [256] = {.lex_state = 0, .external_lex_state = 4},
  [257] = {.lex_state = 0, .external_lex_state = 4},
  [258] = {.lex_state = 0, .external_lex_state = 4},
  [259] = {.lex_state = 0, .external_lex_state = 4},
  [260] = {.lex_state = 0, .external_lex_state = 4},
  [261] = {.lex_state = 0, .external_lex_state = 4},
  [262] = {.lex_state = 0, .external_lex_state = 4},
  [263] = {.lex_state = 0, .external_lex_state = 4},
  [264] = {.lex_state = 0, .external_lex_state = 4},
  [265] = {.lex_state = 0, .external_lex_state = 4},
  [266] = {.lex_state = 0, .external_lex_state = 4},
  [267] = {.lex_state = 0, .external_lex_state = 4},
  [268] = {.lex_state = 0, .external_lex_state = 4},
  [269] = {.lex_state = 0, .external_lex_state = 4},
  [270] = {.lex_state = 0, .external_lex_state = 4},
  [271] = {.lex_state = 0, .external_lex_state = 4},
  [272] = {.lex_state = 0, .external_lex_state = 4},
  [273] = {.lex_state = 64, .external_lex_state = 4},
  [274] = {.lex_state = 65, .external_lex_state = 4},
  [275] = {.lex_state = 0, .external_lex_state = 5},
  [276] = {.lex_state = 0, .external_lex_state = 4},
  [277] = {.lex_state = 0, .external_lex_state = 4},
  [278] = {.lex_state = 65, .external_lex_state = 2},
  [279] = {.lex_state = 65, .external_lex_state = 2},
  [280] = {.lex_state = 65, .external_lex_state = 2},
  [281] = {.lex_state = 67},
  [282] = {.lex_state = 67},
  [283] = {.lex_state = 67},
  [284] = {.lex_state = 67},
  [285] = {.lex_state = 67},
  [286] = {.lex_state = 67},
  [287] = {.lex_state = 67},
  [288] = {.lex_state = 67},
  [289] = {.lex_state = 67},
  [290] = {.lex_state = 67},
  [291] = {.lex_state = 67},
  [292] = {.lex_state = 67},
  [293] = {.lex_state = 67},
  [294] = {.lex_state = 67},
  [295] = {.lex_state = 67},
  [296] = {.lex_state = 67},
  [297] = {.lex_state = 67},
  [298] = {.lex_state = 67},
  [299] = {.lex_state = 67},
  [300] = {.lex_state = 67},
  [301] = {.lex_state = 67},
  [302] = {.lex_state = 67},
  [303] = {.lex_state = 67},
  [304] = {.lex_state = 67},
  [305] = {.lex_state = 67},
  [306] = {.lex_state = 67},
  [307] = {.lex_state = 67},
  [308] = {.lex_state = 67},
  [309] = {.lex_state = 67},
  [310] = {.lex_state = 67},
  [311] = {.lex_state = 67},
  [312] = {.lex_state = 67},
  [313] = {.lex_state = 67},
  [314] = {.lex_state = 67},
  [315] = {.lex_state = 67},
  [316] = {.lex_state = 67},
  [317] = {.lex_state = 67},
  [318] = {.lex_state = 67},
  [319] = {.lex_state = 67},
  [320] = {.lex_state = 67},
  [321] = {.lex_state = 67},
  [322] = {.lex_state = 67},
  [323] = {.lex_state = 67},
  [324] = {.lex_state = 67, .external_lex_state = 10},
  [325] = {.lex_state = 67, .external_lex_state = 10},
  [326] = {.lex_state = 67, .external_lex_state = 10},
  [327] = {.lex_state = 67, .external_lex_state = 10},
  [328] = {.lex_state = 67, .external_lex_state = 10},
  [329] = {.lex_state = 67},
  [330] = {.lex_state = 67, .external_lex_state = 10},
  [331] = {.lex_state = 67, .external_lex_state = 10},
  [332] = {.lex_state = 67, .external_lex_state = 10},
  [333] = {.lex_state = 67, .external_lex_state = 10},
  [334] = {.lex_state = 67, .external_lex_state = 10},
  [335] = {.lex_state = 67},
  [336] = {.lex_state = 67, .external_lex_state = 10},
  [337] = {.lex_state = 67, .external_lex_state = 10},
  [338] = {.lex_state = 67},
  [339] = {.lex_state = 67, .external_lex_state = 10},
  [340] = {.lex_state = 67},
  [341] = {.lex_state = 67},
  [342] = {.lex_state = 6},
  [343] = {.lex_state = 6},
  [344] = {.lex_state = 6},
  [345] = {.lex_state = 6},
  [346] = {.lex_state = 6},
  [347] = {.lex_state = 67},
  [348] = {.lex_state = 6},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 6},
  [351] = {.lex_state = 6},
  [352] = {.lex_state = 6},
  [353] = {.lex_state = 7},
  [354] = {.lex_state = 7},
  [355] = {.lex_state = 2},
  [356] = {.lex_state = 7},
  [357] = {.lex_state = 7},
  [358] = {.lex_state = 6},
  [359] = {.lex_state = 2},
  [360] = {.lex_state = 6},
  [361] = {.lex_state = 7},
  [362] = {.lex_state = 3},
  [363] = {.lex_state = 67},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 6, .external_lex_state = 10},
  [370] = {.lex_state = 6, .external_lex_state = 10},
  [371] = {.lex_state = 67},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 3},
  [375] = {.lex_state = 3},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 67},
  [378] = {.lex_state = 67},
  [379] = {.lex_state = 67},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 6, .external_lex_state = 10},
  [382] = {.lex_state = 3},
  [383] = {.lex_state = 6, .external_lex_state = 10},
  [384] = {.lex_state = 6, .external_lex_state = 10},
  [385] = {.lex_state = 6, .external_lex_state = 10},
  [386] = {.lex_state = 6, .external_lex_state = 10},
  [387] = {.lex_state = 6, .external_lex_state = 10},
  [388] = {.lex_state = 7},
  [389] = {.lex_state = 6, .external_lex_state = 10},
  [390] = {.lex_state = 6, .external_lex_state = 10},
  [391] = {.lex_state = 4},
  [392] = {.lex_state = 6, .external_lex_state = 10},
  [393] = {.lex_state = 4},
  [394] = {.lex_state = 7},
  [395] = {.lex_state = 4},
  [396] = {.lex_state = 6, .external_lex_state = 10},
  [397] = {.lex_state = 6, .external_lex_state = 10},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6, .external_lex_state = 10},
  [401] = {.lex_state = 6, .external_lex_state = 10},
  [402] = {.lex_state = 3},
  [403] = {.lex_state = 6, .external_lex_state = 10},
  [404] = {.lex_state = 3},
  [405] = {.lex_state = 6, .external_lex_state = 10},
  [406] = {.lex_state = 6, .external_lex_state = 10},
  [407] = {.lex_state = 6, .external_lex_state = 10},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 9},
  [415] = {.lex_state = 9},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 9},
  [418] = {.lex_state = 9},
  [419] = {.lex_state = 9},
  [420] = {.lex_state = 9},
  [421] = {.lex_state = 9},
  [422] = {.lex_state = 9},
  [423] = {.lex_state = 9},
  [424] = {.lex_state = 9},
  [425] = {.lex_state = 8},
  [426] = {.lex_state = 9},
  [427] = {.lex_state = 9},
  [428] = {.lex_state = 9},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0, .external_lex_state = 11},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0, .external_lex_state = 11},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 5},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 8},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0, .external_lex_state = 12},
  [450] = {.lex_state = 0, .external_lex_state = 11},
  [451] = {.lex_state = 65},
  [452] = {.lex_state = 0, .external_lex_state = 11},
  [453] = {.lex_state = 0, .external_lex_state = 11},
  [454] = {.lex_state = 0, .external_lex_state = 11},
  [455] = {.lex_state = 65},
  [456] = {.lex_state = 0, .external_lex_state = 11},
  [457] = {.lex_state = 0, .external_lex_state = 11},
  [458] = {.lex_state = 0},
  [459] = {.lex_state = 0, .external_lex_state = 11},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 0, .external_lex_state = 11},
  [462] = {.lex_state = 0, .external_lex_state = 11},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0, .external_lex_state = 11},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 0, .external_lex_state = 12},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 0, .external_lex_state = 10},
  [481] = {.lex_state = 0, .external_lex_state = 13},
  [482] = {.lex_state = 0, .external_lex_state = 10},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0},
  [486] = {.lex_state = 0},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 10},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 7},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 0},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 0},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0, .external_lex_state = 13},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 0, .external_lex_state = 10},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 0, .external_lex_state = 13},
};

enum {
  ts_external_token__cmd_identifier = 0,
  ts_external_token__help_stmt = 1,
  ts_external_token_file_descriptor = 2,
  ts_external_token__eq_sep_concat = 3,
  ts_external_token__concat = 4,
  ts_external_token__concat_pf_dot = 5,
  ts_external_token__spec_sep = 6,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__cmd_identifier] = sym__cmd_identifier,
  [ts_external_token__help_stmt] = sym__help_stmt,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__eq_sep_concat] = sym__eq_sep_concat,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token__concat_pf_dot] = sym__concat_pf_dot,
  [ts_external_token__spec_sep] = sym__spec_sep,
};

static const bool ts_external_scanner_states[14][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
    [ts_external_token__concat_pf_dot] = true,
    [ts_external_token__spec_sep] = true,
  },
  [2] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
  },
  [3] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [4] = {
    [ts_external_token_file_descriptor] = true,
  },
  [5] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat_pf_dot] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__spec_sep] = true,
  },
  [7] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [9] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token__eq_sep_concat] = true,
  },
  [13] = {
    [ts_external_token__concat_pf_dot] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PIPEH] = ACTIONS(1),
    [anon_sym_AT_AT_DOT] = ACTIONS(1),
    [anon_sym_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT] = ACTIONS(1),
    [anon_sym_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_ATC] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT_ATdbt] = ACTIONS(1),
    [anon_sym_AT_ATdbta] = ACTIONS(1),
    [anon_sym_AT_ATdbtb] = ACTIONS(1),
    [anon_sym_AT_ATdbts] = ACTIONS(1),
    [anon_sym_AT_ATt] = ACTIONS(1),
    [anon_sym_AT_ATb] = ACTIONS(1),
    [anon_sym_AT_ATi] = ACTIONS(1),
    [anon_sym_AT_ATii] = ACTIONS(1),
    [anon_sym_AT_ATiS] = ACTIONS(1),
    [anon_sym_AT_ATiSS] = ACTIONS(1),
    [anon_sym_AT_ATis] = ACTIONS(1),
    [anon_sym_AT_ATiz] = ACTIONS(1),
    [anon_sym_AT_ATf] = ACTIONS(1),
    [anon_sym_AT_ATF] = ACTIONS(1),
    [anon_sym_AT_ATom] = ACTIONS(1),
    [anon_sym_AT_ATdm] = ACTIONS(1),
    [anon_sym_AT_ATr] = ACTIONS(1),
    [anon_sym_AT_ATs_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AT_BANG] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_ATa_COLON] = ACTIONS(1),
    [anon_sym_ATb_COLON] = ACTIONS(1),
    [anon_sym_ATB_COLON] = ACTIONS(1),
    [anon_sym_ATe_COLON] = ACTIONS(1),
    [anon_sym_ATF_COLON] = ACTIONS(1),
    [anon_sym_ATi_COLON] = ACTIONS(1),
    [anon_sym_ATk_COLON] = ACTIONS(1),
    [anon_sym_ATo_COLON] = ACTIONS(1),
    [anon_sym_ATr_COLON] = ACTIONS(1),
    [anon_sym_ATf_COLON] = ACTIONS(1),
    [anon_sym_ATs_COLON] = ACTIONS(1),
    [anon_sym_ATv_COLON] = ACTIONS(1),
    [anon_sym_ATx_COLON] = ACTIONS(1),
    [aux_sym__search_stmt_token1] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_PIPE_DOT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [sym_question_mark_identifier] = ACTIONS(1),
    [sym_pointer_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [sym_html_redirect_operator] = ACTIONS(1),
    [sym_html_append_operator] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_tmp_eval_arg_token1] = ACTIONS(1),
    [aux_sym_double_quoted_arg_token3] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_CR] = ACTIONS(1),
    [sym__cmd_identifier] = ACTIONS(1),
    [sym__help_stmt] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__eq_sep_concat] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym__concat_pf_dot] = ACTIONS(1),
    [sym__spec_sep] = ACTIONS(1),
  },
  [1] = {
    [sym_statements] = STATE(496),
    [sym__statement] = STATE(410),
    [sym_legacy_quoted_stmt] = STATE(179),
    [sym__simple_stmt] = STATE(179),
    [sym__tmp_stmt] = STATE(179),
    [sym__iter_stmt] = STATE(179),
    [sym__pipe_stmt] = STATE(179),
    [sym_grep_stmt] = STATE(179),
    [sym_html_disable_stmt] = STATE(179),
    [sym_html_enable_stmt] = STATE(179),
    [sym_pipe_stmt] = STATE(179),
    [sym_iter_file_lines_stmt] = STATE(179),
    [sym_iter_offsets_stmt] = STATE(179),
    [sym_iter_offsetssizes_stmt] = STATE(179),
    [sym_iter_hit_stmt] = STATE(179),
    [sym_iter_interpret_stmt] = STATE(179),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(179),
    [sym_iter_comment_stmt] = STATE(179),
    [sym_iter_dbta_stmt] = STATE(179),
    [sym_iter_dbtb_stmt] = STATE(179),
    [sym_iter_dbts_stmt] = STATE(179),
    [sym_iter_threads_stmt] = STATE(179),
    [sym_iter_bbs_stmt] = STATE(179),
    [sym_iter_instrs_stmt] = STATE(179),
    [sym_iter_import_stmt] = STATE(179),
    [sym_iter_sections_stmt] = STATE(179),
    [sym_iter_segments_stmt] = STATE(179),
    [sym_iter_symbol_stmt] = STATE(179),
    [sym_iter_string_stmt] = STATE(179),
    [sym_iter_flags_stmt] = STATE(179),
    [sym_iter_function_stmt] = STATE(179),
    [sym_iter_iomap_stmt] = STATE(179),
    [sym_iter_dbgmap_stmt] = STATE(179),
    [sym_iter_register_stmt] = STATE(179),
    [sym_iter_step_stmt] = STATE(179),
    [sym_tmp_seek_stmt] = STATE(179),
    [sym_tmp_blksz_stmt] = STATE(179),
    [sym_tmp_fromto_stmt] = STATE(179),
    [sym_tmp_arch_stmt] = STATE(179),
    [sym_tmp_bits_stmt] = STATE(179),
    [sym_tmp_nthi_stmt] = STATE(179),
    [sym_tmp_eval_stmt] = STATE(179),
    [sym_tmp_fs_stmt] = STATE(179),
    [sym_tmp_reli_stmt] = STATE(179),
    [sym_tmp_kuery_stmt] = STATE(179),
    [sym_tmp_fd_stmt] = STATE(179),
    [sym_tmp_reg_stmt] = STATE(179),
    [sym_tmp_file_stmt] = STATE(179),
    [sym_tmp_string_stmt] = STATE(179),
    [sym_tmp_value_stmt] = STATE(179),
    [sym_tmp_hex_stmt] = STATE(179),
    [sym_help_stmt] = STATE(179),
    [sym_arged_stmt] = STATE(179),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(179),
    [sym_Cf_cmd] = STATE(179),
    [sym_pf_new_cmd] = STATE(179),
    [sym_pf_dot_cmd] = STATE(179),
    [sym_pf_cmd] = STATE(179),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(179),
    [sym_redirect_stmt] = STATE(410),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym_statements_repeat1] = STATE(4),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(41),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(41),
    [anon_sym_CR] = ACTIONS(41),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [2] = {
    [sym_legacy_quoted_stmt] = STATE(195),
    [sym__simple_stmt] = STATE(195),
    [sym__tmp_stmt] = STATE(195),
    [sym__iter_stmt] = STATE(195),
    [sym__pipe_stmt] = STATE(195),
    [sym_grep_stmt] = STATE(195),
    [sym_html_disable_stmt] = STATE(195),
    [sym_html_enable_stmt] = STATE(195),
    [sym_pipe_stmt] = STATE(195),
    [sym_iter_file_lines_stmt] = STATE(195),
    [sym_iter_offsets_stmt] = STATE(195),
    [sym_iter_offsetssizes_stmt] = STATE(195),
    [sym_iter_hit_stmt] = STATE(195),
    [sym_iter_interpret_stmt] = STATE(195),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(195),
    [sym_iter_comment_stmt] = STATE(195),
    [sym_iter_dbta_stmt] = STATE(195),
    [sym_iter_dbtb_stmt] = STATE(195),
    [sym_iter_dbts_stmt] = STATE(195),
    [sym_iter_threads_stmt] = STATE(195),
    [sym_iter_bbs_stmt] = STATE(195),
    [sym_iter_instrs_stmt] = STATE(195),
    [sym_iter_import_stmt] = STATE(195),
    [sym_iter_sections_stmt] = STATE(195),
    [sym_iter_segments_stmt] = STATE(195),
    [sym_iter_symbol_stmt] = STATE(195),
    [sym_iter_string_stmt] = STATE(195),
    [sym_iter_flags_stmt] = STATE(195),
    [sym_iter_function_stmt] = STATE(195),
    [sym_iter_iomap_stmt] = STATE(195),
    [sym_iter_dbgmap_stmt] = STATE(195),
    [sym_iter_register_stmt] = STATE(195),
    [sym_iter_step_stmt] = STATE(195),
    [sym_tmp_seek_stmt] = STATE(195),
    [sym_tmp_blksz_stmt] = STATE(195),
    [sym_tmp_fromto_stmt] = STATE(195),
    [sym_tmp_arch_stmt] = STATE(195),
    [sym_tmp_bits_stmt] = STATE(195),
    [sym_tmp_nthi_stmt] = STATE(195),
    [sym_tmp_eval_stmt] = STATE(195),
    [sym_tmp_fs_stmt] = STATE(195),
    [sym_tmp_reli_stmt] = STATE(195),
    [sym_tmp_kuery_stmt] = STATE(195),
    [sym_tmp_fd_stmt] = STATE(195),
    [sym_tmp_reg_stmt] = STATE(195),
    [sym_tmp_file_stmt] = STATE(195),
    [sym_tmp_string_stmt] = STATE(195),
    [sym_tmp_value_stmt] = STATE(195),
    [sym_tmp_hex_stmt] = STATE(195),
    [sym_help_stmt] = STATE(195),
    [sym_arged_stmt] = STATE(195),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(195),
    [sym_Cf_cmd] = STATE(195),
    [sym_pf_new_cmd] = STATE(195),
    [sym_pf_dot_cmd] = STATE(195),
    [sym_pf_cmd] = STATE(195),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(195),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [ts_builtin_sym_end] = ACTIONS(51),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_PIPEH] = ACTIONS(51),
    [anon_sym_AT_AT_DOT] = ACTIONS(51),
    [anon_sym_AT_AT_EQ] = ACTIONS(51),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(51),
    [anon_sym_AT_AT] = ACTIONS(53),
    [anon_sym_AT_ATc_COLON] = ACTIONS(51),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(51),
    [anon_sym_AT_ATC] = ACTIONS(51),
    [anon_sym_AT_ATdbt] = ACTIONS(53),
    [anon_sym_AT_ATdbta] = ACTIONS(51),
    [anon_sym_AT_ATdbtb] = ACTIONS(51),
    [anon_sym_AT_ATdbts] = ACTIONS(51),
    [anon_sym_AT_ATt] = ACTIONS(51),
    [anon_sym_AT_ATb] = ACTIONS(51),
    [anon_sym_AT_ATi] = ACTIONS(53),
    [anon_sym_AT_ATii] = ACTIONS(51),
    [anon_sym_AT_ATiS] = ACTIONS(53),
    [anon_sym_AT_ATiSS] = ACTIONS(51),
    [anon_sym_AT_ATis] = ACTIONS(51),
    [anon_sym_AT_ATiz] = ACTIONS(51),
    [anon_sym_AT_ATf] = ACTIONS(51),
    [anon_sym_AT_ATF] = ACTIONS(51),
    [anon_sym_AT_ATom] = ACTIONS(51),
    [anon_sym_AT_ATdm] = ACTIONS(51),
    [anon_sym_AT_ATr] = ACTIONS(51),
    [anon_sym_AT_ATs_COLON] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_AT_BANG] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(51),
    [anon_sym_ATa_COLON] = ACTIONS(51),
    [anon_sym_ATb_COLON] = ACTIONS(51),
    [anon_sym_ATB_COLON] = ACTIONS(51),
    [anon_sym_ATe_COLON] = ACTIONS(51),
    [anon_sym_ATF_COLON] = ACTIONS(51),
    [anon_sym_ATi_COLON] = ACTIONS(51),
    [anon_sym_ATk_COLON] = ACTIONS(51),
    [anon_sym_ATo_COLON] = ACTIONS(51),
    [anon_sym_ATr_COLON] = ACTIONS(51),
    [anon_sym_ATf_COLON] = ACTIONS(51),
    [anon_sym_ATs_COLON] = ACTIONS(51),
    [anon_sym_ATv_COLON] = ACTIONS(51),
    [anon_sym_ATx_COLON] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_PIPE_DOT] = ACTIONS(51),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_GT_GT] = ACTIONS(51),
    [sym_html_redirect_operator] = ACTIONS(53),
    [sym_html_append_operator] = ACTIONS(51),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(51),
    [anon_sym_CR] = ACTIONS(51),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
    [sym_file_descriptor] = ACTIONS(51),
  },
  [3] = {
    [sym_legacy_quoted_stmt] = STATE(195),
    [sym__simple_stmt] = STATE(195),
    [sym__tmp_stmt] = STATE(195),
    [sym__iter_stmt] = STATE(195),
    [sym__pipe_stmt] = STATE(195),
    [sym_grep_stmt] = STATE(195),
    [sym_html_disable_stmt] = STATE(195),
    [sym_html_enable_stmt] = STATE(195),
    [sym_pipe_stmt] = STATE(195),
    [sym_iter_file_lines_stmt] = STATE(195),
    [sym_iter_offsets_stmt] = STATE(195),
    [sym_iter_offsetssizes_stmt] = STATE(195),
    [sym_iter_hit_stmt] = STATE(195),
    [sym_iter_interpret_stmt] = STATE(195),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(195),
    [sym_iter_comment_stmt] = STATE(195),
    [sym_iter_dbta_stmt] = STATE(195),
    [sym_iter_dbtb_stmt] = STATE(195),
    [sym_iter_dbts_stmt] = STATE(195),
    [sym_iter_threads_stmt] = STATE(195),
    [sym_iter_bbs_stmt] = STATE(195),
    [sym_iter_instrs_stmt] = STATE(195),
    [sym_iter_import_stmt] = STATE(195),
    [sym_iter_sections_stmt] = STATE(195),
    [sym_iter_segments_stmt] = STATE(195),
    [sym_iter_symbol_stmt] = STATE(195),
    [sym_iter_string_stmt] = STATE(195),
    [sym_iter_flags_stmt] = STATE(195),
    [sym_iter_function_stmt] = STATE(195),
    [sym_iter_iomap_stmt] = STATE(195),
    [sym_iter_dbgmap_stmt] = STATE(195),
    [sym_iter_register_stmt] = STATE(195),
    [sym_iter_step_stmt] = STATE(195),
    [sym_tmp_seek_stmt] = STATE(195),
    [sym_tmp_blksz_stmt] = STATE(195),
    [sym_tmp_fromto_stmt] = STATE(195),
    [sym_tmp_arch_stmt] = STATE(195),
    [sym_tmp_bits_stmt] = STATE(195),
    [sym_tmp_nthi_stmt] = STATE(195),
    [sym_tmp_eval_stmt] = STATE(195),
    [sym_tmp_fs_stmt] = STATE(195),
    [sym_tmp_reli_stmt] = STATE(195),
    [sym_tmp_kuery_stmt] = STATE(195),
    [sym_tmp_fd_stmt] = STATE(195),
    [sym_tmp_reg_stmt] = STATE(195),
    [sym_tmp_file_stmt] = STATE(195),
    [sym_tmp_string_stmt] = STATE(195),
    [sym_tmp_value_stmt] = STATE(195),
    [sym_tmp_hex_stmt] = STATE(195),
    [sym_help_stmt] = STATE(195),
    [sym_arged_stmt] = STATE(195),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(195),
    [sym_Cf_cmd] = STATE(195),
    [sym_pf_new_cmd] = STATE(195),
    [sym_pf_dot_cmd] = STATE(195),
    [sym_pf_cmd] = STATE(195),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(195),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_PIPEH] = ACTIONS(51),
    [anon_sym_AT_AT_DOT] = ACTIONS(51),
    [anon_sym_AT_AT_EQ] = ACTIONS(51),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(51),
    [anon_sym_AT_AT] = ACTIONS(53),
    [anon_sym_AT_ATc_COLON] = ACTIONS(51),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(51),
    [anon_sym_AT_ATC] = ACTIONS(51),
    [anon_sym_AT_ATdbt] = ACTIONS(53),
    [anon_sym_AT_ATdbta] = ACTIONS(51),
    [anon_sym_AT_ATdbtb] = ACTIONS(51),
    [anon_sym_AT_ATdbts] = ACTIONS(51),
    [anon_sym_AT_ATt] = ACTIONS(51),
    [anon_sym_AT_ATb] = ACTIONS(51),
    [anon_sym_AT_ATi] = ACTIONS(53),
    [anon_sym_AT_ATii] = ACTIONS(51),
    [anon_sym_AT_ATiS] = ACTIONS(53),
    [anon_sym_AT_ATiSS] = ACTIONS(51),
    [anon_sym_AT_ATis] = ACTIONS(51),
    [anon_sym_AT_ATiz] = ACTIONS(51),
    [anon_sym_AT_ATf] = ACTIONS(51),
    [anon_sym_AT_ATF] = ACTIONS(51),
    [anon_sym_AT_ATom] = ACTIONS(51),
    [anon_sym_AT_ATdm] = ACTIONS(51),
    [anon_sym_AT_ATr] = ACTIONS(51),
    [anon_sym_AT_ATs_COLON] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_AT_BANG] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(51),
    [anon_sym_ATa_COLON] = ACTIONS(51),
    [anon_sym_ATb_COLON] = ACTIONS(51),
    [anon_sym_ATB_COLON] = ACTIONS(51),
    [anon_sym_ATe_COLON] = ACTIONS(51),
    [anon_sym_ATF_COLON] = ACTIONS(51),
    [anon_sym_ATi_COLON] = ACTIONS(51),
    [anon_sym_ATk_COLON] = ACTIONS(51),
    [anon_sym_ATo_COLON] = ACTIONS(51),
    [anon_sym_ATr_COLON] = ACTIONS(51),
    [anon_sym_ATf_COLON] = ACTIONS(51),
    [anon_sym_ATs_COLON] = ACTIONS(51),
    [anon_sym_ATv_COLON] = ACTIONS(51),
    [anon_sym_ATx_COLON] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_PIPE_DOT] = ACTIONS(51),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_GT_GT] = ACTIONS(51),
    [sym_html_redirect_operator] = ACTIONS(53),
    [sym_html_append_operator] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(51),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
    [sym_file_descriptor] = ACTIONS(51),
  },
  [4] = {
    [sym__statement] = STATE(411),
    [sym_legacy_quoted_stmt] = STATE(179),
    [sym__simple_stmt] = STATE(179),
    [sym__tmp_stmt] = STATE(179),
    [sym__iter_stmt] = STATE(179),
    [sym__pipe_stmt] = STATE(179),
    [sym_grep_stmt] = STATE(179),
    [sym_html_disable_stmt] = STATE(179),
    [sym_html_enable_stmt] = STATE(179),
    [sym_pipe_stmt] = STATE(179),
    [sym_iter_file_lines_stmt] = STATE(179),
    [sym_iter_offsets_stmt] = STATE(179),
    [sym_iter_offsetssizes_stmt] = STATE(179),
    [sym_iter_hit_stmt] = STATE(179),
    [sym_iter_interpret_stmt] = STATE(179),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(179),
    [sym_iter_comment_stmt] = STATE(179),
    [sym_iter_dbta_stmt] = STATE(179),
    [sym_iter_dbtb_stmt] = STATE(179),
    [sym_iter_dbts_stmt] = STATE(179),
    [sym_iter_threads_stmt] = STATE(179),
    [sym_iter_bbs_stmt] = STATE(179),
    [sym_iter_instrs_stmt] = STATE(179),
    [sym_iter_import_stmt] = STATE(179),
    [sym_iter_sections_stmt] = STATE(179),
    [sym_iter_segments_stmt] = STATE(179),
    [sym_iter_symbol_stmt] = STATE(179),
    [sym_iter_string_stmt] = STATE(179),
    [sym_iter_flags_stmt] = STATE(179),
    [sym_iter_function_stmt] = STATE(179),
    [sym_iter_iomap_stmt] = STATE(179),
    [sym_iter_dbgmap_stmt] = STATE(179),
    [sym_iter_register_stmt] = STATE(179),
    [sym_iter_step_stmt] = STATE(179),
    [sym_tmp_seek_stmt] = STATE(179),
    [sym_tmp_blksz_stmt] = STATE(179),
    [sym_tmp_fromto_stmt] = STATE(179),
    [sym_tmp_arch_stmt] = STATE(179),
    [sym_tmp_bits_stmt] = STATE(179),
    [sym_tmp_nthi_stmt] = STATE(179),
    [sym_tmp_eval_stmt] = STATE(179),
    [sym_tmp_fs_stmt] = STATE(179),
    [sym_tmp_reli_stmt] = STATE(179),
    [sym_tmp_kuery_stmt] = STATE(179),
    [sym_tmp_fd_stmt] = STATE(179),
    [sym_tmp_reg_stmt] = STATE(179),
    [sym_tmp_file_stmt] = STATE(179),
    [sym_tmp_string_stmt] = STATE(179),
    [sym_tmp_value_stmt] = STATE(179),
    [sym_tmp_hex_stmt] = STATE(179),
    [sym_help_stmt] = STATE(179),
    [sym_arged_stmt] = STATE(179),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(179),
    [sym_Cf_cmd] = STATE(179),
    [sym_pf_new_cmd] = STATE(179),
    [sym_pf_dot_cmd] = STATE(179),
    [sym_pf_cmd] = STATE(179),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(179),
    [sym_redirect_stmt] = STATE(411),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym_statements_repeat1] = STATE(278),
    [ts_builtin_sym_end] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(81),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(81),
    [anon_sym_CR] = ACTIONS(81),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [5] = {
    [sym__statement] = STATE(416),
    [sym_legacy_quoted_stmt] = STATE(179),
    [sym__simple_stmt] = STATE(179),
    [sym__tmp_stmt] = STATE(179),
    [sym__iter_stmt] = STATE(179),
    [sym__pipe_stmt] = STATE(179),
    [sym_grep_stmt] = STATE(179),
    [sym_html_disable_stmt] = STATE(179),
    [sym_html_enable_stmt] = STATE(179),
    [sym_pipe_stmt] = STATE(179),
    [sym_iter_file_lines_stmt] = STATE(179),
    [sym_iter_offsets_stmt] = STATE(179),
    [sym_iter_offsetssizes_stmt] = STATE(179),
    [sym_iter_hit_stmt] = STATE(179),
    [sym_iter_interpret_stmt] = STATE(179),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(179),
    [sym_iter_comment_stmt] = STATE(179),
    [sym_iter_dbta_stmt] = STATE(179),
    [sym_iter_dbtb_stmt] = STATE(179),
    [sym_iter_dbts_stmt] = STATE(179),
    [sym_iter_threads_stmt] = STATE(179),
    [sym_iter_bbs_stmt] = STATE(179),
    [sym_iter_instrs_stmt] = STATE(179),
    [sym_iter_import_stmt] = STATE(179),
    [sym_iter_sections_stmt] = STATE(179),
    [sym_iter_segments_stmt] = STATE(179),
    [sym_iter_symbol_stmt] = STATE(179),
    [sym_iter_string_stmt] = STATE(179),
    [sym_iter_flags_stmt] = STATE(179),
    [sym_iter_function_stmt] = STATE(179),
    [sym_iter_iomap_stmt] = STATE(179),
    [sym_iter_dbgmap_stmt] = STATE(179),
    [sym_iter_register_stmt] = STATE(179),
    [sym_iter_step_stmt] = STATE(179),
    [sym_tmp_seek_stmt] = STATE(179),
    [sym_tmp_blksz_stmt] = STATE(179),
    [sym_tmp_fromto_stmt] = STATE(179),
    [sym_tmp_arch_stmt] = STATE(179),
    [sym_tmp_bits_stmt] = STATE(179),
    [sym_tmp_nthi_stmt] = STATE(179),
    [sym_tmp_eval_stmt] = STATE(179),
    [sym_tmp_fs_stmt] = STATE(179),
    [sym_tmp_reli_stmt] = STATE(179),
    [sym_tmp_kuery_stmt] = STATE(179),
    [sym_tmp_fd_stmt] = STATE(179),
    [sym_tmp_reg_stmt] = STATE(179),
    [sym_tmp_file_stmt] = STATE(179),
    [sym_tmp_string_stmt] = STATE(179),
    [sym_tmp_value_stmt] = STATE(179),
    [sym_tmp_hex_stmt] = STATE(179),
    [sym_help_stmt] = STATE(179),
    [sym_arged_stmt] = STATE(179),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(179),
    [sym_Cf_cmd] = STATE(179),
    [sym_pf_new_cmd] = STATE(179),
    [sym_pf_dot_cmd] = STATE(179),
    [sym_pf_cmd] = STATE(179),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(179),
    [sym_redirect_stmt] = STATE(416),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [ts_builtin_sym_end] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(83),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(83),
    [anon_sym_CR] = ACTIONS(83),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [6] = {
    [sym__statements_singleline] = STATE(507),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [7] = {
    [sym__statements_singleline] = STATE(468),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [8] = {
    [sym__statements_singleline] = STATE(474),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [9] = {
    [sym__statements_singleline] = STATE(473),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [10] = {
    [sym__statements_singleline] = STATE(472),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [11] = {
    [sym__statements_singleline] = STATE(471),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [12] = {
    [sym__statements_singleline] = STATE(497),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [13] = {
    [sym__statements_singleline] = STATE(470),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [14] = {
    [sym__statements_singleline] = STATE(469),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [15] = {
    [sym__statements_singleline] = STATE(465),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [16] = {
    [sym__statements_singleline] = STATE(475),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [17] = {
    [sym__statements_singleline] = STATE(490),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [18] = {
    [sym__statements_singleline] = STATE(502),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [19] = {
    [sym__statements_singleline] = STATE(499),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [20] = {
    [sym__statements_singleline] = STATE(467),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [21] = {
    [sym__statements_singleline] = STATE(494),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [22] = {
    [sym__statements_singleline] = STATE(486),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [23] = {
    [sym__statements_singleline] = STATE(477),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [24] = {
    [sym__statements_singleline] = STATE(478),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [25] = {
    [sym__statements_singleline] = STATE(493),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [26] = {
    [sym__statements_singleline] = STATE(479),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [27] = {
    [sym__statements_singleline] = STATE(483),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [28] = {
    [sym__statements_singleline] = STATE(484),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(87),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [29] = {
    [sym__statements_singleline] = STATE(489),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(31),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [30] = {
    [sym__statement] = STATE(439),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(439),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [31] = {
    [sym__statement] = STATE(444),
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(272),
    [sym_redirect_stmt] = STATE(444),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(279),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(91),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [32] = {
    [sym__statement] = STATE(447),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(447),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [aux_sym__statements_singleline_repeat1] = STATE(279),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(91),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [33] = {
    [sym__statement] = STATE(439),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(439),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(89),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [34] = {
    [sym__statement] = STATE(463),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(463),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [35] = {
    [sym__statement] = STATE(443),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(443),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [36] = {
    [sym__statement] = STATE(433),
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(269),
    [sym_redirect_stmt] = STATE(433),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [37] = {
    [sym_legacy_quoted_stmt] = STATE(276),
    [sym__simple_stmt] = STATE(276),
    [sym__tmp_stmt] = STATE(276),
    [sym__iter_stmt] = STATE(276),
    [sym__pipe_stmt] = STATE(276),
    [sym_grep_stmt] = STATE(276),
    [sym_html_disable_stmt] = STATE(276),
    [sym_html_enable_stmt] = STATE(276),
    [sym_pipe_stmt] = STATE(276),
    [sym_iter_file_lines_stmt] = STATE(276),
    [sym_iter_offsets_stmt] = STATE(276),
    [sym_iter_offsetssizes_stmt] = STATE(276),
    [sym_iter_hit_stmt] = STATE(276),
    [sym_iter_interpret_stmt] = STATE(276),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(276),
    [sym_iter_comment_stmt] = STATE(276),
    [sym_iter_dbta_stmt] = STATE(276),
    [sym_iter_dbtb_stmt] = STATE(276),
    [sym_iter_dbts_stmt] = STATE(276),
    [sym_iter_threads_stmt] = STATE(276),
    [sym_iter_bbs_stmt] = STATE(276),
    [sym_iter_instrs_stmt] = STATE(276),
    [sym_iter_import_stmt] = STATE(276),
    [sym_iter_sections_stmt] = STATE(276),
    [sym_iter_segments_stmt] = STATE(276),
    [sym_iter_symbol_stmt] = STATE(276),
    [sym_iter_string_stmt] = STATE(276),
    [sym_iter_flags_stmt] = STATE(276),
    [sym_iter_function_stmt] = STATE(276),
    [sym_iter_iomap_stmt] = STATE(276),
    [sym_iter_dbgmap_stmt] = STATE(276),
    [sym_iter_register_stmt] = STATE(276),
    [sym_iter_step_stmt] = STATE(276),
    [sym_tmp_seek_stmt] = STATE(276),
    [sym_tmp_blksz_stmt] = STATE(276),
    [sym_tmp_fromto_stmt] = STATE(276),
    [sym_tmp_arch_stmt] = STATE(276),
    [sym_tmp_bits_stmt] = STATE(276),
    [sym_tmp_nthi_stmt] = STATE(276),
    [sym_tmp_eval_stmt] = STATE(276),
    [sym_tmp_fs_stmt] = STATE(276),
    [sym_tmp_reli_stmt] = STATE(276),
    [sym_tmp_kuery_stmt] = STATE(276),
    [sym_tmp_fd_stmt] = STATE(276),
    [sym_tmp_reg_stmt] = STATE(276),
    [sym_tmp_file_stmt] = STATE(276),
    [sym_tmp_string_stmt] = STATE(276),
    [sym_tmp_value_stmt] = STATE(276),
    [sym_tmp_hex_stmt] = STATE(276),
    [sym_help_stmt] = STATE(276),
    [sym_arged_stmt] = STATE(276),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(276),
    [sym_Cf_cmd] = STATE(276),
    [sym_pf_new_cmd] = STATE(276),
    [sym_pf_dot_cmd] = STATE(276),
    [sym_pf_cmd] = STATE(276),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(276),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [38] = {
    [sym_legacy_quoted_stmt] = STATE(277),
    [sym__simple_stmt] = STATE(277),
    [sym__tmp_stmt] = STATE(277),
    [sym__iter_stmt] = STATE(277),
    [sym__pipe_stmt] = STATE(277),
    [sym_grep_stmt] = STATE(277),
    [sym_html_disable_stmt] = STATE(277),
    [sym_html_enable_stmt] = STATE(277),
    [sym_pipe_stmt] = STATE(277),
    [sym_iter_file_lines_stmt] = STATE(277),
    [sym_iter_offsets_stmt] = STATE(277),
    [sym_iter_offsetssizes_stmt] = STATE(277),
    [sym_iter_hit_stmt] = STATE(277),
    [sym_iter_interpret_stmt] = STATE(277),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(277),
    [sym_iter_comment_stmt] = STATE(277),
    [sym_iter_dbta_stmt] = STATE(277),
    [sym_iter_dbtb_stmt] = STATE(277),
    [sym_iter_dbts_stmt] = STATE(277),
    [sym_iter_threads_stmt] = STATE(277),
    [sym_iter_bbs_stmt] = STATE(277),
    [sym_iter_instrs_stmt] = STATE(277),
    [sym_iter_import_stmt] = STATE(277),
    [sym_iter_sections_stmt] = STATE(277),
    [sym_iter_segments_stmt] = STATE(277),
    [sym_iter_symbol_stmt] = STATE(277),
    [sym_iter_string_stmt] = STATE(277),
    [sym_iter_flags_stmt] = STATE(277),
    [sym_iter_function_stmt] = STATE(277),
    [sym_iter_iomap_stmt] = STATE(277),
    [sym_iter_dbgmap_stmt] = STATE(277),
    [sym_iter_register_stmt] = STATE(277),
    [sym_iter_step_stmt] = STATE(277),
    [sym_tmp_seek_stmt] = STATE(277),
    [sym_tmp_blksz_stmt] = STATE(277),
    [sym_tmp_fromto_stmt] = STATE(277),
    [sym_tmp_arch_stmt] = STATE(277),
    [sym_tmp_bits_stmt] = STATE(277),
    [sym_tmp_nthi_stmt] = STATE(277),
    [sym_tmp_eval_stmt] = STATE(277),
    [sym_tmp_fs_stmt] = STATE(277),
    [sym_tmp_reli_stmt] = STATE(277),
    [sym_tmp_kuery_stmt] = STATE(277),
    [sym_tmp_fd_stmt] = STATE(277),
    [sym_tmp_reg_stmt] = STATE(277),
    [sym_tmp_file_stmt] = STATE(277),
    [sym_tmp_string_stmt] = STATE(277),
    [sym_tmp_value_stmt] = STATE(277),
    [sym_tmp_hex_stmt] = STATE(277),
    [sym_help_stmt] = STATE(277),
    [sym_arged_stmt] = STATE(277),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(277),
    [sym_Cf_cmd] = STATE(277),
    [sym_pf_new_cmd] = STATE(277),
    [sym_pf_dot_cmd] = STATE(277),
    [sym_pf_cmd] = STATE(277),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(277),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [39] = {
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(270),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [40] = {
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(271),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [41] = {
    [sym_legacy_quoted_stmt] = STATE(254),
    [sym__simple_stmt] = STATE(254),
    [sym__tmp_stmt] = STATE(254),
    [sym__iter_stmt] = STATE(254),
    [sym__pipe_stmt] = STATE(254),
    [sym_grep_stmt] = STATE(254),
    [sym_html_disable_stmt] = STATE(254),
    [sym_html_enable_stmt] = STATE(254),
    [sym_pipe_stmt] = STATE(254),
    [sym_iter_file_lines_stmt] = STATE(254),
    [sym_iter_offsets_stmt] = STATE(254),
    [sym_iter_offsetssizes_stmt] = STATE(254),
    [sym_iter_hit_stmt] = STATE(254),
    [sym_iter_interpret_stmt] = STATE(254),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(254),
    [sym_iter_comment_stmt] = STATE(254),
    [sym_iter_dbta_stmt] = STATE(254),
    [sym_iter_dbtb_stmt] = STATE(254),
    [sym_iter_dbts_stmt] = STATE(254),
    [sym_iter_threads_stmt] = STATE(254),
    [sym_iter_bbs_stmt] = STATE(254),
    [sym_iter_instrs_stmt] = STATE(254),
    [sym_iter_import_stmt] = STATE(254),
    [sym_iter_sections_stmt] = STATE(254),
    [sym_iter_segments_stmt] = STATE(254),
    [sym_iter_symbol_stmt] = STATE(254),
    [sym_iter_string_stmt] = STATE(254),
    [sym_iter_flags_stmt] = STATE(254),
    [sym_iter_function_stmt] = STATE(254),
    [sym_iter_iomap_stmt] = STATE(254),
    [sym_iter_dbgmap_stmt] = STATE(254),
    [sym_iter_register_stmt] = STATE(254),
    [sym_iter_step_stmt] = STATE(254),
    [sym_tmp_seek_stmt] = STATE(254),
    [sym_tmp_blksz_stmt] = STATE(254),
    [sym_tmp_fromto_stmt] = STATE(254),
    [sym_tmp_arch_stmt] = STATE(254),
    [sym_tmp_bits_stmt] = STATE(254),
    [sym_tmp_nthi_stmt] = STATE(254),
    [sym_tmp_eval_stmt] = STATE(254),
    [sym_tmp_fs_stmt] = STATE(254),
    [sym_tmp_reli_stmt] = STATE(254),
    [sym_tmp_kuery_stmt] = STATE(254),
    [sym_tmp_fd_stmt] = STATE(254),
    [sym_tmp_reg_stmt] = STATE(254),
    [sym_tmp_file_stmt] = STATE(254),
    [sym_tmp_string_stmt] = STATE(254),
    [sym_tmp_value_stmt] = STATE(254),
    [sym_tmp_hex_stmt] = STATE(254),
    [sym_help_stmt] = STATE(254),
    [sym_arged_stmt] = STATE(254),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(254),
    [sym_Cf_cmd] = STATE(254),
    [sym_pf_new_cmd] = STATE(254),
    [sym_pf_dot_cmd] = STATE(254),
    [sym_pf_cmd] = STATE(254),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(72),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(254),
    [sym__dec_number] = STATE(41),
    [sym_cmd_identifier] = STATE(44),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(9),
    [aux_sym__interpret_stmt_token1] = ACTIONS(11),
    [aux_sym__interpret_stmt_token3] = ACTIONS(13),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(19),
    [anon_sym_Cf] = ACTIONS(21),
    [sym_pf_dot_cmd_identifier] = ACTIONS(23),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(25),
    [aux_sym_pf_cmd_token1] = ACTIONS(27),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(33),
    [sym_question_mark_identifier] = ACTIONS(35),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(39),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(49),
  },
  [42] = {
    [sym_legacy_quoted_stmt] = STATE(254),
    [sym__simple_stmt] = STATE(254),
    [sym__tmp_stmt] = STATE(254),
    [sym__iter_stmt] = STATE(254),
    [sym__pipe_stmt] = STATE(254),
    [sym_grep_stmt] = STATE(254),
    [sym_html_disable_stmt] = STATE(254),
    [sym_html_enable_stmt] = STATE(254),
    [sym_pipe_stmt] = STATE(254),
    [sym_iter_file_lines_stmt] = STATE(254),
    [sym_iter_offsets_stmt] = STATE(254),
    [sym_iter_offsetssizes_stmt] = STATE(254),
    [sym_iter_hit_stmt] = STATE(254),
    [sym_iter_interpret_stmt] = STATE(254),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(254),
    [sym_iter_comment_stmt] = STATE(254),
    [sym_iter_dbta_stmt] = STATE(254),
    [sym_iter_dbtb_stmt] = STATE(254),
    [sym_iter_dbts_stmt] = STATE(254),
    [sym_iter_threads_stmt] = STATE(254),
    [sym_iter_bbs_stmt] = STATE(254),
    [sym_iter_instrs_stmt] = STATE(254),
    [sym_iter_import_stmt] = STATE(254),
    [sym_iter_sections_stmt] = STATE(254),
    [sym_iter_segments_stmt] = STATE(254),
    [sym_iter_symbol_stmt] = STATE(254),
    [sym_iter_string_stmt] = STATE(254),
    [sym_iter_flags_stmt] = STATE(254),
    [sym_iter_function_stmt] = STATE(254),
    [sym_iter_iomap_stmt] = STATE(254),
    [sym_iter_dbgmap_stmt] = STATE(254),
    [sym_iter_register_stmt] = STATE(254),
    [sym_iter_step_stmt] = STATE(254),
    [sym_tmp_seek_stmt] = STATE(254),
    [sym_tmp_blksz_stmt] = STATE(254),
    [sym_tmp_fromto_stmt] = STATE(254),
    [sym_tmp_arch_stmt] = STATE(254),
    [sym_tmp_bits_stmt] = STATE(254),
    [sym_tmp_nthi_stmt] = STATE(254),
    [sym_tmp_eval_stmt] = STATE(254),
    [sym_tmp_fs_stmt] = STATE(254),
    [sym_tmp_reli_stmt] = STATE(254),
    [sym_tmp_kuery_stmt] = STATE(254),
    [sym_tmp_fd_stmt] = STATE(254),
    [sym_tmp_reg_stmt] = STATE(254),
    [sym_tmp_file_stmt] = STATE(254),
    [sym_tmp_string_stmt] = STATE(254),
    [sym_tmp_value_stmt] = STATE(254),
    [sym_tmp_hex_stmt] = STATE(254),
    [sym_help_stmt] = STATE(254),
    [sym_arged_stmt] = STATE(254),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(295),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(254),
    [sym_Cf_cmd] = STATE(254),
    [sym_pf_new_cmd] = STATE(254),
    [sym_pf_dot_cmd] = STATE(254),
    [sym_pf_cmd] = STATE(254),
    [sym__env_stmt] = STATE(267),
    [sym__env_stmt_identifier] = STATE(93),
    [sym__last_stmt] = STATE(243),
    [sym_last_stmt_identifier] = STATE(235),
    [sym_repeat_stmt] = STATE(254),
    [sym__dec_number] = STATE(42),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(55),
    [aux_sym__interpret_stmt_token1] = ACTIONS(57),
    [aux_sym__interpret_stmt_token3] = ACTIONS(59),
    [aux_sym__interpret_stmt_token4] = ACTIONS(15),
    [anon_sym_DOT_SLASH] = ACTIONS(17),
    [anon_sym_pfo] = ACTIONS(61),
    [anon_sym_Cf] = ACTIONS(63),
    [sym_pf_dot_cmd_identifier] = ACTIONS(65),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(67),
    [aux_sym_pf_cmd_token1] = ACTIONS(69),
    [anon_sym_PERCENT] = ACTIONS(29),
    [anon_sym_env] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [sym_system_identifier] = ACTIONS(71),
    [sym_question_mark_identifier] = ACTIONS(73),
    [sym_pointer_identifier] = ACTIONS(37),
    [sym_macro_identifier] = ACTIONS(75),
    [aux_sym__dec_number_token1] = ACTIONS(43),
    [aux_sym__dec_number_token2] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(47),
    [sym__help_stmt] = ACTIONS(77),
  },
  [43] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(264),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(97),
    [anon_sym_PIPEH] = ACTIONS(93),
    [anon_sym_AT_AT_DOT] = ACTIONS(93),
    [anon_sym_AT_AT_EQ] = ACTIONS(93),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(93),
    [anon_sym_AT_AT] = ACTIONS(97),
    [anon_sym_AT_ATc_COLON] = ACTIONS(93),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(93),
    [anon_sym_AT_ATC] = ACTIONS(93),
    [anon_sym_AT_ATdbt] = ACTIONS(97),
    [anon_sym_AT_ATdbta] = ACTIONS(93),
    [anon_sym_AT_ATdbtb] = ACTIONS(93),
    [anon_sym_AT_ATdbts] = ACTIONS(93),
    [anon_sym_AT_ATt] = ACTIONS(93),
    [anon_sym_AT_ATb] = ACTIONS(93),
    [anon_sym_AT_ATi] = ACTIONS(97),
    [anon_sym_AT_ATii] = ACTIONS(93),
    [anon_sym_AT_ATiS] = ACTIONS(97),
    [anon_sym_AT_ATiSS] = ACTIONS(93),
    [anon_sym_AT_ATis] = ACTIONS(93),
    [anon_sym_AT_ATiz] = ACTIONS(93),
    [anon_sym_AT_ATf] = ACTIONS(93),
    [anon_sym_AT_ATF] = ACTIONS(93),
    [anon_sym_AT_ATom] = ACTIONS(93),
    [anon_sym_AT_ATdm] = ACTIONS(93),
    [anon_sym_AT_ATr] = ACTIONS(93),
    [anon_sym_AT_ATs_COLON] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_AT_BANG] = ACTIONS(93),
    [anon_sym_AT_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(93),
    [anon_sym_ATa_COLON] = ACTIONS(93),
    [anon_sym_ATb_COLON] = ACTIONS(93),
    [anon_sym_ATB_COLON] = ACTIONS(93),
    [anon_sym_ATe_COLON] = ACTIONS(93),
    [anon_sym_ATF_COLON] = ACTIONS(93),
    [anon_sym_ATi_COLON] = ACTIONS(93),
    [anon_sym_ATk_COLON] = ACTIONS(93),
    [anon_sym_ATo_COLON] = ACTIONS(93),
    [anon_sym_ATr_COLON] = ACTIONS(93),
    [anon_sym_ATf_COLON] = ACTIONS(93),
    [anon_sym_ATs_COLON] = ACTIONS(93),
    [anon_sym_ATv_COLON] = ACTIONS(93),
    [anon_sym_ATx_COLON] = ACTIONS(93),
    [anon_sym_PIPE_DOT] = ACTIONS(93),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(93),
    [sym_html_redirect_operator] = ACTIONS(97),
    [sym_html_append_operator] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(93),
    [anon_sym_CR] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(93),
  },
  [44] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(268),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(111),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_PIPEH] = ACTIONS(111),
    [anon_sym_AT_AT_DOT] = ACTIONS(111),
    [anon_sym_AT_AT_EQ] = ACTIONS(111),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(111),
    [anon_sym_AT_AT] = ACTIONS(113),
    [anon_sym_AT_ATc_COLON] = ACTIONS(111),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(111),
    [anon_sym_AT_ATC] = ACTIONS(111),
    [anon_sym_AT_ATdbt] = ACTIONS(113),
    [anon_sym_AT_ATdbta] = ACTIONS(111),
    [anon_sym_AT_ATdbtb] = ACTIONS(111),
    [anon_sym_AT_ATdbts] = ACTIONS(111),
    [anon_sym_AT_ATt] = ACTIONS(111),
    [anon_sym_AT_ATb] = ACTIONS(111),
    [anon_sym_AT_ATi] = ACTIONS(113),
    [anon_sym_AT_ATii] = ACTIONS(111),
    [anon_sym_AT_ATiS] = ACTIONS(113),
    [anon_sym_AT_ATiSS] = ACTIONS(111),
    [anon_sym_AT_ATis] = ACTIONS(111),
    [anon_sym_AT_ATiz] = ACTIONS(111),
    [anon_sym_AT_ATf] = ACTIONS(111),
    [anon_sym_AT_ATF] = ACTIONS(111),
    [anon_sym_AT_ATom] = ACTIONS(111),
    [anon_sym_AT_ATdm] = ACTIONS(111),
    [anon_sym_AT_ATr] = ACTIONS(111),
    [anon_sym_AT_ATs_COLON] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [anon_sym_AT_BANG] = ACTIONS(111),
    [anon_sym_AT_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_ATa_COLON] = ACTIONS(111),
    [anon_sym_ATb_COLON] = ACTIONS(111),
    [anon_sym_ATB_COLON] = ACTIONS(111),
    [anon_sym_ATe_COLON] = ACTIONS(111),
    [anon_sym_ATF_COLON] = ACTIONS(111),
    [anon_sym_ATi_COLON] = ACTIONS(111),
    [anon_sym_ATk_COLON] = ACTIONS(111),
    [anon_sym_ATo_COLON] = ACTIONS(111),
    [anon_sym_ATr_COLON] = ACTIONS(111),
    [anon_sym_ATf_COLON] = ACTIONS(111),
    [anon_sym_ATs_COLON] = ACTIONS(111),
    [anon_sym_ATv_COLON] = ACTIONS(111),
    [anon_sym_ATx_COLON] = ACTIONS(111),
    [anon_sym_PIPE_DOT] = ACTIONS(111),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(111),
    [sym_html_redirect_operator] = ACTIONS(113),
    [sym_html_append_operator] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(111),
    [anon_sym_CR] = ACTIONS(111),
    [sym_file_descriptor] = ACTIONS(111),
  },
  [45] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(206),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(117),
    [anon_sym_PIPEH] = ACTIONS(115),
    [anon_sym_AT_AT_DOT] = ACTIONS(115),
    [anon_sym_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT] = ACTIONS(117),
    [anon_sym_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_ATC] = ACTIONS(115),
    [anon_sym_AT_ATdbt] = ACTIONS(117),
    [anon_sym_AT_ATdbta] = ACTIONS(115),
    [anon_sym_AT_ATdbtb] = ACTIONS(115),
    [anon_sym_AT_ATdbts] = ACTIONS(115),
    [anon_sym_AT_ATt] = ACTIONS(115),
    [anon_sym_AT_ATb] = ACTIONS(115),
    [anon_sym_AT_ATi] = ACTIONS(117),
    [anon_sym_AT_ATii] = ACTIONS(115),
    [anon_sym_AT_ATiS] = ACTIONS(117),
    [anon_sym_AT_ATiSS] = ACTIONS(115),
    [anon_sym_AT_ATis] = ACTIONS(115),
    [anon_sym_AT_ATiz] = ACTIONS(115),
    [anon_sym_AT_ATf] = ACTIONS(115),
    [anon_sym_AT_ATF] = ACTIONS(115),
    [anon_sym_AT_ATom] = ACTIONS(115),
    [anon_sym_AT_ATdm] = ACTIONS(115),
    [anon_sym_AT_ATr] = ACTIONS(115),
    [anon_sym_AT_ATs_COLON] = ACTIONS(115),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_AT_BANG] = ACTIONS(115),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(115),
    [anon_sym_ATa_COLON] = ACTIONS(115),
    [anon_sym_ATb_COLON] = ACTIONS(115),
    [anon_sym_ATB_COLON] = ACTIONS(115),
    [anon_sym_ATe_COLON] = ACTIONS(115),
    [anon_sym_ATF_COLON] = ACTIONS(115),
    [anon_sym_ATi_COLON] = ACTIONS(115),
    [anon_sym_ATk_COLON] = ACTIONS(115),
    [anon_sym_ATo_COLON] = ACTIONS(115),
    [anon_sym_ATr_COLON] = ACTIONS(115),
    [anon_sym_ATf_COLON] = ACTIONS(115),
    [anon_sym_ATs_COLON] = ACTIONS(115),
    [anon_sym_ATv_COLON] = ACTIONS(115),
    [anon_sym_ATx_COLON] = ACTIONS(115),
    [anon_sym_PIPE_DOT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(117),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym_html_redirect_operator] = ACTIONS(117),
    [sym_html_append_operator] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(115),
    [anon_sym_CR] = ACTIONS(115),
    [sym_file_descriptor] = ACTIONS(115),
  },
  [46] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(194),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(121),
    [anon_sym_PIPEH] = ACTIONS(119),
    [anon_sym_AT_AT_DOT] = ACTIONS(119),
    [anon_sym_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT] = ACTIONS(121),
    [anon_sym_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_ATC] = ACTIONS(119),
    [anon_sym_AT_ATdbt] = ACTIONS(121),
    [anon_sym_AT_ATdbta] = ACTIONS(119),
    [anon_sym_AT_ATdbtb] = ACTIONS(119),
    [anon_sym_AT_ATdbts] = ACTIONS(119),
    [anon_sym_AT_ATt] = ACTIONS(119),
    [anon_sym_AT_ATb] = ACTIONS(119),
    [anon_sym_AT_ATi] = ACTIONS(121),
    [anon_sym_AT_ATii] = ACTIONS(119),
    [anon_sym_AT_ATiS] = ACTIONS(121),
    [anon_sym_AT_ATiSS] = ACTIONS(119),
    [anon_sym_AT_ATis] = ACTIONS(119),
    [anon_sym_AT_ATiz] = ACTIONS(119),
    [anon_sym_AT_ATf] = ACTIONS(119),
    [anon_sym_AT_ATF] = ACTIONS(119),
    [anon_sym_AT_ATom] = ACTIONS(119),
    [anon_sym_AT_ATdm] = ACTIONS(119),
    [anon_sym_AT_ATr] = ACTIONS(119),
    [anon_sym_AT_ATs_COLON] = ACTIONS(119),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_AT_BANG] = ACTIONS(119),
    [anon_sym_AT_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_ATa_COLON] = ACTIONS(119),
    [anon_sym_ATb_COLON] = ACTIONS(119),
    [anon_sym_ATB_COLON] = ACTIONS(119),
    [anon_sym_ATe_COLON] = ACTIONS(119),
    [anon_sym_ATF_COLON] = ACTIONS(119),
    [anon_sym_ATi_COLON] = ACTIONS(119),
    [anon_sym_ATk_COLON] = ACTIONS(119),
    [anon_sym_ATo_COLON] = ACTIONS(119),
    [anon_sym_ATr_COLON] = ACTIONS(119),
    [anon_sym_ATf_COLON] = ACTIONS(119),
    [anon_sym_ATs_COLON] = ACTIONS(119),
    [anon_sym_ATv_COLON] = ACTIONS(119),
    [anon_sym_ATx_COLON] = ACTIONS(119),
    [anon_sym_PIPE_DOT] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_GT_GT] = ACTIONS(119),
    [sym_html_redirect_operator] = ACTIONS(121),
    [sym_html_append_operator] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(119),
    [anon_sym_CR] = ACTIONS(119),
    [sym_file_descriptor] = ACTIONS(119),
  },
  [47] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(209),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(125),
    [anon_sym_PIPEH] = ACTIONS(123),
    [anon_sym_AT_AT_DOT] = ACTIONS(123),
    [anon_sym_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT] = ACTIONS(125),
    [anon_sym_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_ATC] = ACTIONS(123),
    [anon_sym_AT_ATdbt] = ACTIONS(125),
    [anon_sym_AT_ATdbta] = ACTIONS(123),
    [anon_sym_AT_ATdbtb] = ACTIONS(123),
    [anon_sym_AT_ATdbts] = ACTIONS(123),
    [anon_sym_AT_ATt] = ACTIONS(123),
    [anon_sym_AT_ATb] = ACTIONS(123),
    [anon_sym_AT_ATi] = ACTIONS(125),
    [anon_sym_AT_ATii] = ACTIONS(123),
    [anon_sym_AT_ATiS] = ACTIONS(125),
    [anon_sym_AT_ATiSS] = ACTIONS(123),
    [anon_sym_AT_ATis] = ACTIONS(123),
    [anon_sym_AT_ATiz] = ACTIONS(123),
    [anon_sym_AT_ATf] = ACTIONS(123),
    [anon_sym_AT_ATF] = ACTIONS(123),
    [anon_sym_AT_ATom] = ACTIONS(123),
    [anon_sym_AT_ATdm] = ACTIONS(123),
    [anon_sym_AT_ATr] = ACTIONS(123),
    [anon_sym_AT_ATs_COLON] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_AT_BANG] = ACTIONS(123),
    [anon_sym_AT_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_ATa_COLON] = ACTIONS(123),
    [anon_sym_ATb_COLON] = ACTIONS(123),
    [anon_sym_ATB_COLON] = ACTIONS(123),
    [anon_sym_ATe_COLON] = ACTIONS(123),
    [anon_sym_ATF_COLON] = ACTIONS(123),
    [anon_sym_ATi_COLON] = ACTIONS(123),
    [anon_sym_ATk_COLON] = ACTIONS(123),
    [anon_sym_ATo_COLON] = ACTIONS(123),
    [anon_sym_ATr_COLON] = ACTIONS(123),
    [anon_sym_ATf_COLON] = ACTIONS(123),
    [anon_sym_ATs_COLON] = ACTIONS(123),
    [anon_sym_ATv_COLON] = ACTIONS(123),
    [anon_sym_ATx_COLON] = ACTIONS(123),
    [anon_sym_PIPE_DOT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym_html_redirect_operator] = ACTIONS(125),
    [sym_html_append_operator] = ACTIONS(123),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(123),
    [anon_sym_CR] = ACTIONS(123),
    [sym_file_descriptor] = ACTIONS(123),
  },
  [48] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(208),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(127),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(127),
    [anon_sym_CR] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [49] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(196),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(131),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(131),
    [anon_sym_CR] = ACTIONS(131),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [50] = {
    [sym_macro_content] = STATE(132),
    [sym_macro_args] = STATE(215),
    [sym__arg_with_paren] = STATE(326),
    [sym__arg] = STATE(326),
    [sym_arg] = STATE(281),
    [sym_arg_identifier] = STATE(326),
    [sym_double_quoted_arg] = STATE(326),
    [sym_single_quoted_arg] = STATE(326),
    [sym_cmd_substitution_arg] = STATE(326),
    [sym_concatenation] = STATE(347),
    [ts_builtin_sym_end] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(139),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(139),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(139),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(139),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(135),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(139),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(145),
    [aux_sym_arg_identifier_token1] = ACTIONS(141),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(135),
    [anon_sym_CR] = ACTIONS(135),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [51] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(213),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(121),
    [anon_sym_PIPEH] = ACTIONS(119),
    [anon_sym_AT_AT_DOT] = ACTIONS(119),
    [anon_sym_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT] = ACTIONS(121),
    [anon_sym_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_ATC] = ACTIONS(119),
    [anon_sym_AT_ATdbt] = ACTIONS(121),
    [anon_sym_AT_ATdbta] = ACTIONS(119),
    [anon_sym_AT_ATdbtb] = ACTIONS(119),
    [anon_sym_AT_ATdbts] = ACTIONS(119),
    [anon_sym_AT_ATt] = ACTIONS(119),
    [anon_sym_AT_ATb] = ACTIONS(119),
    [anon_sym_AT_ATi] = ACTIONS(121),
    [anon_sym_AT_ATii] = ACTIONS(119),
    [anon_sym_AT_ATiS] = ACTIONS(121),
    [anon_sym_AT_ATiSS] = ACTIONS(119),
    [anon_sym_AT_ATis] = ACTIONS(119),
    [anon_sym_AT_ATiz] = ACTIONS(119),
    [anon_sym_AT_ATf] = ACTIONS(119),
    [anon_sym_AT_ATF] = ACTIONS(119),
    [anon_sym_AT_ATom] = ACTIONS(119),
    [anon_sym_AT_ATdm] = ACTIONS(119),
    [anon_sym_AT_ATr] = ACTIONS(119),
    [anon_sym_AT_ATs_COLON] = ACTIONS(119),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_AT_BANG] = ACTIONS(119),
    [anon_sym_AT_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_ATa_COLON] = ACTIONS(119),
    [anon_sym_ATb_COLON] = ACTIONS(119),
    [anon_sym_ATB_COLON] = ACTIONS(119),
    [anon_sym_ATe_COLON] = ACTIONS(119),
    [anon_sym_ATF_COLON] = ACTIONS(119),
    [anon_sym_ATi_COLON] = ACTIONS(119),
    [anon_sym_ATk_COLON] = ACTIONS(119),
    [anon_sym_ATo_COLON] = ACTIONS(119),
    [anon_sym_ATr_COLON] = ACTIONS(119),
    [anon_sym_ATf_COLON] = ACTIONS(119),
    [anon_sym_ATs_COLON] = ACTIONS(119),
    [anon_sym_ATv_COLON] = ACTIONS(119),
    [anon_sym_ATx_COLON] = ACTIONS(119),
    [anon_sym_PIPE_DOT] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_GT_GT] = ACTIONS(119),
    [sym_html_redirect_operator] = ACTIONS(121),
    [sym_html_append_operator] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(119),
    [anon_sym_CR] = ACTIONS(119),
    [sym_file_descriptor] = ACTIONS(119),
  },
  [52] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(260),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(153),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_PIPEH] = ACTIONS(153),
    [anon_sym_AT_AT_DOT] = ACTIONS(153),
    [anon_sym_AT_AT_EQ] = ACTIONS(153),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(153),
    [anon_sym_AT_AT] = ACTIONS(155),
    [anon_sym_AT_ATc_COLON] = ACTIONS(153),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(153),
    [anon_sym_AT_ATC] = ACTIONS(153),
    [anon_sym_AT_ATdbt] = ACTIONS(155),
    [anon_sym_AT_ATdbta] = ACTIONS(153),
    [anon_sym_AT_ATdbtb] = ACTIONS(153),
    [anon_sym_AT_ATdbts] = ACTIONS(153),
    [anon_sym_AT_ATt] = ACTIONS(153),
    [anon_sym_AT_ATb] = ACTIONS(153),
    [anon_sym_AT_ATi] = ACTIONS(155),
    [anon_sym_AT_ATii] = ACTIONS(153),
    [anon_sym_AT_ATiS] = ACTIONS(155),
    [anon_sym_AT_ATiSS] = ACTIONS(153),
    [anon_sym_AT_ATis] = ACTIONS(153),
    [anon_sym_AT_ATiz] = ACTIONS(153),
    [anon_sym_AT_ATf] = ACTIONS(153),
    [anon_sym_AT_ATF] = ACTIONS(153),
    [anon_sym_AT_ATom] = ACTIONS(153),
    [anon_sym_AT_ATdm] = ACTIONS(153),
    [anon_sym_AT_ATr] = ACTIONS(153),
    [anon_sym_AT_ATs_COLON] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_AT_BANG] = ACTIONS(153),
    [anon_sym_AT_LPAREN] = ACTIONS(153),
    [anon_sym_RPAREN] = ACTIONS(153),
    [anon_sym_ATa_COLON] = ACTIONS(153),
    [anon_sym_ATb_COLON] = ACTIONS(153),
    [anon_sym_ATB_COLON] = ACTIONS(153),
    [anon_sym_ATe_COLON] = ACTIONS(153),
    [anon_sym_ATF_COLON] = ACTIONS(153),
    [anon_sym_ATi_COLON] = ACTIONS(153),
    [anon_sym_ATk_COLON] = ACTIONS(153),
    [anon_sym_ATo_COLON] = ACTIONS(153),
    [anon_sym_ATr_COLON] = ACTIONS(153),
    [anon_sym_ATf_COLON] = ACTIONS(153),
    [anon_sym_ATs_COLON] = ACTIONS(153),
    [anon_sym_ATv_COLON] = ACTIONS(153),
    [anon_sym_ATx_COLON] = ACTIONS(153),
    [anon_sym_PIPE_DOT] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(153),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_GT_GT] = ACTIONS(153),
    [sym_html_redirect_operator] = ACTIONS(155),
    [sym_html_append_operator] = ACTIONS(153),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(153),
    [anon_sym_CR] = ACTIONS(153),
    [sym_file_descriptor] = ACTIONS(153),
  },
  [53] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(187),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PIPEH] = ACTIONS(157),
    [anon_sym_AT_AT_DOT] = ACTIONS(157),
    [anon_sym_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT] = ACTIONS(159),
    [anon_sym_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_ATC] = ACTIONS(157),
    [anon_sym_AT_ATdbt] = ACTIONS(159),
    [anon_sym_AT_ATdbta] = ACTIONS(157),
    [anon_sym_AT_ATdbtb] = ACTIONS(157),
    [anon_sym_AT_ATdbts] = ACTIONS(157),
    [anon_sym_AT_ATt] = ACTIONS(157),
    [anon_sym_AT_ATb] = ACTIONS(157),
    [anon_sym_AT_ATi] = ACTIONS(159),
    [anon_sym_AT_ATii] = ACTIONS(157),
    [anon_sym_AT_ATiS] = ACTIONS(159),
    [anon_sym_AT_ATiSS] = ACTIONS(157),
    [anon_sym_AT_ATis] = ACTIONS(157),
    [anon_sym_AT_ATiz] = ACTIONS(157),
    [anon_sym_AT_ATf] = ACTIONS(157),
    [anon_sym_AT_ATF] = ACTIONS(157),
    [anon_sym_AT_ATom] = ACTIONS(157),
    [anon_sym_AT_ATdm] = ACTIONS(157),
    [anon_sym_AT_ATr] = ACTIONS(157),
    [anon_sym_AT_ATs_COLON] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_AT_BANG] = ACTIONS(157),
    [anon_sym_AT_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_ATa_COLON] = ACTIONS(157),
    [anon_sym_ATb_COLON] = ACTIONS(157),
    [anon_sym_ATB_COLON] = ACTIONS(157),
    [anon_sym_ATe_COLON] = ACTIONS(157),
    [anon_sym_ATF_COLON] = ACTIONS(157),
    [anon_sym_ATi_COLON] = ACTIONS(157),
    [anon_sym_ATk_COLON] = ACTIONS(157),
    [anon_sym_ATo_COLON] = ACTIONS(157),
    [anon_sym_ATr_COLON] = ACTIONS(157),
    [anon_sym_ATf_COLON] = ACTIONS(157),
    [anon_sym_ATs_COLON] = ACTIONS(157),
    [anon_sym_ATv_COLON] = ACTIONS(157),
    [anon_sym_ATx_COLON] = ACTIONS(157),
    [anon_sym_PIPE_DOT] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(159),
    [anon_sym_GT_GT] = ACTIONS(157),
    [sym_html_redirect_operator] = ACTIONS(159),
    [sym_html_append_operator] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(157),
    [anon_sym_CR] = ACTIONS(157),
    [sym_file_descriptor] = ACTIONS(157),
  },
  [54] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(56),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(56),
    [ts_builtin_sym_end] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(163),
    [anon_sym_PIPEH] = ACTIONS(161),
    [anon_sym_AT_AT_DOT] = ACTIONS(161),
    [anon_sym_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT] = ACTIONS(163),
    [anon_sym_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_ATC] = ACTIONS(161),
    [anon_sym_AT_ATdbt] = ACTIONS(163),
    [anon_sym_AT_ATdbta] = ACTIONS(161),
    [anon_sym_AT_ATdbtb] = ACTIONS(161),
    [anon_sym_AT_ATdbts] = ACTIONS(161),
    [anon_sym_AT_ATt] = ACTIONS(161),
    [anon_sym_AT_ATb] = ACTIONS(161),
    [anon_sym_AT_ATi] = ACTIONS(163),
    [anon_sym_AT_ATii] = ACTIONS(161),
    [anon_sym_AT_ATiS] = ACTIONS(163),
    [anon_sym_AT_ATiSS] = ACTIONS(161),
    [anon_sym_AT_ATis] = ACTIONS(161),
    [anon_sym_AT_ATiz] = ACTIONS(161),
    [anon_sym_AT_ATf] = ACTIONS(161),
    [anon_sym_AT_ATF] = ACTIONS(161),
    [anon_sym_AT_ATom] = ACTIONS(161),
    [anon_sym_AT_ATdm] = ACTIONS(161),
    [anon_sym_AT_ATr] = ACTIONS(161),
    [anon_sym_AT_ATs_COLON] = ACTIONS(161),
    [anon_sym_AT] = ACTIONS(161),
    [anon_sym_AT_BANG] = ACTIONS(161),
    [anon_sym_AT_LPAREN] = ACTIONS(161),
    [anon_sym_RPAREN] = ACTIONS(161),
    [anon_sym_ATa_COLON] = ACTIONS(161),
    [anon_sym_ATb_COLON] = ACTIONS(161),
    [anon_sym_ATB_COLON] = ACTIONS(161),
    [anon_sym_ATe_COLON] = ACTIONS(161),
    [anon_sym_ATF_COLON] = ACTIONS(161),
    [anon_sym_ATi_COLON] = ACTIONS(161),
    [anon_sym_ATk_COLON] = ACTIONS(161),
    [anon_sym_ATo_COLON] = ACTIONS(161),
    [anon_sym_ATr_COLON] = ACTIONS(161),
    [anon_sym_ATf_COLON] = ACTIONS(161),
    [anon_sym_ATs_COLON] = ACTIONS(161),
    [anon_sym_ATv_COLON] = ACTIONS(161),
    [anon_sym_ATx_COLON] = ACTIONS(161),
    [anon_sym_PIPE_DOT] = ACTIONS(161),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(161),
    [sym_html_redirect_operator] = ACTIONS(163),
    [sym_html_append_operator] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(161),
    [anon_sym_CR] = ACTIONS(161),
    [sym_file_descriptor] = ACTIONS(161),
  },
  [55] = {
    [sym__Cf_args] = STATE(202),
    [sym__arg_with_paren] = STATE(386),
    [sym__arg] = STATE(386),
    [sym_arg] = STATE(342),
    [sym_arg_identifier] = STATE(386),
    [sym_double_quoted_arg] = STATE(386),
    [sym_single_quoted_arg] = STATE(386),
    [sym_cmd_substitution_arg] = STATE(386),
    [sym_concatenation] = STATE(413),
    [ts_builtin_sym_end] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(169),
    [anon_sym_PIPEH] = ACTIONS(165),
    [anon_sym_AT_AT_DOT] = ACTIONS(165),
    [anon_sym_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT] = ACTIONS(169),
    [anon_sym_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_ATC] = ACTIONS(165),
    [anon_sym_AT_ATdbt] = ACTIONS(169),
    [anon_sym_AT_ATdbta] = ACTIONS(165),
    [anon_sym_AT_ATdbtb] = ACTIONS(165),
    [anon_sym_AT_ATdbts] = ACTIONS(165),
    [anon_sym_AT_ATt] = ACTIONS(165),
    [anon_sym_AT_ATb] = ACTIONS(165),
    [anon_sym_AT_ATi] = ACTIONS(169),
    [anon_sym_AT_ATii] = ACTIONS(165),
    [anon_sym_AT_ATiS] = ACTIONS(169),
    [anon_sym_AT_ATiSS] = ACTIONS(165),
    [anon_sym_AT_ATis] = ACTIONS(165),
    [anon_sym_AT_ATiz] = ACTIONS(165),
    [anon_sym_AT_ATf] = ACTIONS(165),
    [anon_sym_AT_ATF] = ACTIONS(165),
    [anon_sym_AT_ATom] = ACTIONS(165),
    [anon_sym_AT_ATdm] = ACTIONS(165),
    [anon_sym_AT_ATr] = ACTIONS(165),
    [anon_sym_AT_ATs_COLON] = ACTIONS(165),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_AT_BANG] = ACTIONS(165),
    [anon_sym_AT_LPAREN] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_ATa_COLON] = ACTIONS(165),
    [anon_sym_ATb_COLON] = ACTIONS(165),
    [anon_sym_ATB_COLON] = ACTIONS(165),
    [anon_sym_ATe_COLON] = ACTIONS(165),
    [anon_sym_ATF_COLON] = ACTIONS(165),
    [anon_sym_ATi_COLON] = ACTIONS(165),
    [anon_sym_ATk_COLON] = ACTIONS(165),
    [anon_sym_ATo_COLON] = ACTIONS(165),
    [anon_sym_ATr_COLON] = ACTIONS(165),
    [anon_sym_ATf_COLON] = ACTIONS(165),
    [anon_sym_ATs_COLON] = ACTIONS(165),
    [anon_sym_ATv_COLON] = ACTIONS(165),
    [anon_sym_ATx_COLON] = ACTIONS(165),
    [anon_sym_PIPE_DOT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_SEMI] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(169),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym_html_redirect_operator] = ACTIONS(169),
    [sym_html_append_operator] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_arg_identifier_token1] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(165),
    [anon_sym_CR] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(165),
  },
  [56] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(56),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(56),
    [ts_builtin_sym_end] = ACTIONS(183),
    [anon_sym_DQUOTE] = ACTIONS(185),
    [anon_sym_TILDE] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(188),
    [anon_sym_PIPEH] = ACTIONS(183),
    [anon_sym_AT_AT_DOT] = ACTIONS(183),
    [anon_sym_AT_AT_EQ] = ACTIONS(183),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(183),
    [anon_sym_AT_AT] = ACTIONS(188),
    [anon_sym_AT_ATc_COLON] = ACTIONS(183),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(183),
    [anon_sym_AT_ATC] = ACTIONS(183),
    [anon_sym_AT_ATdbt] = ACTIONS(188),
    [anon_sym_AT_ATdbta] = ACTIONS(183),
    [anon_sym_AT_ATdbtb] = ACTIONS(183),
    [anon_sym_AT_ATdbts] = ACTIONS(183),
    [anon_sym_AT_ATt] = ACTIONS(183),
    [anon_sym_AT_ATb] = ACTIONS(183),
    [anon_sym_AT_ATi] = ACTIONS(188),
    [anon_sym_AT_ATii] = ACTIONS(183),
    [anon_sym_AT_ATiS] = ACTIONS(188),
    [anon_sym_AT_ATiSS] = ACTIONS(183),
    [anon_sym_AT_ATis] = ACTIONS(183),
    [anon_sym_AT_ATiz] = ACTIONS(183),
    [anon_sym_AT_ATf] = ACTIONS(183),
    [anon_sym_AT_ATF] = ACTIONS(183),
    [anon_sym_AT_ATom] = ACTIONS(183),
    [anon_sym_AT_ATdm] = ACTIONS(183),
    [anon_sym_AT_ATr] = ACTIONS(183),
    [anon_sym_AT_ATs_COLON] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(183),
    [anon_sym_AT_BANG] = ACTIONS(183),
    [anon_sym_AT_LPAREN] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_ATa_COLON] = ACTIONS(183),
    [anon_sym_ATb_COLON] = ACTIONS(183),
    [anon_sym_ATB_COLON] = ACTIONS(183),
    [anon_sym_ATe_COLON] = ACTIONS(183),
    [anon_sym_ATF_COLON] = ACTIONS(183),
    [anon_sym_ATi_COLON] = ACTIONS(183),
    [anon_sym_ATk_COLON] = ACTIONS(183),
    [anon_sym_ATo_COLON] = ACTIONS(183),
    [anon_sym_ATr_COLON] = ACTIONS(183),
    [anon_sym_ATf_COLON] = ACTIONS(183),
    [anon_sym_ATs_COLON] = ACTIONS(183),
    [anon_sym_ATv_COLON] = ACTIONS(183),
    [anon_sym_ATx_COLON] = ACTIONS(183),
    [anon_sym_PIPE_DOT] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(190),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_GT] = ACTIONS(188),
    [anon_sym_GT_GT] = ACTIONS(183),
    [sym_html_redirect_operator] = ACTIONS(188),
    [sym_html_append_operator] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(196),
    [aux_sym_arg_identifier_token1] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(202),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(183),
    [anon_sym_CR] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(183),
  },
  [57] = {
    [sym__pf_arg_parentheses] = STATE(102),
    [sym_pf_arg_identifier] = STATE(102),
    [sym__pf_arg] = STATE(102),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(74),
    [sym_pf_args] = STATE(242),
    [sym_cmd_substitution_arg] = STATE(102),
    [aux_sym_pf_args_repeat1] = STATE(74),
    [aux_sym_pf_dot_args_repeat1] = STATE(123),
    [ts_builtin_sym_end] = ACTIONS(208),
    [anon_sym_TILDE] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(210),
    [anon_sym_PIPEH] = ACTIONS(208),
    [anon_sym_AT_AT_DOT] = ACTIONS(208),
    [anon_sym_AT_AT_EQ] = ACTIONS(208),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(208),
    [anon_sym_AT_AT] = ACTIONS(210),
    [anon_sym_AT_ATc_COLON] = ACTIONS(208),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(208),
    [anon_sym_AT_ATC] = ACTIONS(208),
    [anon_sym_AT_ATdbt] = ACTIONS(210),
    [anon_sym_AT_ATdbta] = ACTIONS(208),
    [anon_sym_AT_ATdbtb] = ACTIONS(208),
    [anon_sym_AT_ATdbts] = ACTIONS(208),
    [anon_sym_AT_ATt] = ACTIONS(208),
    [anon_sym_AT_ATb] = ACTIONS(208),
    [anon_sym_AT_ATi] = ACTIONS(210),
    [anon_sym_AT_ATii] = ACTIONS(208),
    [anon_sym_AT_ATiS] = ACTIONS(210),
    [anon_sym_AT_ATiSS] = ACTIONS(208),
    [anon_sym_AT_ATis] = ACTIONS(208),
    [anon_sym_AT_ATiz] = ACTIONS(208),
    [anon_sym_AT_ATf] = ACTIONS(208),
    [anon_sym_AT_ATF] = ACTIONS(208),
    [anon_sym_AT_ATom] = ACTIONS(208),
    [anon_sym_AT_ATdm] = ACTIONS(208),
    [anon_sym_AT_ATr] = ACTIONS(208),
    [anon_sym_AT_ATs_COLON] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(208),
    [anon_sym_AT_BANG] = ACTIONS(208),
    [anon_sym_AT_LPAREN] = ACTIONS(208),
    [anon_sym_RPAREN] = ACTIONS(208),
    [anon_sym_ATa_COLON] = ACTIONS(208),
    [anon_sym_ATb_COLON] = ACTIONS(208),
    [anon_sym_ATB_COLON] = ACTIONS(208),
    [anon_sym_ATe_COLON] = ACTIONS(208),
    [anon_sym_ATF_COLON] = ACTIONS(208),
    [anon_sym_ATi_COLON] = ACTIONS(208),
    [anon_sym_ATk_COLON] = ACTIONS(208),
    [anon_sym_ATo_COLON] = ACTIONS(208),
    [anon_sym_ATr_COLON] = ACTIONS(208),
    [anon_sym_ATf_COLON] = ACTIONS(208),
    [anon_sym_ATs_COLON] = ACTIONS(208),
    [anon_sym_ATv_COLON] = ACTIONS(208),
    [anon_sym_ATx_COLON] = ACTIONS(208),
    [anon_sym_PIPE_DOT] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(212),
    [anon_sym_LPAREN] = ACTIONS(214),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(208),
    [anon_sym_GT] = ACTIONS(210),
    [anon_sym_GT_GT] = ACTIONS(208),
    [sym_html_redirect_operator] = ACTIONS(210),
    [sym_html_append_operator] = ACTIONS(208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(216),
    [anon_sym_BQUOTE] = ACTIONS(218),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(208),
    [anon_sym_CR] = ACTIONS(208),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat_pf_dot] = ACTIONS(220),
  },
  [58] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(208),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(127),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [59] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(264),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(97),
    [anon_sym_PIPEH] = ACTIONS(93),
    [anon_sym_AT_AT_DOT] = ACTIONS(93),
    [anon_sym_AT_AT_EQ] = ACTIONS(93),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(93),
    [anon_sym_AT_AT] = ACTIONS(97),
    [anon_sym_AT_ATc_COLON] = ACTIONS(93),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(93),
    [anon_sym_AT_ATC] = ACTIONS(93),
    [anon_sym_AT_ATdbt] = ACTIONS(97),
    [anon_sym_AT_ATdbta] = ACTIONS(93),
    [anon_sym_AT_ATdbtb] = ACTIONS(93),
    [anon_sym_AT_ATdbts] = ACTIONS(93),
    [anon_sym_AT_ATt] = ACTIONS(93),
    [anon_sym_AT_ATb] = ACTIONS(93),
    [anon_sym_AT_ATi] = ACTIONS(97),
    [anon_sym_AT_ATii] = ACTIONS(93),
    [anon_sym_AT_ATiS] = ACTIONS(97),
    [anon_sym_AT_ATiSS] = ACTIONS(93),
    [anon_sym_AT_ATis] = ACTIONS(93),
    [anon_sym_AT_ATiz] = ACTIONS(93),
    [anon_sym_AT_ATf] = ACTIONS(93),
    [anon_sym_AT_ATF] = ACTIONS(93),
    [anon_sym_AT_ATom] = ACTIONS(93),
    [anon_sym_AT_ATdm] = ACTIONS(93),
    [anon_sym_AT_ATr] = ACTIONS(93),
    [anon_sym_AT_ATs_COLON] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(93),
    [anon_sym_AT_BANG] = ACTIONS(93),
    [anon_sym_AT_LPAREN] = ACTIONS(93),
    [anon_sym_ATa_COLON] = ACTIONS(93),
    [anon_sym_ATb_COLON] = ACTIONS(93),
    [anon_sym_ATB_COLON] = ACTIONS(93),
    [anon_sym_ATe_COLON] = ACTIONS(93),
    [anon_sym_ATF_COLON] = ACTIONS(93),
    [anon_sym_ATi_COLON] = ACTIONS(93),
    [anon_sym_ATk_COLON] = ACTIONS(93),
    [anon_sym_ATo_COLON] = ACTIONS(93),
    [anon_sym_ATr_COLON] = ACTIONS(93),
    [anon_sym_ATf_COLON] = ACTIONS(93),
    [anon_sym_ATs_COLON] = ACTIONS(93),
    [anon_sym_ATv_COLON] = ACTIONS(93),
    [anon_sym_ATx_COLON] = ACTIONS(93),
    [anon_sym_PIPE_DOT] = ACTIONS(93),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(93),
    [sym_html_redirect_operator] = ACTIONS(97),
    [sym_html_append_operator] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(93),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(93),
  },
  [60] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(260),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_PIPEH] = ACTIONS(153),
    [anon_sym_AT_AT_DOT] = ACTIONS(153),
    [anon_sym_AT_AT_EQ] = ACTIONS(153),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(153),
    [anon_sym_AT_AT] = ACTIONS(155),
    [anon_sym_AT_ATc_COLON] = ACTIONS(153),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(153),
    [anon_sym_AT_ATC] = ACTIONS(153),
    [anon_sym_AT_ATdbt] = ACTIONS(155),
    [anon_sym_AT_ATdbta] = ACTIONS(153),
    [anon_sym_AT_ATdbtb] = ACTIONS(153),
    [anon_sym_AT_ATdbts] = ACTIONS(153),
    [anon_sym_AT_ATt] = ACTIONS(153),
    [anon_sym_AT_ATb] = ACTIONS(153),
    [anon_sym_AT_ATi] = ACTIONS(155),
    [anon_sym_AT_ATii] = ACTIONS(153),
    [anon_sym_AT_ATiS] = ACTIONS(155),
    [anon_sym_AT_ATiSS] = ACTIONS(153),
    [anon_sym_AT_ATis] = ACTIONS(153),
    [anon_sym_AT_ATiz] = ACTIONS(153),
    [anon_sym_AT_ATf] = ACTIONS(153),
    [anon_sym_AT_ATF] = ACTIONS(153),
    [anon_sym_AT_ATom] = ACTIONS(153),
    [anon_sym_AT_ATdm] = ACTIONS(153),
    [anon_sym_AT_ATr] = ACTIONS(153),
    [anon_sym_AT_ATs_COLON] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_AT_BANG] = ACTIONS(153),
    [anon_sym_AT_LPAREN] = ACTIONS(153),
    [anon_sym_ATa_COLON] = ACTIONS(153),
    [anon_sym_ATb_COLON] = ACTIONS(153),
    [anon_sym_ATB_COLON] = ACTIONS(153),
    [anon_sym_ATe_COLON] = ACTIONS(153),
    [anon_sym_ATF_COLON] = ACTIONS(153),
    [anon_sym_ATi_COLON] = ACTIONS(153),
    [anon_sym_ATk_COLON] = ACTIONS(153),
    [anon_sym_ATo_COLON] = ACTIONS(153),
    [anon_sym_ATr_COLON] = ACTIONS(153),
    [anon_sym_ATf_COLON] = ACTIONS(153),
    [anon_sym_ATs_COLON] = ACTIONS(153),
    [anon_sym_ATv_COLON] = ACTIONS(153),
    [anon_sym_ATx_COLON] = ACTIONS(153),
    [anon_sym_PIPE_DOT] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(153),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_GT_GT] = ACTIONS(153),
    [sym_html_redirect_operator] = ACTIONS(155),
    [sym_html_append_operator] = ACTIONS(153),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(153),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(153),
  },
  [61] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(209),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(125),
    [anon_sym_PIPEH] = ACTIONS(123),
    [anon_sym_AT_AT_DOT] = ACTIONS(123),
    [anon_sym_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT] = ACTIONS(125),
    [anon_sym_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_ATC] = ACTIONS(123),
    [anon_sym_AT_ATdbt] = ACTIONS(125),
    [anon_sym_AT_ATdbta] = ACTIONS(123),
    [anon_sym_AT_ATdbtb] = ACTIONS(123),
    [anon_sym_AT_ATdbts] = ACTIONS(123),
    [anon_sym_AT_ATt] = ACTIONS(123),
    [anon_sym_AT_ATb] = ACTIONS(123),
    [anon_sym_AT_ATi] = ACTIONS(125),
    [anon_sym_AT_ATii] = ACTIONS(123),
    [anon_sym_AT_ATiS] = ACTIONS(125),
    [anon_sym_AT_ATiSS] = ACTIONS(123),
    [anon_sym_AT_ATis] = ACTIONS(123),
    [anon_sym_AT_ATiz] = ACTIONS(123),
    [anon_sym_AT_ATf] = ACTIONS(123),
    [anon_sym_AT_ATF] = ACTIONS(123),
    [anon_sym_AT_ATom] = ACTIONS(123),
    [anon_sym_AT_ATdm] = ACTIONS(123),
    [anon_sym_AT_ATr] = ACTIONS(123),
    [anon_sym_AT_ATs_COLON] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_AT_BANG] = ACTIONS(123),
    [anon_sym_AT_LPAREN] = ACTIONS(123),
    [anon_sym_ATa_COLON] = ACTIONS(123),
    [anon_sym_ATb_COLON] = ACTIONS(123),
    [anon_sym_ATB_COLON] = ACTIONS(123),
    [anon_sym_ATe_COLON] = ACTIONS(123),
    [anon_sym_ATF_COLON] = ACTIONS(123),
    [anon_sym_ATi_COLON] = ACTIONS(123),
    [anon_sym_ATk_COLON] = ACTIONS(123),
    [anon_sym_ATo_COLON] = ACTIONS(123),
    [anon_sym_ATr_COLON] = ACTIONS(123),
    [anon_sym_ATf_COLON] = ACTIONS(123),
    [anon_sym_ATs_COLON] = ACTIONS(123),
    [anon_sym_ATv_COLON] = ACTIONS(123),
    [anon_sym_ATx_COLON] = ACTIONS(123),
    [anon_sym_PIPE_DOT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym_html_redirect_operator] = ACTIONS(125),
    [sym_html_append_operator] = ACTIONS(123),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(123),
  },
  [62] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(206),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(117),
    [anon_sym_PIPEH] = ACTIONS(115),
    [anon_sym_AT_AT_DOT] = ACTIONS(115),
    [anon_sym_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT] = ACTIONS(117),
    [anon_sym_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_ATC] = ACTIONS(115),
    [anon_sym_AT_ATdbt] = ACTIONS(117),
    [anon_sym_AT_ATdbta] = ACTIONS(115),
    [anon_sym_AT_ATdbtb] = ACTIONS(115),
    [anon_sym_AT_ATdbts] = ACTIONS(115),
    [anon_sym_AT_ATt] = ACTIONS(115),
    [anon_sym_AT_ATb] = ACTIONS(115),
    [anon_sym_AT_ATi] = ACTIONS(117),
    [anon_sym_AT_ATii] = ACTIONS(115),
    [anon_sym_AT_ATiS] = ACTIONS(117),
    [anon_sym_AT_ATiSS] = ACTIONS(115),
    [anon_sym_AT_ATis] = ACTIONS(115),
    [anon_sym_AT_ATiz] = ACTIONS(115),
    [anon_sym_AT_ATf] = ACTIONS(115),
    [anon_sym_AT_ATF] = ACTIONS(115),
    [anon_sym_AT_ATom] = ACTIONS(115),
    [anon_sym_AT_ATdm] = ACTIONS(115),
    [anon_sym_AT_ATr] = ACTIONS(115),
    [anon_sym_AT_ATs_COLON] = ACTIONS(115),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_AT_BANG] = ACTIONS(115),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_ATa_COLON] = ACTIONS(115),
    [anon_sym_ATb_COLON] = ACTIONS(115),
    [anon_sym_ATB_COLON] = ACTIONS(115),
    [anon_sym_ATe_COLON] = ACTIONS(115),
    [anon_sym_ATF_COLON] = ACTIONS(115),
    [anon_sym_ATi_COLON] = ACTIONS(115),
    [anon_sym_ATk_COLON] = ACTIONS(115),
    [anon_sym_ATo_COLON] = ACTIONS(115),
    [anon_sym_ATr_COLON] = ACTIONS(115),
    [anon_sym_ATf_COLON] = ACTIONS(115),
    [anon_sym_ATs_COLON] = ACTIONS(115),
    [anon_sym_ATv_COLON] = ACTIONS(115),
    [anon_sym_ATx_COLON] = ACTIONS(115),
    [anon_sym_PIPE_DOT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(117),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym_html_redirect_operator] = ACTIONS(117),
    [sym_html_append_operator] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(115),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(115),
  },
  [63] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(187),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PIPEH] = ACTIONS(157),
    [anon_sym_AT_AT_DOT] = ACTIONS(157),
    [anon_sym_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT] = ACTIONS(159),
    [anon_sym_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_ATC] = ACTIONS(157),
    [anon_sym_AT_ATdbt] = ACTIONS(159),
    [anon_sym_AT_ATdbta] = ACTIONS(157),
    [anon_sym_AT_ATdbtb] = ACTIONS(157),
    [anon_sym_AT_ATdbts] = ACTIONS(157),
    [anon_sym_AT_ATt] = ACTIONS(157),
    [anon_sym_AT_ATb] = ACTIONS(157),
    [anon_sym_AT_ATi] = ACTIONS(159),
    [anon_sym_AT_ATii] = ACTIONS(157),
    [anon_sym_AT_ATiS] = ACTIONS(159),
    [anon_sym_AT_ATiSS] = ACTIONS(157),
    [anon_sym_AT_ATis] = ACTIONS(157),
    [anon_sym_AT_ATiz] = ACTIONS(157),
    [anon_sym_AT_ATf] = ACTIONS(157),
    [anon_sym_AT_ATF] = ACTIONS(157),
    [anon_sym_AT_ATom] = ACTIONS(157),
    [anon_sym_AT_ATdm] = ACTIONS(157),
    [anon_sym_AT_ATr] = ACTIONS(157),
    [anon_sym_AT_ATs_COLON] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_AT_BANG] = ACTIONS(157),
    [anon_sym_AT_LPAREN] = ACTIONS(157),
    [anon_sym_ATa_COLON] = ACTIONS(157),
    [anon_sym_ATb_COLON] = ACTIONS(157),
    [anon_sym_ATB_COLON] = ACTIONS(157),
    [anon_sym_ATe_COLON] = ACTIONS(157),
    [anon_sym_ATF_COLON] = ACTIONS(157),
    [anon_sym_ATi_COLON] = ACTIONS(157),
    [anon_sym_ATk_COLON] = ACTIONS(157),
    [anon_sym_ATo_COLON] = ACTIONS(157),
    [anon_sym_ATr_COLON] = ACTIONS(157),
    [anon_sym_ATf_COLON] = ACTIONS(157),
    [anon_sym_ATs_COLON] = ACTIONS(157),
    [anon_sym_ATv_COLON] = ACTIONS(157),
    [anon_sym_ATx_COLON] = ACTIONS(157),
    [anon_sym_PIPE_DOT] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(159),
    [anon_sym_GT_GT] = ACTIONS(157),
    [sym_html_redirect_operator] = ACTIONS(159),
    [sym_html_append_operator] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(157),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(157),
  },
  [64] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(268),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_PIPEH] = ACTIONS(111),
    [anon_sym_AT_AT_DOT] = ACTIONS(111),
    [anon_sym_AT_AT_EQ] = ACTIONS(111),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(111),
    [anon_sym_AT_AT] = ACTIONS(113),
    [anon_sym_AT_ATc_COLON] = ACTIONS(111),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(111),
    [anon_sym_AT_ATC] = ACTIONS(111),
    [anon_sym_AT_ATdbt] = ACTIONS(113),
    [anon_sym_AT_ATdbta] = ACTIONS(111),
    [anon_sym_AT_ATdbtb] = ACTIONS(111),
    [anon_sym_AT_ATdbts] = ACTIONS(111),
    [anon_sym_AT_ATt] = ACTIONS(111),
    [anon_sym_AT_ATb] = ACTIONS(111),
    [anon_sym_AT_ATi] = ACTIONS(113),
    [anon_sym_AT_ATii] = ACTIONS(111),
    [anon_sym_AT_ATiS] = ACTIONS(113),
    [anon_sym_AT_ATiSS] = ACTIONS(111),
    [anon_sym_AT_ATis] = ACTIONS(111),
    [anon_sym_AT_ATiz] = ACTIONS(111),
    [anon_sym_AT_ATf] = ACTIONS(111),
    [anon_sym_AT_ATF] = ACTIONS(111),
    [anon_sym_AT_ATom] = ACTIONS(111),
    [anon_sym_AT_ATdm] = ACTIONS(111),
    [anon_sym_AT_ATr] = ACTIONS(111),
    [anon_sym_AT_ATs_COLON] = ACTIONS(111),
    [anon_sym_AT] = ACTIONS(111),
    [anon_sym_AT_BANG] = ACTIONS(111),
    [anon_sym_AT_LPAREN] = ACTIONS(111),
    [anon_sym_ATa_COLON] = ACTIONS(111),
    [anon_sym_ATb_COLON] = ACTIONS(111),
    [anon_sym_ATB_COLON] = ACTIONS(111),
    [anon_sym_ATe_COLON] = ACTIONS(111),
    [anon_sym_ATF_COLON] = ACTIONS(111),
    [anon_sym_ATi_COLON] = ACTIONS(111),
    [anon_sym_ATk_COLON] = ACTIONS(111),
    [anon_sym_ATo_COLON] = ACTIONS(111),
    [anon_sym_ATr_COLON] = ACTIONS(111),
    [anon_sym_ATf_COLON] = ACTIONS(111),
    [anon_sym_ATs_COLON] = ACTIONS(111),
    [anon_sym_ATv_COLON] = ACTIONS(111),
    [anon_sym_ATx_COLON] = ACTIONS(111),
    [anon_sym_PIPE_DOT] = ACTIONS(111),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(111),
    [sym_html_redirect_operator] = ACTIONS(113),
    [sym_html_append_operator] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(111),
  },
  [65] = {
    [sym_macro_content] = STATE(132),
    [sym_macro_args] = STATE(215),
    [sym__arg_with_paren] = STATE(326),
    [sym__arg] = STATE(326),
    [sym_arg] = STATE(281),
    [sym_arg_identifier] = STATE(326),
    [sym_double_quoted_arg] = STATE(326),
    [sym_single_quoted_arg] = STATE(326),
    [sym_cmd_substitution_arg] = STATE(326),
    [sym_concatenation] = STATE(347),
    [anon_sym_DQUOTE] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(139),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(139),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(139),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(139),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(135),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(139),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(145),
    [aux_sym_arg_identifier_token1] = ACTIONS(141),
    [anon_sym_SQUOTE] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [66] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(213),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(121),
    [anon_sym_PIPEH] = ACTIONS(119),
    [anon_sym_AT_AT_DOT] = ACTIONS(119),
    [anon_sym_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT] = ACTIONS(121),
    [anon_sym_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_ATC] = ACTIONS(119),
    [anon_sym_AT_ATdbt] = ACTIONS(121),
    [anon_sym_AT_ATdbta] = ACTIONS(119),
    [anon_sym_AT_ATdbtb] = ACTIONS(119),
    [anon_sym_AT_ATdbts] = ACTIONS(119),
    [anon_sym_AT_ATt] = ACTIONS(119),
    [anon_sym_AT_ATb] = ACTIONS(119),
    [anon_sym_AT_ATi] = ACTIONS(121),
    [anon_sym_AT_ATii] = ACTIONS(119),
    [anon_sym_AT_ATiS] = ACTIONS(121),
    [anon_sym_AT_ATiSS] = ACTIONS(119),
    [anon_sym_AT_ATis] = ACTIONS(119),
    [anon_sym_AT_ATiz] = ACTIONS(119),
    [anon_sym_AT_ATf] = ACTIONS(119),
    [anon_sym_AT_ATF] = ACTIONS(119),
    [anon_sym_AT_ATom] = ACTIONS(119),
    [anon_sym_AT_ATdm] = ACTIONS(119),
    [anon_sym_AT_ATr] = ACTIONS(119),
    [anon_sym_AT_ATs_COLON] = ACTIONS(119),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_AT_BANG] = ACTIONS(119),
    [anon_sym_AT_LPAREN] = ACTIONS(119),
    [anon_sym_ATa_COLON] = ACTIONS(119),
    [anon_sym_ATb_COLON] = ACTIONS(119),
    [anon_sym_ATB_COLON] = ACTIONS(119),
    [anon_sym_ATe_COLON] = ACTIONS(119),
    [anon_sym_ATF_COLON] = ACTIONS(119),
    [anon_sym_ATi_COLON] = ACTIONS(119),
    [anon_sym_ATk_COLON] = ACTIONS(119),
    [anon_sym_ATo_COLON] = ACTIONS(119),
    [anon_sym_ATr_COLON] = ACTIONS(119),
    [anon_sym_ATf_COLON] = ACTIONS(119),
    [anon_sym_ATs_COLON] = ACTIONS(119),
    [anon_sym_ATv_COLON] = ACTIONS(119),
    [anon_sym_ATx_COLON] = ACTIONS(119),
    [anon_sym_PIPE_DOT] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_GT_GT] = ACTIONS(119),
    [sym_html_redirect_operator] = ACTIONS(121),
    [sym_html_append_operator] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(119),
  },
  [67] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(196),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [68] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(194),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(121),
    [anon_sym_PIPEH] = ACTIONS(119),
    [anon_sym_AT_AT_DOT] = ACTIONS(119),
    [anon_sym_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT] = ACTIONS(121),
    [anon_sym_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_ATC] = ACTIONS(119),
    [anon_sym_AT_ATdbt] = ACTIONS(121),
    [anon_sym_AT_ATdbta] = ACTIONS(119),
    [anon_sym_AT_ATdbtb] = ACTIONS(119),
    [anon_sym_AT_ATdbts] = ACTIONS(119),
    [anon_sym_AT_ATt] = ACTIONS(119),
    [anon_sym_AT_ATb] = ACTIONS(119),
    [anon_sym_AT_ATi] = ACTIONS(121),
    [anon_sym_AT_ATii] = ACTIONS(119),
    [anon_sym_AT_ATiS] = ACTIONS(121),
    [anon_sym_AT_ATiSS] = ACTIONS(119),
    [anon_sym_AT_ATis] = ACTIONS(119),
    [anon_sym_AT_ATiz] = ACTIONS(119),
    [anon_sym_AT_ATf] = ACTIONS(119),
    [anon_sym_AT_ATF] = ACTIONS(119),
    [anon_sym_AT_ATom] = ACTIONS(119),
    [anon_sym_AT_ATdm] = ACTIONS(119),
    [anon_sym_AT_ATr] = ACTIONS(119),
    [anon_sym_AT_ATs_COLON] = ACTIONS(119),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_AT_BANG] = ACTIONS(119),
    [anon_sym_AT_LPAREN] = ACTIONS(119),
    [anon_sym_ATa_COLON] = ACTIONS(119),
    [anon_sym_ATb_COLON] = ACTIONS(119),
    [anon_sym_ATB_COLON] = ACTIONS(119),
    [anon_sym_ATe_COLON] = ACTIONS(119),
    [anon_sym_ATF_COLON] = ACTIONS(119),
    [anon_sym_ATi_COLON] = ACTIONS(119),
    [anon_sym_ATk_COLON] = ACTIONS(119),
    [anon_sym_ATo_COLON] = ACTIONS(119),
    [anon_sym_ATr_COLON] = ACTIONS(119),
    [anon_sym_ATf_COLON] = ACTIONS(119),
    [anon_sym_ATs_COLON] = ACTIONS(119),
    [anon_sym_ATv_COLON] = ACTIONS(119),
    [anon_sym_ATx_COLON] = ACTIONS(119),
    [anon_sym_PIPE_DOT] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_GT_GT] = ACTIONS(119),
    [sym_html_redirect_operator] = ACTIONS(121),
    [sym_html_append_operator] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(119),
  },
  [69] = {
    [sym__arg_with_paren] = STATE(78),
    [sym__arg] = STATE(78),
    [sym_arg] = STATE(56),
    [sym_arg_identifier] = STATE(78),
    [sym_double_quoted_arg] = STATE(78),
    [sym_single_quoted_arg] = STATE(78),
    [sym_cmd_substitution_arg] = STATE(78),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(56),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(163),
    [anon_sym_PIPEH] = ACTIONS(161),
    [anon_sym_AT_AT_DOT] = ACTIONS(161),
    [anon_sym_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT] = ACTIONS(163),
    [anon_sym_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_ATC] = ACTIONS(161),
    [anon_sym_AT_ATdbt] = ACTIONS(163),
    [anon_sym_AT_ATdbta] = ACTIONS(161),
    [anon_sym_AT_ATdbtb] = ACTIONS(161),
    [anon_sym_AT_ATdbts] = ACTIONS(161),
    [anon_sym_AT_ATt] = ACTIONS(161),
    [anon_sym_AT_ATb] = ACTIONS(161),
    [anon_sym_AT_ATi] = ACTIONS(163),
    [anon_sym_AT_ATii] = ACTIONS(161),
    [anon_sym_AT_ATiS] = ACTIONS(163),
    [anon_sym_AT_ATiSS] = ACTIONS(161),
    [anon_sym_AT_ATis] = ACTIONS(161),
    [anon_sym_AT_ATiz] = ACTIONS(161),
    [anon_sym_AT_ATf] = ACTIONS(161),
    [anon_sym_AT_ATF] = ACTIONS(161),
    [anon_sym_AT_ATom] = ACTIONS(161),
    [anon_sym_AT_ATdm] = ACTIONS(161),
    [anon_sym_AT_ATr] = ACTIONS(161),
    [anon_sym_AT_ATs_COLON] = ACTIONS(161),
    [anon_sym_AT] = ACTIONS(161),
    [anon_sym_AT_BANG] = ACTIONS(161),
    [anon_sym_AT_LPAREN] = ACTIONS(161),
    [anon_sym_ATa_COLON] = ACTIONS(161),
    [anon_sym_ATb_COLON] = ACTIONS(161),
    [anon_sym_ATB_COLON] = ACTIONS(161),
    [anon_sym_ATe_COLON] = ACTIONS(161),
    [anon_sym_ATF_COLON] = ACTIONS(161),
    [anon_sym_ATi_COLON] = ACTIONS(161),
    [anon_sym_ATk_COLON] = ACTIONS(161),
    [anon_sym_ATo_COLON] = ACTIONS(161),
    [anon_sym_ATr_COLON] = ACTIONS(161),
    [anon_sym_ATf_COLON] = ACTIONS(161),
    [anon_sym_ATs_COLON] = ACTIONS(161),
    [anon_sym_ATv_COLON] = ACTIONS(161),
    [anon_sym_ATx_COLON] = ACTIONS(161),
    [anon_sym_PIPE_DOT] = ACTIONS(161),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(161),
    [sym_html_redirect_operator] = ACTIONS(163),
    [sym_html_append_operator] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(103),
    [aux_sym_arg_identifier_token1] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(161),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(161),
  },
  [70] = {
    [sym__Cf_args] = STATE(202),
    [sym__arg_with_paren] = STATE(386),
    [sym__arg] = STATE(386),
    [sym_arg] = STATE(344),
    [sym_arg_identifier] = STATE(386),
    [sym_double_quoted_arg] = STATE(386),
    [sym_single_quoted_arg] = STATE(386),
    [sym_cmd_substitution_arg] = STATE(386),
    [sym_concatenation] = STATE(413),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(169),
    [anon_sym_PIPEH] = ACTIONS(165),
    [anon_sym_AT_AT_DOT] = ACTIONS(165),
    [anon_sym_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT] = ACTIONS(169),
    [anon_sym_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_ATC] = ACTIONS(165),
    [anon_sym_AT_ATdbt] = ACTIONS(169),
    [anon_sym_AT_ATdbta] = ACTIONS(165),
    [anon_sym_AT_ATdbtb] = ACTIONS(165),
    [anon_sym_AT_ATdbts] = ACTIONS(165),
    [anon_sym_AT_ATt] = ACTIONS(165),
    [anon_sym_AT_ATb] = ACTIONS(165),
    [anon_sym_AT_ATi] = ACTIONS(169),
    [anon_sym_AT_ATii] = ACTIONS(165),
    [anon_sym_AT_ATiS] = ACTIONS(169),
    [anon_sym_AT_ATiSS] = ACTIONS(165),
    [anon_sym_AT_ATis] = ACTIONS(165),
    [anon_sym_AT_ATiz] = ACTIONS(165),
    [anon_sym_AT_ATf] = ACTIONS(165),
    [anon_sym_AT_ATF] = ACTIONS(165),
    [anon_sym_AT_ATom] = ACTIONS(165),
    [anon_sym_AT_ATdm] = ACTIONS(165),
    [anon_sym_AT_ATr] = ACTIONS(165),
    [anon_sym_AT_ATs_COLON] = ACTIONS(165),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_AT_BANG] = ACTIONS(165),
    [anon_sym_AT_LPAREN] = ACTIONS(165),
    [anon_sym_ATa_COLON] = ACTIONS(165),
    [anon_sym_ATb_COLON] = ACTIONS(165),
    [anon_sym_ATB_COLON] = ACTIONS(165),
    [anon_sym_ATe_COLON] = ACTIONS(165),
    [anon_sym_ATF_COLON] = ACTIONS(165),
    [anon_sym_ATi_COLON] = ACTIONS(165),
    [anon_sym_ATk_COLON] = ACTIONS(165),
    [anon_sym_ATo_COLON] = ACTIONS(165),
    [anon_sym_ATr_COLON] = ACTIONS(165),
    [anon_sym_ATf_COLON] = ACTIONS(165),
    [anon_sym_ATs_COLON] = ACTIONS(165),
    [anon_sym_ATv_COLON] = ACTIONS(165),
    [anon_sym_ATx_COLON] = ACTIONS(165),
    [anon_sym_PIPE_DOT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_SEMI] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(169),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym_html_redirect_operator] = ACTIONS(169),
    [sym_html_append_operator] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_arg_identifier_token1] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(165),
  },
  [71] = {
    [sym__pf_arg_parentheses] = STATE(102),
    [sym_pf_arg_identifier] = STATE(102),
    [sym__pf_arg] = STATE(102),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(97),
    [sym_pf_args] = STATE(242),
    [sym_cmd_substitution_arg] = STATE(102),
    [aux_sym_pf_args_repeat1] = STATE(97),
    [aux_sym_pf_dot_args_repeat1] = STATE(123),
    [anon_sym_TILDE] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(210),
    [anon_sym_PIPEH] = ACTIONS(208),
    [anon_sym_AT_AT_DOT] = ACTIONS(208),
    [anon_sym_AT_AT_EQ] = ACTIONS(208),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(208),
    [anon_sym_AT_AT] = ACTIONS(210),
    [anon_sym_AT_ATc_COLON] = ACTIONS(208),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(208),
    [anon_sym_AT_ATC] = ACTIONS(208),
    [anon_sym_AT_ATdbt] = ACTIONS(210),
    [anon_sym_AT_ATdbta] = ACTIONS(208),
    [anon_sym_AT_ATdbtb] = ACTIONS(208),
    [anon_sym_AT_ATdbts] = ACTIONS(208),
    [anon_sym_AT_ATt] = ACTIONS(208),
    [anon_sym_AT_ATb] = ACTIONS(208),
    [anon_sym_AT_ATi] = ACTIONS(210),
    [anon_sym_AT_ATii] = ACTIONS(208),
    [anon_sym_AT_ATiS] = ACTIONS(210),
    [anon_sym_AT_ATiSS] = ACTIONS(208),
    [anon_sym_AT_ATis] = ACTIONS(208),
    [anon_sym_AT_ATiz] = ACTIONS(208),
    [anon_sym_AT_ATf] = ACTIONS(208),
    [anon_sym_AT_ATF] = ACTIONS(208),
    [anon_sym_AT_ATom] = ACTIONS(208),
    [anon_sym_AT_ATdm] = ACTIONS(208),
    [anon_sym_AT_ATr] = ACTIONS(208),
    [anon_sym_AT_ATs_COLON] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(208),
    [anon_sym_AT_BANG] = ACTIONS(208),
    [anon_sym_AT_LPAREN] = ACTIONS(208),
    [anon_sym_ATa_COLON] = ACTIONS(208),
    [anon_sym_ATb_COLON] = ACTIONS(208),
    [anon_sym_ATB_COLON] = ACTIONS(208),
    [anon_sym_ATe_COLON] = ACTIONS(208),
    [anon_sym_ATF_COLON] = ACTIONS(208),
    [anon_sym_ATi_COLON] = ACTIONS(208),
    [anon_sym_ATk_COLON] = ACTIONS(208),
    [anon_sym_ATo_COLON] = ACTIONS(208),
    [anon_sym_ATr_COLON] = ACTIONS(208),
    [anon_sym_ATf_COLON] = ACTIONS(208),
    [anon_sym_ATs_COLON] = ACTIONS(208),
    [anon_sym_ATv_COLON] = ACTIONS(208),
    [anon_sym_ATx_COLON] = ACTIONS(208),
    [anon_sym_PIPE_DOT] = ACTIONS(208),
    [anon_sym_EQ] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(212),
    [anon_sym_LPAREN] = ACTIONS(214),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(208),
    [anon_sym_GT] = ACTIONS(210),
    [anon_sym_GT_GT] = ACTIONS(208),
    [sym_html_redirect_operator] = ACTIONS(210),
    [sym_html_append_operator] = ACTIONS(208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(216),
    [anon_sym_BQUOTE] = ACTIONS(208),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(208),
    [sym__concat_pf_dot] = ACTIONS(220),
  },
  [72] = {
    [sym_eq_sep_args] = STATE(239),
    [sym__eq_sep_key_single] = STATE(131),
    [sym__eq_sep_key_concatenation] = STATE(169),
    [sym__eq_sep_key] = STATE(168),
    [sym_double_quoted_arg] = STATE(131),
    [sym_single_quoted_arg] = STATE(131),
    [sym_cmd_substitution_arg] = STATE(131),
    [ts_builtin_sym_end] = ACTIONS(222),
    [anon_sym_DQUOTE] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(222),
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_PIPEH] = ACTIONS(222),
    [anon_sym_AT_AT_DOT] = ACTIONS(222),
    [anon_sym_AT_AT_EQ] = ACTIONS(222),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(222),
    [anon_sym_AT_AT] = ACTIONS(226),
    [anon_sym_AT_ATc_COLON] = ACTIONS(222),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(222),
    [anon_sym_AT_ATC] = ACTIONS(222),
    [anon_sym_AT_ATdbt] = ACTIONS(226),
    [anon_sym_AT_ATdbta] = ACTIONS(222),
    [anon_sym_AT_ATdbtb] = ACTIONS(222),
    [anon_sym_AT_ATdbts] = ACTIONS(222),
    [anon_sym_AT_ATt] = ACTIONS(222),
    [anon_sym_AT_ATb] = ACTIONS(222),
    [anon_sym_AT_ATi] = ACTIONS(226),
    [anon_sym_AT_ATii] = ACTIONS(222),
    [anon_sym_AT_ATiS] = ACTIONS(226),
    [anon_sym_AT_ATiSS] = ACTIONS(222),
    [anon_sym_AT_ATis] = ACTIONS(222),
    [anon_sym_AT_ATiz] = ACTIONS(222),
    [anon_sym_AT_ATf] = ACTIONS(222),
    [anon_sym_AT_ATF] = ACTIONS(222),
    [anon_sym_AT_ATom] = ACTIONS(222),
    [anon_sym_AT_ATdm] = ACTIONS(222),
    [anon_sym_AT_ATr] = ACTIONS(222),
    [anon_sym_AT_ATs_COLON] = ACTIONS(222),
    [anon_sym_AT] = ACTIONS(222),
    [anon_sym_AT_BANG] = ACTIONS(222),
    [anon_sym_AT_LPAREN] = ACTIONS(222),
    [anon_sym_RPAREN] = ACTIONS(222),
    [anon_sym_ATa_COLON] = ACTIONS(222),
    [anon_sym_ATb_COLON] = ACTIONS(222),
    [anon_sym_ATB_COLON] = ACTIONS(222),
    [anon_sym_ATe_COLON] = ACTIONS(222),
    [anon_sym_ATF_COLON] = ACTIONS(222),
    [anon_sym_ATi_COLON] = ACTIONS(222),
    [anon_sym_ATk_COLON] = ACTIONS(222),
    [anon_sym_ATo_COLON] = ACTIONS(222),
    [anon_sym_ATr_COLON] = ACTIONS(222),
    [anon_sym_ATf_COLON] = ACTIONS(222),
    [anon_sym_ATs_COLON] = ACTIONS(222),
    [anon_sym_ATv_COLON] = ACTIONS(222),
    [anon_sym_ATx_COLON] = ACTIONS(222),
    [anon_sym_PIPE_DOT] = ACTIONS(222),
    [anon_sym_SEMI] = ACTIONS(222),
    [anon_sym_GT] = ACTIONS(226),
    [anon_sym_GT_GT] = ACTIONS(222),
    [sym_html_redirect_operator] = ACTIONS(226),
    [sym_html_append_operator] = ACTIONS(222),
    [sym__eq_sep_key_identifier] = ACTIONS(228),
    [anon_sym_SQUOTE] = ACTIONS(230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(232),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(222),
    [anon_sym_CR] = ACTIONS(222),
    [sym_file_descriptor] = ACTIONS(222),
  },
  [73] = {
    [sym__pf_arg_parentheses] = STATE(102),
    [sym_pf_arg_identifier] = STATE(102),
    [sym__pf_arg] = STATE(102),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(102),
    [aux_sym_pf_args_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_PIPEH] = ACTIONS(236),
    [anon_sym_AT_AT_DOT] = ACTIONS(236),
    [anon_sym_AT_AT_EQ] = ACTIONS(236),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(236),
    [anon_sym_AT_AT] = ACTIONS(238),
    [anon_sym_AT_ATc_COLON] = ACTIONS(236),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(236),
    [anon_sym_AT_ATC] = ACTIONS(236),
    [anon_sym_AT_ATdbt] = ACTIONS(238),
    [anon_sym_AT_ATdbta] = ACTIONS(236),
    [anon_sym_AT_ATdbtb] = ACTIONS(236),
    [anon_sym_AT_ATdbts] = ACTIONS(236),
    [anon_sym_AT_ATt] = ACTIONS(236),
    [anon_sym_AT_ATb] = ACTIONS(236),
    [anon_sym_AT_ATi] = ACTIONS(238),
    [anon_sym_AT_ATii] = ACTIONS(236),
    [anon_sym_AT_ATiS] = ACTIONS(238),
    [anon_sym_AT_ATiSS] = ACTIONS(236),
    [anon_sym_AT_ATis] = ACTIONS(236),
    [anon_sym_AT_ATiz] = ACTIONS(236),
    [anon_sym_AT_ATf] = ACTIONS(236),
    [anon_sym_AT_ATF] = ACTIONS(236),
    [anon_sym_AT_ATom] = ACTIONS(236),
    [anon_sym_AT_ATdm] = ACTIONS(236),
    [anon_sym_AT_ATr] = ACTIONS(236),
    [anon_sym_AT_ATs_COLON] = ACTIONS(236),
    [anon_sym_AT] = ACTIONS(236),
    [anon_sym_AT_BANG] = ACTIONS(236),
    [anon_sym_AT_LPAREN] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_ATa_COLON] = ACTIONS(236),
    [anon_sym_ATb_COLON] = ACTIONS(236),
    [anon_sym_ATB_COLON] = ACTIONS(236),
    [anon_sym_ATe_COLON] = ACTIONS(236),
    [anon_sym_ATF_COLON] = ACTIONS(236),
    [anon_sym_ATi_COLON] = ACTIONS(236),
    [anon_sym_ATk_COLON] = ACTIONS(236),
    [anon_sym_ATo_COLON] = ACTIONS(236),
    [anon_sym_ATr_COLON] = ACTIONS(236),
    [anon_sym_ATf_COLON] = ACTIONS(236),
    [anon_sym_ATs_COLON] = ACTIONS(236),
    [anon_sym_ATv_COLON] = ACTIONS(236),
    [anon_sym_ATx_COLON] = ACTIONS(236),
    [anon_sym_PIPE_DOT] = ACTIONS(236),
    [anon_sym_DOLLAR] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(243),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(240),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(236),
    [sym_html_redirect_operator] = ACTIONS(238),
    [sym_html_append_operator] = ACTIONS(236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(246),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(236),
    [anon_sym_CR] = ACTIONS(236),
    [sym_file_descriptor] = ACTIONS(236),
  },
  [74] = {
    [sym__pf_arg_parentheses] = STATE(102),
    [sym_pf_arg_identifier] = STATE(102),
    [sym__pf_arg] = STATE(102),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(102),
    [aux_sym_pf_args_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(252),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PIPEH] = ACTIONS(252),
    [anon_sym_AT_AT_DOT] = ACTIONS(252),
    [anon_sym_AT_AT_EQ] = ACTIONS(252),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(252),
    [anon_sym_AT_AT] = ACTIONS(254),
    [anon_sym_AT_ATc_COLON] = ACTIONS(252),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(252),
    [anon_sym_AT_ATC] = ACTIONS(252),
    [anon_sym_AT_ATdbt] = ACTIONS(254),
    [anon_sym_AT_ATdbta] = ACTIONS(252),
    [anon_sym_AT_ATdbtb] = ACTIONS(252),
    [anon_sym_AT_ATdbts] = ACTIONS(252),
    [anon_sym_AT_ATt] = ACTIONS(252),
    [anon_sym_AT_ATb] = ACTIONS(252),
    [anon_sym_AT_ATi] = ACTIONS(254),
    [anon_sym_AT_ATii] = ACTIONS(252),
    [anon_sym_AT_ATiS] = ACTIONS(254),
    [anon_sym_AT_ATiSS] = ACTIONS(252),
    [anon_sym_AT_ATis] = ACTIONS(252),
    [anon_sym_AT_ATiz] = ACTIONS(252),
    [anon_sym_AT_ATf] = ACTIONS(252),
    [anon_sym_AT_ATF] = ACTIONS(252),
    [anon_sym_AT_ATom] = ACTIONS(252),
    [anon_sym_AT_ATdm] = ACTIONS(252),
    [anon_sym_AT_ATr] = ACTIONS(252),
    [anon_sym_AT_ATs_COLON] = ACTIONS(252),
    [anon_sym_AT] = ACTIONS(252),
    [anon_sym_AT_BANG] = ACTIONS(252),
    [anon_sym_AT_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_ATa_COLON] = ACTIONS(252),
    [anon_sym_ATb_COLON] = ACTIONS(252),
    [anon_sym_ATB_COLON] = ACTIONS(252),
    [anon_sym_ATe_COLON] = ACTIONS(252),
    [anon_sym_ATF_COLON] = ACTIONS(252),
    [anon_sym_ATi_COLON] = ACTIONS(252),
    [anon_sym_ATk_COLON] = ACTIONS(252),
    [anon_sym_ATo_COLON] = ACTIONS(252),
    [anon_sym_ATr_COLON] = ACTIONS(252),
    [anon_sym_ATf_COLON] = ACTIONS(252),
    [anon_sym_ATs_COLON] = ACTIONS(252),
    [anon_sym_ATv_COLON] = ACTIONS(252),
    [anon_sym_ATx_COLON] = ACTIONS(252),
    [anon_sym_PIPE_DOT] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(212),
    [anon_sym_LPAREN] = ACTIONS(214),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [sym_html_redirect_operator] = ACTIONS(254),
    [sym_html_append_operator] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(216),
    [anon_sym_BQUOTE] = ACTIONS(218),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(252),
    [anon_sym_CR] = ACTIONS(252),
    [sym_file_descriptor] = ACTIONS(252),
  },
  [75] = {
    [sym_specifiers] = STATE(95),
    [aux_sym_specifiers_repeat1] = STATE(76),
    [ts_builtin_sym_end] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_PIPEH] = ACTIONS(256),
    [anon_sym_AT_AT_DOT] = ACTIONS(256),
    [anon_sym_AT_AT_EQ] = ACTIONS(256),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(256),
    [anon_sym_AT_AT] = ACTIONS(258),
    [anon_sym_AT_ATc_COLON] = ACTIONS(256),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(256),
    [anon_sym_AT_ATC] = ACTIONS(256),
    [anon_sym_AT_ATdbt] = ACTIONS(258),
    [anon_sym_AT_ATdbta] = ACTIONS(256),
    [anon_sym_AT_ATdbtb] = ACTIONS(256),
    [anon_sym_AT_ATdbts] = ACTIONS(256),
    [anon_sym_AT_ATt] = ACTIONS(256),
    [anon_sym_AT_ATb] = ACTIONS(256),
    [anon_sym_AT_ATi] = ACTIONS(258),
    [anon_sym_AT_ATii] = ACTIONS(256),
    [anon_sym_AT_ATiS] = ACTIONS(258),
    [anon_sym_AT_ATiSS] = ACTIONS(256),
    [anon_sym_AT_ATis] = ACTIONS(256),
    [anon_sym_AT_ATiz] = ACTIONS(256),
    [anon_sym_AT_ATf] = ACTIONS(256),
    [anon_sym_AT_ATF] = ACTIONS(256),
    [anon_sym_AT_ATom] = ACTIONS(256),
    [anon_sym_AT_ATdm] = ACTIONS(256),
    [anon_sym_AT_ATr] = ACTIONS(256),
    [anon_sym_AT_ATs_COLON] = ACTIONS(256),
    [anon_sym_AT] = ACTIONS(256),
    [anon_sym_AT_BANG] = ACTIONS(256),
    [anon_sym_AT_LPAREN] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_ATa_COLON] = ACTIONS(256),
    [anon_sym_ATb_COLON] = ACTIONS(256),
    [anon_sym_ATB_COLON] = ACTIONS(256),
    [anon_sym_ATe_COLON] = ACTIONS(256),
    [anon_sym_ATF_COLON] = ACTIONS(256),
    [anon_sym_ATi_COLON] = ACTIONS(256),
    [anon_sym_ATk_COLON] = ACTIONS(256),
    [anon_sym_ATo_COLON] = ACTIONS(256),
    [anon_sym_ATr_COLON] = ACTIONS(256),
    [anon_sym_ATf_COLON] = ACTIONS(256),
    [anon_sym_ATs_COLON] = ACTIONS(256),
    [anon_sym_ATv_COLON] = ACTIONS(256),
    [anon_sym_ATx_COLON] = ACTIONS(256),
    [anon_sym_PIPE_DOT] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(256),
    [sym_html_redirect_operator] = ACTIONS(258),
    [sym_html_append_operator] = ACTIONS(256),
    [anon_sym_COMMA] = ACTIONS(256),
    [aux_sym_arg_identifier_token1] = ACTIONS(258),
    [anon_sym_SQUOTE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(256),
    [anon_sym_CR] = ACTIONS(256),
    [sym_file_descriptor] = ACTIONS(256),
    [sym__spec_sep] = ACTIONS(260),
  },
  [76] = {
    [aux_sym_specifiers_repeat1] = STATE(77),
    [ts_builtin_sym_end] = ACTIONS(262),
    [anon_sym_DQUOTE] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(262),
    [anon_sym_PIPE] = ACTIONS(264),
    [anon_sym_PIPEH] = ACTIONS(262),
    [anon_sym_AT_AT_DOT] = ACTIONS(262),
    [anon_sym_AT_AT_EQ] = ACTIONS(262),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(262),
    [anon_sym_AT_AT] = ACTIONS(264),
    [anon_sym_AT_ATc_COLON] = ACTIONS(262),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(262),
    [anon_sym_AT_ATC] = ACTIONS(262),
    [anon_sym_AT_ATdbt] = ACTIONS(264),
    [anon_sym_AT_ATdbta] = ACTIONS(262),
    [anon_sym_AT_ATdbtb] = ACTIONS(262),
    [anon_sym_AT_ATdbts] = ACTIONS(262),
    [anon_sym_AT_ATt] = ACTIONS(262),
    [anon_sym_AT_ATb] = ACTIONS(262),
    [anon_sym_AT_ATi] = ACTIONS(264),
    [anon_sym_AT_ATii] = ACTIONS(262),
    [anon_sym_AT_ATiS] = ACTIONS(264),
    [anon_sym_AT_ATiSS] = ACTIONS(262),
    [anon_sym_AT_ATis] = ACTIONS(262),
    [anon_sym_AT_ATiz] = ACTIONS(262),
    [anon_sym_AT_ATf] = ACTIONS(262),
    [anon_sym_AT_ATF] = ACTIONS(262),
    [anon_sym_AT_ATom] = ACTIONS(262),
    [anon_sym_AT_ATdm] = ACTIONS(262),
    [anon_sym_AT_ATr] = ACTIONS(262),
    [anon_sym_AT_ATs_COLON] = ACTIONS(262),
    [anon_sym_AT] = ACTIONS(262),
    [anon_sym_AT_BANG] = ACTIONS(262),
    [anon_sym_AT_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(262),
    [anon_sym_ATa_COLON] = ACTIONS(262),
    [anon_sym_ATb_COLON] = ACTIONS(262),
    [anon_sym_ATB_COLON] = ACTIONS(262),
    [anon_sym_ATe_COLON] = ACTIONS(262),
    [anon_sym_ATF_COLON] = ACTIONS(262),
    [anon_sym_ATi_COLON] = ACTIONS(262),
    [anon_sym_ATk_COLON] = ACTIONS(262),
    [anon_sym_ATo_COLON] = ACTIONS(262),
    [anon_sym_ATr_COLON] = ACTIONS(262),
    [anon_sym_ATf_COLON] = ACTIONS(262),
    [anon_sym_ATs_COLON] = ACTIONS(262),
    [anon_sym_ATv_COLON] = ACTIONS(262),
    [anon_sym_ATx_COLON] = ACTIONS(262),
    [anon_sym_PIPE_DOT] = ACTIONS(262),
    [anon_sym_DOLLAR] = ACTIONS(264),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(262),
    [anon_sym_GT] = ACTIONS(264),
    [anon_sym_GT_GT] = ACTIONS(262),
    [sym_html_redirect_operator] = ACTIONS(264),
    [sym_html_append_operator] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(262),
    [aux_sym_arg_identifier_token1] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(262),
    [anon_sym_BQUOTE] = ACTIONS(262),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(262),
    [anon_sym_CR] = ACTIONS(262),
    [sym_file_descriptor] = ACTIONS(262),
    [sym__spec_sep] = ACTIONS(260),
  },
  [77] = {
    [aux_sym_specifiers_repeat1] = STATE(77),
    [ts_builtin_sym_end] = ACTIONS(266),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [anon_sym_TILDE] = ACTIONS(266),
    [anon_sym_PIPE] = ACTIONS(268),
    [anon_sym_PIPEH] = ACTIONS(266),
    [anon_sym_AT_AT_DOT] = ACTIONS(266),
    [anon_sym_AT_AT_EQ] = ACTIONS(266),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(266),
    [anon_sym_AT_AT] = ACTIONS(268),
    [anon_sym_AT_ATc_COLON] = ACTIONS(266),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(266),
    [anon_sym_AT_ATC] = ACTIONS(266),
    [anon_sym_AT_ATdbt] = ACTIONS(268),
    [anon_sym_AT_ATdbta] = ACTIONS(266),
    [anon_sym_AT_ATdbtb] = ACTIONS(266),
    [anon_sym_AT_ATdbts] = ACTIONS(266),
    [anon_sym_AT_ATt] = ACTIONS(266),
    [anon_sym_AT_ATb] = ACTIONS(266),
    [anon_sym_AT_ATi] = ACTIONS(268),
    [anon_sym_AT_ATii] = ACTIONS(266),
    [anon_sym_AT_ATiS] = ACTIONS(268),
    [anon_sym_AT_ATiSS] = ACTIONS(266),
    [anon_sym_AT_ATis] = ACTIONS(266),
    [anon_sym_AT_ATiz] = ACTIONS(266),
    [anon_sym_AT_ATf] = ACTIONS(266),
    [anon_sym_AT_ATF] = ACTIONS(266),
    [anon_sym_AT_ATom] = ACTIONS(266),
    [anon_sym_AT_ATdm] = ACTIONS(266),
    [anon_sym_AT_ATr] = ACTIONS(266),
    [anon_sym_AT_ATs_COLON] = ACTIONS(266),
    [anon_sym_AT] = ACTIONS(266),
    [anon_sym_AT_BANG] = ACTIONS(266),
    [anon_sym_AT_LPAREN] = ACTIONS(266),
    [anon_sym_RPAREN] = ACTIONS(266),
    [anon_sym_ATa_COLON] = ACTIONS(266),
    [anon_sym_ATb_COLON] = ACTIONS(266),
    [anon_sym_ATB_COLON] = ACTIONS(266),
    [anon_sym_ATe_COLON] = ACTIONS(266),
    [anon_sym_ATF_COLON] = ACTIONS(266),
    [anon_sym_ATi_COLON] = ACTIONS(266),
    [anon_sym_ATk_COLON] = ACTIONS(266),
    [anon_sym_ATo_COLON] = ACTIONS(266),
    [anon_sym_ATr_COLON] = ACTIONS(266),
    [anon_sym_ATf_COLON] = ACTIONS(266),
    [anon_sym_ATs_COLON] = ACTIONS(266),
    [anon_sym_ATv_COLON] = ACTIONS(266),
    [anon_sym_ATx_COLON] = ACTIONS(266),
    [anon_sym_PIPE_DOT] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(268),
    [anon_sym_LPAREN] = ACTIONS(266),
    [anon_sym_SEMI] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(266),
    [sym_html_redirect_operator] = ACTIONS(268),
    [sym_html_append_operator] = ACTIONS(266),
    [anon_sym_COMMA] = ACTIONS(266),
    [aux_sym_arg_identifier_token1] = ACTIONS(268),
    [anon_sym_SQUOTE] = ACTIONS(266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(266),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(266),
    [anon_sym_CR] = ACTIONS(266),
    [sym_file_descriptor] = ACTIONS(266),
    [sym__spec_sep] = ACTIONS(270),
  },
  [78] = {
    [aux_sym_concatenation_repeat1] = STATE(80),
    [ts_builtin_sym_end] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(273),
    [anon_sym_PIPE] = ACTIONS(275),
    [anon_sym_PIPEH] = ACTIONS(273),
    [anon_sym_AT_AT_DOT] = ACTIONS(273),
    [anon_sym_AT_AT_EQ] = ACTIONS(273),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(273),
    [anon_sym_AT_AT] = ACTIONS(275),
    [anon_sym_AT_ATc_COLON] = ACTIONS(273),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(273),
    [anon_sym_AT_ATC] = ACTIONS(273),
    [anon_sym_AT_ATdbt] = ACTIONS(275),
    [anon_sym_AT_ATdbta] = ACTIONS(273),
    [anon_sym_AT_ATdbtb] = ACTIONS(273),
    [anon_sym_AT_ATdbts] = ACTIONS(273),
    [anon_sym_AT_ATt] = ACTIONS(273),
    [anon_sym_AT_ATb] = ACTIONS(273),
    [anon_sym_AT_ATi] = ACTIONS(275),
    [anon_sym_AT_ATii] = ACTIONS(273),
    [anon_sym_AT_ATiS] = ACTIONS(275),
    [anon_sym_AT_ATiSS] = ACTIONS(273),
    [anon_sym_AT_ATis] = ACTIONS(273),
    [anon_sym_AT_ATiz] = ACTIONS(273),
    [anon_sym_AT_ATf] = ACTIONS(273),
    [anon_sym_AT_ATF] = ACTIONS(273),
    [anon_sym_AT_ATom] = ACTIONS(273),
    [anon_sym_AT_ATdm] = ACTIONS(273),
    [anon_sym_AT_ATr] = ACTIONS(273),
    [anon_sym_AT_ATs_COLON] = ACTIONS(273),
    [anon_sym_AT] = ACTIONS(273),
    [anon_sym_AT_BANG] = ACTIONS(273),
    [anon_sym_AT_LPAREN] = ACTIONS(273),
    [anon_sym_RPAREN] = ACTIONS(273),
    [anon_sym_ATa_COLON] = ACTIONS(273),
    [anon_sym_ATb_COLON] = ACTIONS(273),
    [anon_sym_ATB_COLON] = ACTIONS(273),
    [anon_sym_ATe_COLON] = ACTIONS(273),
    [anon_sym_ATF_COLON] = ACTIONS(273),
    [anon_sym_ATi_COLON] = ACTIONS(273),
    [anon_sym_ATk_COLON] = ACTIONS(273),
    [anon_sym_ATo_COLON] = ACTIONS(273),
    [anon_sym_ATr_COLON] = ACTIONS(273),
    [anon_sym_ATf_COLON] = ACTIONS(273),
    [anon_sym_ATs_COLON] = ACTIONS(273),
    [anon_sym_ATv_COLON] = ACTIONS(273),
    [anon_sym_ATx_COLON] = ACTIONS(273),
    [anon_sym_PIPE_DOT] = ACTIONS(273),
    [anon_sym_DOLLAR] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_GT] = ACTIONS(275),
    [anon_sym_GT_GT] = ACTIONS(273),
    [sym_html_redirect_operator] = ACTIONS(275),
    [sym_html_append_operator] = ACTIONS(273),
    [anon_sym_COMMA] = ACTIONS(273),
    [aux_sym_arg_identifier_token1] = ACTIONS(275),
    [anon_sym_SQUOTE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(273),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(273),
    [anon_sym_CR] = ACTIONS(273),
    [sym_file_descriptor] = ACTIONS(273),
    [sym__concat] = ACTIONS(277),
  },
  [79] = {
    [aux_sym_concatenation_repeat1] = STATE(79),
    [ts_builtin_sym_end] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(279),
    [anon_sym_PIPE] = ACTIONS(281),
    [anon_sym_PIPEH] = ACTIONS(279),
    [anon_sym_AT_AT_DOT] = ACTIONS(279),
    [anon_sym_AT_AT_EQ] = ACTIONS(279),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(279),
    [anon_sym_AT_AT] = ACTIONS(281),
    [anon_sym_AT_ATc_COLON] = ACTIONS(279),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(279),
    [anon_sym_AT_ATC] = ACTIONS(279),
    [anon_sym_AT_ATdbt] = ACTIONS(281),
    [anon_sym_AT_ATdbta] = ACTIONS(279),
    [anon_sym_AT_ATdbtb] = ACTIONS(279),
    [anon_sym_AT_ATdbts] = ACTIONS(279),
    [anon_sym_AT_ATt] = ACTIONS(279),
    [anon_sym_AT_ATb] = ACTIONS(279),
    [anon_sym_AT_ATi] = ACTIONS(281),
    [anon_sym_AT_ATii] = ACTIONS(279),
    [anon_sym_AT_ATiS] = ACTIONS(281),
    [anon_sym_AT_ATiSS] = ACTIONS(279),
    [anon_sym_AT_ATis] = ACTIONS(279),
    [anon_sym_AT_ATiz] = ACTIONS(279),
    [anon_sym_AT_ATf] = ACTIONS(279),
    [anon_sym_AT_ATF] = ACTIONS(279),
    [anon_sym_AT_ATom] = ACTIONS(279),
    [anon_sym_AT_ATdm] = ACTIONS(279),
    [anon_sym_AT_ATr] = ACTIONS(279),
    [anon_sym_AT_ATs_COLON] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_AT_BANG] = ACTIONS(279),
    [anon_sym_AT_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_ATa_COLON] = ACTIONS(279),
    [anon_sym_ATb_COLON] = ACTIONS(279),
    [anon_sym_ATB_COLON] = ACTIONS(279),
    [anon_sym_ATe_COLON] = ACTIONS(279),
    [anon_sym_ATF_COLON] = ACTIONS(279),
    [anon_sym_ATi_COLON] = ACTIONS(279),
    [anon_sym_ATk_COLON] = ACTIONS(279),
    [anon_sym_ATo_COLON] = ACTIONS(279),
    [anon_sym_ATr_COLON] = ACTIONS(279),
    [anon_sym_ATf_COLON] = ACTIONS(279),
    [anon_sym_ATs_COLON] = ACTIONS(279),
    [anon_sym_ATv_COLON] = ACTIONS(279),
    [anon_sym_ATx_COLON] = ACTIONS(279),
    [anon_sym_PIPE_DOT] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(279),
    [sym_html_redirect_operator] = ACTIONS(281),
    [sym_html_append_operator] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(279),
    [aux_sym_arg_identifier_token1] = ACTIONS(281),
    [anon_sym_SQUOTE] = ACTIONS(279),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(279),
    [anon_sym_BQUOTE] = ACTIONS(279),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_CR] = ACTIONS(279),
    [sym_file_descriptor] = ACTIONS(279),
    [sym__concat] = ACTIONS(283),
  },
  [80] = {
    [aux_sym_concatenation_repeat1] = STATE(79),
    [ts_builtin_sym_end] = ACTIONS(286),
    [anon_sym_DQUOTE] = ACTIONS(286),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_PIPE] = ACTIONS(288),
    [anon_sym_PIPEH] = ACTIONS(286),
    [anon_sym_AT_AT_DOT] = ACTIONS(286),
    [anon_sym_AT_AT_EQ] = ACTIONS(286),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(286),
    [anon_sym_AT_AT] = ACTIONS(288),
    [anon_sym_AT_ATc_COLON] = ACTIONS(286),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(286),
    [anon_sym_AT_ATC] = ACTIONS(286),
    [anon_sym_AT_ATdbt] = ACTIONS(288),
    [anon_sym_AT_ATdbta] = ACTIONS(286),
    [anon_sym_AT_ATdbtb] = ACTIONS(286),
    [anon_sym_AT_ATdbts] = ACTIONS(286),
    [anon_sym_AT_ATt] = ACTIONS(286),
    [anon_sym_AT_ATb] = ACTIONS(286),
    [anon_sym_AT_ATi] = ACTIONS(288),
    [anon_sym_AT_ATii] = ACTIONS(286),
    [anon_sym_AT_ATiS] = ACTIONS(288),
    [anon_sym_AT_ATiSS] = ACTIONS(286),
    [anon_sym_AT_ATis] = ACTIONS(286),
    [anon_sym_AT_ATiz] = ACTIONS(286),
    [anon_sym_AT_ATf] = ACTIONS(286),
    [anon_sym_AT_ATF] = ACTIONS(286),
    [anon_sym_AT_ATom] = ACTIONS(286),
    [anon_sym_AT_ATdm] = ACTIONS(286),
    [anon_sym_AT_ATr] = ACTIONS(286),
    [anon_sym_AT_ATs_COLON] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(286),
    [anon_sym_AT_BANG] = ACTIONS(286),
    [anon_sym_AT_LPAREN] = ACTIONS(286),
    [anon_sym_RPAREN] = ACTIONS(286),
    [anon_sym_ATa_COLON] = ACTIONS(286),
    [anon_sym_ATb_COLON] = ACTIONS(286),
    [anon_sym_ATB_COLON] = ACTIONS(286),
    [anon_sym_ATe_COLON] = ACTIONS(286),
    [anon_sym_ATF_COLON] = ACTIONS(286),
    [anon_sym_ATi_COLON] = ACTIONS(286),
    [anon_sym_ATk_COLON] = ACTIONS(286),
    [anon_sym_ATo_COLON] = ACTIONS(286),
    [anon_sym_ATr_COLON] = ACTIONS(286),
    [anon_sym_ATf_COLON] = ACTIONS(286),
    [anon_sym_ATs_COLON] = ACTIONS(286),
    [anon_sym_ATv_COLON] = ACTIONS(286),
    [anon_sym_ATx_COLON] = ACTIONS(286),
    [anon_sym_PIPE_DOT] = ACTIONS(286),
    [anon_sym_DOLLAR] = ACTIONS(288),
    [anon_sym_LPAREN] = ACTIONS(286),
    [anon_sym_SEMI] = ACTIONS(286),
    [anon_sym_GT] = ACTIONS(288),
    [anon_sym_GT_GT] = ACTIONS(286),
    [sym_html_redirect_operator] = ACTIONS(288),
    [sym_html_append_operator] = ACTIONS(286),
    [anon_sym_COMMA] = ACTIONS(286),
    [aux_sym_arg_identifier_token1] = ACTIONS(288),
    [anon_sym_SQUOTE] = ACTIONS(286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(286),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(286),
    [anon_sym_CR] = ACTIONS(286),
    [sym_file_descriptor] = ACTIONS(286),
    [sym__concat] = ACTIONS(277),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [anon_sym_TILDE] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(292),
    [anon_sym_PIPEH] = ACTIONS(290),
    [anon_sym_AT_AT_DOT] = ACTIONS(290),
    [anon_sym_AT_AT_EQ] = ACTIONS(290),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(290),
    [anon_sym_AT_AT] = ACTIONS(292),
    [anon_sym_AT_ATc_COLON] = ACTIONS(290),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(290),
    [anon_sym_AT_ATC] = ACTIONS(290),
    [anon_sym_AT_ATdbt] = ACTIONS(292),
    [anon_sym_AT_ATdbta] = ACTIONS(290),
    [anon_sym_AT_ATdbtb] = ACTIONS(290),
    [anon_sym_AT_ATdbts] = ACTIONS(290),
    [anon_sym_AT_ATt] = ACTIONS(290),
    [anon_sym_AT_ATb] = ACTIONS(290),
    [anon_sym_AT_ATi] = ACTIONS(292),
    [anon_sym_AT_ATii] = ACTIONS(290),
    [anon_sym_AT_ATiS] = ACTIONS(292),
    [anon_sym_AT_ATiSS] = ACTIONS(290),
    [anon_sym_AT_ATis] = ACTIONS(290),
    [anon_sym_AT_ATiz] = ACTIONS(290),
    [anon_sym_AT_ATf] = ACTIONS(290),
    [anon_sym_AT_ATF] = ACTIONS(290),
    [anon_sym_AT_ATom] = ACTIONS(290),
    [anon_sym_AT_ATdm] = ACTIONS(290),
    [anon_sym_AT_ATr] = ACTIONS(290),
    [anon_sym_AT_ATs_COLON] = ACTIONS(290),
    [anon_sym_AT] = ACTIONS(290),
    [anon_sym_AT_BANG] = ACTIONS(290),
    [anon_sym_AT_LPAREN] = ACTIONS(290),
    [anon_sym_RPAREN] = ACTIONS(290),
    [anon_sym_ATa_COLON] = ACTIONS(290),
    [anon_sym_ATb_COLON] = ACTIONS(290),
    [anon_sym_ATB_COLON] = ACTIONS(290),
    [anon_sym_ATe_COLON] = ACTIONS(290),
    [anon_sym_ATF_COLON] = ACTIONS(290),
    [anon_sym_ATi_COLON] = ACTIONS(290),
    [anon_sym_ATk_COLON] = ACTIONS(290),
    [anon_sym_ATo_COLON] = ACTIONS(290),
    [anon_sym_ATr_COLON] = ACTIONS(290),
    [anon_sym_ATf_COLON] = ACTIONS(290),
    [anon_sym_ATs_COLON] = ACTIONS(290),
    [anon_sym_ATv_COLON] = ACTIONS(290),
    [anon_sym_ATx_COLON] = ACTIONS(290),
    [anon_sym_PIPE_DOT] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_LPAREN] = ACTIONS(290),
    [anon_sym_SEMI] = ACTIONS(290),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(290),
    [sym_html_redirect_operator] = ACTIONS(292),
    [sym_html_append_operator] = ACTIONS(290),
    [anon_sym_COMMA] = ACTIONS(290),
    [aux_sym_arg_identifier_token1] = ACTIONS(292),
    [anon_sym_SQUOTE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(290),
    [anon_sym_CR] = ACTIONS(290),
    [sym_file_descriptor] = ACTIONS(290),
    [sym__concat] = ACTIONS(290),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(294),
    [anon_sym_PIPE] = ACTIONS(296),
    [anon_sym_PIPEH] = ACTIONS(294),
    [anon_sym_AT_AT_DOT] = ACTIONS(294),
    [anon_sym_AT_AT_EQ] = ACTIONS(294),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(294),
    [anon_sym_AT_AT] = ACTIONS(296),
    [anon_sym_AT_ATc_COLON] = ACTIONS(294),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(294),
    [anon_sym_AT_ATC] = ACTIONS(294),
    [anon_sym_AT_ATdbt] = ACTIONS(296),
    [anon_sym_AT_ATdbta] = ACTIONS(294),
    [anon_sym_AT_ATdbtb] = ACTIONS(294),
    [anon_sym_AT_ATdbts] = ACTIONS(294),
    [anon_sym_AT_ATt] = ACTIONS(294),
    [anon_sym_AT_ATb] = ACTIONS(294),
    [anon_sym_AT_ATi] = ACTIONS(296),
    [anon_sym_AT_ATii] = ACTIONS(294),
    [anon_sym_AT_ATiS] = ACTIONS(296),
    [anon_sym_AT_ATiSS] = ACTIONS(294),
    [anon_sym_AT_ATis] = ACTIONS(294),
    [anon_sym_AT_ATiz] = ACTIONS(294),
    [anon_sym_AT_ATf] = ACTIONS(294),
    [anon_sym_AT_ATF] = ACTIONS(294),
    [anon_sym_AT_ATom] = ACTIONS(294),
    [anon_sym_AT_ATdm] = ACTIONS(294),
    [anon_sym_AT_ATr] = ACTIONS(294),
    [anon_sym_AT_ATs_COLON] = ACTIONS(294),
    [anon_sym_AT] = ACTIONS(294),
    [anon_sym_AT_BANG] = ACTIONS(294),
    [anon_sym_AT_LPAREN] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(294),
    [anon_sym_ATa_COLON] = ACTIONS(294),
    [anon_sym_ATb_COLON] = ACTIONS(294),
    [anon_sym_ATB_COLON] = ACTIONS(294),
    [anon_sym_ATe_COLON] = ACTIONS(294),
    [anon_sym_ATF_COLON] = ACTIONS(294),
    [anon_sym_ATi_COLON] = ACTIONS(294),
    [anon_sym_ATk_COLON] = ACTIONS(294),
    [anon_sym_ATo_COLON] = ACTIONS(294),
    [anon_sym_ATr_COLON] = ACTIONS(294),
    [anon_sym_ATf_COLON] = ACTIONS(294),
    [anon_sym_ATs_COLON] = ACTIONS(294),
    [anon_sym_ATv_COLON] = ACTIONS(294),
    [anon_sym_ATx_COLON] = ACTIONS(294),
    [anon_sym_PIPE_DOT] = ACTIONS(294),
    [anon_sym_DOLLAR] = ACTIONS(296),
    [anon_sym_LPAREN] = ACTIONS(294),
    [anon_sym_SEMI] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_GT] = ACTIONS(294),
    [sym_html_redirect_operator] = ACTIONS(296),
    [sym_html_append_operator] = ACTIONS(294),
    [anon_sym_COMMA] = ACTIONS(294),
    [aux_sym_arg_identifier_token1] = ACTIONS(296),
    [anon_sym_SQUOTE] = ACTIONS(294),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(294),
    [anon_sym_BQUOTE] = ACTIONS(294),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(294),
    [anon_sym_CR] = ACTIONS(294),
    [sym_file_descriptor] = ACTIONS(294),
    [sym__concat] = ACTIONS(294),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(298),
    [anon_sym_DQUOTE] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_PIPEH] = ACTIONS(298),
    [anon_sym_AT_AT_DOT] = ACTIONS(298),
    [anon_sym_AT_AT_EQ] = ACTIONS(298),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(298),
    [anon_sym_AT_AT] = ACTIONS(300),
    [anon_sym_AT_ATc_COLON] = ACTIONS(298),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(298),
    [anon_sym_AT_ATC] = ACTIONS(298),
    [anon_sym_AT_ATdbt] = ACTIONS(300),
    [anon_sym_AT_ATdbta] = ACTIONS(298),
    [anon_sym_AT_ATdbtb] = ACTIONS(298),
    [anon_sym_AT_ATdbts] = ACTIONS(298),
    [anon_sym_AT_ATt] = ACTIONS(298),
    [anon_sym_AT_ATb] = ACTIONS(298),
    [anon_sym_AT_ATi] = ACTIONS(300),
    [anon_sym_AT_ATii] = ACTIONS(298),
    [anon_sym_AT_ATiS] = ACTIONS(300),
    [anon_sym_AT_ATiSS] = ACTIONS(298),
    [anon_sym_AT_ATis] = ACTIONS(298),
    [anon_sym_AT_ATiz] = ACTIONS(298),
    [anon_sym_AT_ATf] = ACTIONS(298),
    [anon_sym_AT_ATF] = ACTIONS(298),
    [anon_sym_AT_ATom] = ACTIONS(298),
    [anon_sym_AT_ATdm] = ACTIONS(298),
    [anon_sym_AT_ATr] = ACTIONS(298),
    [anon_sym_AT_ATs_COLON] = ACTIONS(298),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_AT_BANG] = ACTIONS(298),
    [anon_sym_AT_LPAREN] = ACTIONS(298),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_ATa_COLON] = ACTIONS(298),
    [anon_sym_ATb_COLON] = ACTIONS(298),
    [anon_sym_ATB_COLON] = ACTIONS(298),
    [anon_sym_ATe_COLON] = ACTIONS(298),
    [anon_sym_ATF_COLON] = ACTIONS(298),
    [anon_sym_ATi_COLON] = ACTIONS(298),
    [anon_sym_ATk_COLON] = ACTIONS(298),
    [anon_sym_ATo_COLON] = ACTIONS(298),
    [anon_sym_ATr_COLON] = ACTIONS(298),
    [anon_sym_ATf_COLON] = ACTIONS(298),
    [anon_sym_ATs_COLON] = ACTIONS(298),
    [anon_sym_ATv_COLON] = ACTIONS(298),
    [anon_sym_ATx_COLON] = ACTIONS(298),
    [anon_sym_PIPE_DOT] = ACTIONS(298),
    [anon_sym_DOLLAR] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(298),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_GT_GT] = ACTIONS(298),
    [sym_html_redirect_operator] = ACTIONS(300),
    [sym_html_append_operator] = ACTIONS(298),
    [anon_sym_COMMA] = ACTIONS(298),
    [aux_sym_arg_identifier_token1] = ACTIONS(300),
    [anon_sym_SQUOTE] = ACTIONS(298),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(298),
    [anon_sym_BQUOTE] = ACTIONS(298),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(298),
    [anon_sym_CR] = ACTIONS(298),
    [sym_file_descriptor] = ACTIONS(298),
    [sym__concat] = ACTIONS(298),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [anon_sym_TILDE] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(292),
    [anon_sym_PIPEH] = ACTIONS(290),
    [anon_sym_AT_AT_DOT] = ACTIONS(290),
    [anon_sym_AT_AT_EQ] = ACTIONS(290),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(290),
    [anon_sym_AT_AT] = ACTIONS(292),
    [anon_sym_AT_ATc_COLON] = ACTIONS(290),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(290),
    [anon_sym_AT_ATC] = ACTIONS(290),
    [anon_sym_AT_ATdbt] = ACTIONS(292),
    [anon_sym_AT_ATdbta] = ACTIONS(290),
    [anon_sym_AT_ATdbtb] = ACTIONS(290),
    [anon_sym_AT_ATdbts] = ACTIONS(290),
    [anon_sym_AT_ATt] = ACTIONS(290),
    [anon_sym_AT_ATb] = ACTIONS(290),
    [anon_sym_AT_ATi] = ACTIONS(292),
    [anon_sym_AT_ATii] = ACTIONS(290),
    [anon_sym_AT_ATiS] = ACTIONS(292),
    [anon_sym_AT_ATiSS] = ACTIONS(290),
    [anon_sym_AT_ATis] = ACTIONS(290),
    [anon_sym_AT_ATiz] = ACTIONS(290),
    [anon_sym_AT_ATf] = ACTIONS(290),
    [anon_sym_AT_ATF] = ACTIONS(290),
    [anon_sym_AT_ATom] = ACTIONS(290),
    [anon_sym_AT_ATdm] = ACTIONS(290),
    [anon_sym_AT_ATr] = ACTIONS(290),
    [anon_sym_AT_ATs_COLON] = ACTIONS(290),
    [anon_sym_AT] = ACTIONS(290),
    [anon_sym_AT_BANG] = ACTIONS(290),
    [anon_sym_AT_LPAREN] = ACTIONS(290),
    [anon_sym_RPAREN] = ACTIONS(290),
    [anon_sym_ATa_COLON] = ACTIONS(290),
    [anon_sym_ATb_COLON] = ACTIONS(290),
    [anon_sym_ATB_COLON] = ACTIONS(290),
    [anon_sym_ATe_COLON] = ACTIONS(290),
    [anon_sym_ATF_COLON] = ACTIONS(290),
    [anon_sym_ATi_COLON] = ACTIONS(290),
    [anon_sym_ATk_COLON] = ACTIONS(290),
    [anon_sym_ATo_COLON] = ACTIONS(290),
    [anon_sym_ATr_COLON] = ACTIONS(290),
    [anon_sym_ATf_COLON] = ACTIONS(290),
    [anon_sym_ATs_COLON] = ACTIONS(290),
    [anon_sym_ATv_COLON] = ACTIONS(290),
    [anon_sym_ATx_COLON] = ACTIONS(290),
    [anon_sym_PIPE_DOT] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_LPAREN] = ACTIONS(290),
    [anon_sym_SEMI] = ACTIONS(290),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(290),
    [sym_html_redirect_operator] = ACTIONS(292),
    [sym_html_append_operator] = ACTIONS(290),
    [anon_sym_COMMA] = ACTIONS(290),
    [aux_sym_arg_identifier_token1] = ACTIONS(292),
    [anon_sym_SQUOTE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(290),
    [anon_sym_CR] = ACTIONS(290),
    [sym_file_descriptor] = ACTIONS(290),
    [sym__concat] = ACTIONS(290),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(302),
    [anon_sym_PIPE] = ACTIONS(304),
    [anon_sym_PIPEH] = ACTIONS(302),
    [anon_sym_AT_AT_DOT] = ACTIONS(302),
    [anon_sym_AT_AT_EQ] = ACTIONS(302),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(302),
    [anon_sym_AT_AT] = ACTIONS(304),
    [anon_sym_AT_ATc_COLON] = ACTIONS(302),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(302),
    [anon_sym_AT_ATC] = ACTIONS(302),
    [anon_sym_AT_ATdbt] = ACTIONS(304),
    [anon_sym_AT_ATdbta] = ACTIONS(302),
    [anon_sym_AT_ATdbtb] = ACTIONS(302),
    [anon_sym_AT_ATdbts] = ACTIONS(302),
    [anon_sym_AT_ATt] = ACTIONS(302),
    [anon_sym_AT_ATb] = ACTIONS(302),
    [anon_sym_AT_ATi] = ACTIONS(304),
    [anon_sym_AT_ATii] = ACTIONS(302),
    [anon_sym_AT_ATiS] = ACTIONS(304),
    [anon_sym_AT_ATiSS] = ACTIONS(302),
    [anon_sym_AT_ATis] = ACTIONS(302),
    [anon_sym_AT_ATiz] = ACTIONS(302),
    [anon_sym_AT_ATf] = ACTIONS(302),
    [anon_sym_AT_ATF] = ACTIONS(302),
    [anon_sym_AT_ATom] = ACTIONS(302),
    [anon_sym_AT_ATdm] = ACTIONS(302),
    [anon_sym_AT_ATr] = ACTIONS(302),
    [anon_sym_AT_ATs_COLON] = ACTIONS(302),
    [anon_sym_AT] = ACTIONS(302),
    [anon_sym_AT_BANG] = ACTIONS(302),
    [anon_sym_AT_LPAREN] = ACTIONS(302),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_ATa_COLON] = ACTIONS(302),
    [anon_sym_ATb_COLON] = ACTIONS(302),
    [anon_sym_ATB_COLON] = ACTIONS(302),
    [anon_sym_ATe_COLON] = ACTIONS(302),
    [anon_sym_ATF_COLON] = ACTIONS(302),
    [anon_sym_ATi_COLON] = ACTIONS(302),
    [anon_sym_ATk_COLON] = ACTIONS(302),
    [anon_sym_ATo_COLON] = ACTIONS(302),
    [anon_sym_ATr_COLON] = ACTIONS(302),
    [anon_sym_ATf_COLON] = ACTIONS(302),
    [anon_sym_ATs_COLON] = ACTIONS(302),
    [anon_sym_ATv_COLON] = ACTIONS(302),
    [anon_sym_ATx_COLON] = ACTIONS(302),
    [anon_sym_PIPE_DOT] = ACTIONS(302),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(304),
    [anon_sym_GT_GT] = ACTIONS(302),
    [sym_html_redirect_operator] = ACTIONS(304),
    [sym_html_append_operator] = ACTIONS(302),
    [anon_sym_COMMA] = ACTIONS(302),
    [aux_sym_arg_identifier_token1] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(302),
    [anon_sym_BQUOTE] = ACTIONS(302),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(302),
    [anon_sym_CR] = ACTIONS(302),
    [sym_file_descriptor] = ACTIONS(302),
    [sym__concat] = ACTIONS(302),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(306),
    [anon_sym_DQUOTE] = ACTIONS(306),
    [anon_sym_TILDE] = ACTIONS(306),
    [anon_sym_PIPE] = ACTIONS(308),
    [anon_sym_PIPEH] = ACTIONS(306),
    [anon_sym_AT_AT_DOT] = ACTIONS(306),
    [anon_sym_AT_AT_EQ] = ACTIONS(306),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(306),
    [anon_sym_AT_AT] = ACTIONS(308),
    [anon_sym_AT_ATc_COLON] = ACTIONS(306),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(306),
    [anon_sym_AT_ATC] = ACTIONS(306),
    [anon_sym_AT_ATdbt] = ACTIONS(308),
    [anon_sym_AT_ATdbta] = ACTIONS(306),
    [anon_sym_AT_ATdbtb] = ACTIONS(306),
    [anon_sym_AT_ATdbts] = ACTIONS(306),
    [anon_sym_AT_ATt] = ACTIONS(306),
    [anon_sym_AT_ATb] = ACTIONS(306),
    [anon_sym_AT_ATi] = ACTIONS(308),
    [anon_sym_AT_ATii] = ACTIONS(306),
    [anon_sym_AT_ATiS] = ACTIONS(308),
    [anon_sym_AT_ATiSS] = ACTIONS(306),
    [anon_sym_AT_ATis] = ACTIONS(306),
    [anon_sym_AT_ATiz] = ACTIONS(306),
    [anon_sym_AT_ATf] = ACTIONS(306),
    [anon_sym_AT_ATF] = ACTIONS(306),
    [anon_sym_AT_ATom] = ACTIONS(306),
    [anon_sym_AT_ATdm] = ACTIONS(306),
    [anon_sym_AT_ATr] = ACTIONS(306),
    [anon_sym_AT_ATs_COLON] = ACTIONS(306),
    [anon_sym_AT] = ACTIONS(306),
    [anon_sym_AT_BANG] = ACTIONS(306),
    [anon_sym_AT_LPAREN] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_ATa_COLON] = ACTIONS(306),
    [anon_sym_ATb_COLON] = ACTIONS(306),
    [anon_sym_ATB_COLON] = ACTIONS(306),
    [anon_sym_ATe_COLON] = ACTIONS(306),
    [anon_sym_ATF_COLON] = ACTIONS(306),
    [anon_sym_ATi_COLON] = ACTIONS(306),
    [anon_sym_ATk_COLON] = ACTIONS(306),
    [anon_sym_ATo_COLON] = ACTIONS(306),
    [anon_sym_ATr_COLON] = ACTIONS(306),
    [anon_sym_ATf_COLON] = ACTIONS(306),
    [anon_sym_ATs_COLON] = ACTIONS(306),
    [anon_sym_ATv_COLON] = ACTIONS(306),
    [anon_sym_ATx_COLON] = ACTIONS(306),
    [anon_sym_PIPE_DOT] = ACTIONS(306),
    [anon_sym_DOLLAR] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_GT] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(306),
    [sym_html_redirect_operator] = ACTIONS(308),
    [sym_html_append_operator] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(306),
    [aux_sym_arg_identifier_token1] = ACTIONS(308),
    [anon_sym_SQUOTE] = ACTIONS(306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(306),
    [anon_sym_BQUOTE] = ACTIONS(306),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(306),
    [anon_sym_CR] = ACTIONS(306),
    [sym_file_descriptor] = ACTIONS(306),
    [sym__concat] = ACTIONS(306),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [anon_sym_TILDE] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(312),
    [anon_sym_PIPEH] = ACTIONS(310),
    [anon_sym_AT_AT_DOT] = ACTIONS(310),
    [anon_sym_AT_AT_EQ] = ACTIONS(310),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(310),
    [anon_sym_AT_AT] = ACTIONS(312),
    [anon_sym_AT_ATc_COLON] = ACTIONS(310),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(310),
    [anon_sym_AT_ATC] = ACTIONS(310),
    [anon_sym_AT_ATdbt] = ACTIONS(312),
    [anon_sym_AT_ATdbta] = ACTIONS(310),
    [anon_sym_AT_ATdbtb] = ACTIONS(310),
    [anon_sym_AT_ATdbts] = ACTIONS(310),
    [anon_sym_AT_ATt] = ACTIONS(310),
    [anon_sym_AT_ATb] = ACTIONS(310),
    [anon_sym_AT_ATi] = ACTIONS(312),
    [anon_sym_AT_ATii] = ACTIONS(310),
    [anon_sym_AT_ATiS] = ACTIONS(312),
    [anon_sym_AT_ATiSS] = ACTIONS(310),
    [anon_sym_AT_ATis] = ACTIONS(310),
    [anon_sym_AT_ATiz] = ACTIONS(310),
    [anon_sym_AT_ATf] = ACTIONS(310),
    [anon_sym_AT_ATF] = ACTIONS(310),
    [anon_sym_AT_ATom] = ACTIONS(310),
    [anon_sym_AT_ATdm] = ACTIONS(310),
    [anon_sym_AT_ATr] = ACTIONS(310),
    [anon_sym_AT_ATs_COLON] = ACTIONS(310),
    [anon_sym_AT] = ACTIONS(310),
    [anon_sym_AT_BANG] = ACTIONS(310),
    [anon_sym_AT_LPAREN] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(310),
    [anon_sym_ATa_COLON] = ACTIONS(310),
    [anon_sym_ATb_COLON] = ACTIONS(310),
    [anon_sym_ATB_COLON] = ACTIONS(310),
    [anon_sym_ATe_COLON] = ACTIONS(310),
    [anon_sym_ATF_COLON] = ACTIONS(310),
    [anon_sym_ATi_COLON] = ACTIONS(310),
    [anon_sym_ATk_COLON] = ACTIONS(310),
    [anon_sym_ATo_COLON] = ACTIONS(310),
    [anon_sym_ATr_COLON] = ACTIONS(310),
    [anon_sym_ATf_COLON] = ACTIONS(310),
    [anon_sym_ATs_COLON] = ACTIONS(310),
    [anon_sym_ATv_COLON] = ACTIONS(310),
    [anon_sym_ATx_COLON] = ACTIONS(310),
    [anon_sym_PIPE_DOT] = ACTIONS(310),
    [anon_sym_DOLLAR] = ACTIONS(312),
    [anon_sym_LPAREN] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(310),
    [sym_html_redirect_operator] = ACTIONS(312),
    [sym_html_append_operator] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(310),
    [aux_sym_arg_identifier_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(310),
    [anon_sym_BQUOTE] = ACTIONS(310),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_CR] = ACTIONS(310),
    [sym_file_descriptor] = ACTIONS(310),
    [sym__concat] = ACTIONS(310),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(279),
    [anon_sym_PIPE] = ACTIONS(281),
    [anon_sym_PIPEH] = ACTIONS(279),
    [anon_sym_AT_AT_DOT] = ACTIONS(279),
    [anon_sym_AT_AT_EQ] = ACTIONS(279),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(279),
    [anon_sym_AT_AT] = ACTIONS(281),
    [anon_sym_AT_ATc_COLON] = ACTIONS(279),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(279),
    [anon_sym_AT_ATC] = ACTIONS(279),
    [anon_sym_AT_ATdbt] = ACTIONS(281),
    [anon_sym_AT_ATdbta] = ACTIONS(279),
    [anon_sym_AT_ATdbtb] = ACTIONS(279),
    [anon_sym_AT_ATdbts] = ACTIONS(279),
    [anon_sym_AT_ATt] = ACTIONS(279),
    [anon_sym_AT_ATb] = ACTIONS(279),
    [anon_sym_AT_ATi] = ACTIONS(281),
    [anon_sym_AT_ATii] = ACTIONS(279),
    [anon_sym_AT_ATiS] = ACTIONS(281),
    [anon_sym_AT_ATiSS] = ACTIONS(279),
    [anon_sym_AT_ATis] = ACTIONS(279),
    [anon_sym_AT_ATiz] = ACTIONS(279),
    [anon_sym_AT_ATf] = ACTIONS(279),
    [anon_sym_AT_ATF] = ACTIONS(279),
    [anon_sym_AT_ATom] = ACTIONS(279),
    [anon_sym_AT_ATdm] = ACTIONS(279),
    [anon_sym_AT_ATr] = ACTIONS(279),
    [anon_sym_AT_ATs_COLON] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_AT_BANG] = ACTIONS(279),
    [anon_sym_AT_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_ATa_COLON] = ACTIONS(279),
    [anon_sym_ATb_COLON] = ACTIONS(279),
    [anon_sym_ATB_COLON] = ACTIONS(279),
    [anon_sym_ATe_COLON] = ACTIONS(279),
    [anon_sym_ATF_COLON] = ACTIONS(279),
    [anon_sym_ATi_COLON] = ACTIONS(279),
    [anon_sym_ATk_COLON] = ACTIONS(279),
    [anon_sym_ATo_COLON] = ACTIONS(279),
    [anon_sym_ATr_COLON] = ACTIONS(279),
    [anon_sym_ATf_COLON] = ACTIONS(279),
    [anon_sym_ATs_COLON] = ACTIONS(279),
    [anon_sym_ATv_COLON] = ACTIONS(279),
    [anon_sym_ATx_COLON] = ACTIONS(279),
    [anon_sym_PIPE_DOT] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(279),
    [sym_html_redirect_operator] = ACTIONS(281),
    [sym_html_append_operator] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(279),
    [aux_sym_arg_identifier_token1] = ACTIONS(281),
    [anon_sym_SQUOTE] = ACTIONS(279),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(279),
    [anon_sym_BQUOTE] = ACTIONS(279),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_CR] = ACTIONS(279),
    [sym_file_descriptor] = ACTIONS(279),
    [sym__concat] = ACTIONS(279),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(314),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_TILDE] = ACTIONS(314),
    [anon_sym_PIPE] = ACTIONS(316),
    [anon_sym_PIPEH] = ACTIONS(314),
    [anon_sym_AT_AT_DOT] = ACTIONS(314),
    [anon_sym_AT_AT_EQ] = ACTIONS(314),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(314),
    [anon_sym_AT_AT] = ACTIONS(316),
    [anon_sym_AT_ATc_COLON] = ACTIONS(314),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(314),
    [anon_sym_AT_ATC] = ACTIONS(314),
    [anon_sym_AT_ATdbt] = ACTIONS(316),
    [anon_sym_AT_ATdbta] = ACTIONS(314),
    [anon_sym_AT_ATdbtb] = ACTIONS(314),
    [anon_sym_AT_ATdbts] = ACTIONS(314),
    [anon_sym_AT_ATt] = ACTIONS(314),
    [anon_sym_AT_ATb] = ACTIONS(314),
    [anon_sym_AT_ATi] = ACTIONS(316),
    [anon_sym_AT_ATii] = ACTIONS(314),
    [anon_sym_AT_ATiS] = ACTIONS(316),
    [anon_sym_AT_ATiSS] = ACTIONS(314),
    [anon_sym_AT_ATis] = ACTIONS(314),
    [anon_sym_AT_ATiz] = ACTIONS(314),
    [anon_sym_AT_ATf] = ACTIONS(314),
    [anon_sym_AT_ATF] = ACTIONS(314),
    [anon_sym_AT_ATom] = ACTIONS(314),
    [anon_sym_AT_ATdm] = ACTIONS(314),
    [anon_sym_AT_ATr] = ACTIONS(314),
    [anon_sym_AT_ATs_COLON] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(314),
    [anon_sym_AT_BANG] = ACTIONS(314),
    [anon_sym_AT_LPAREN] = ACTIONS(314),
    [anon_sym_RPAREN] = ACTIONS(314),
    [anon_sym_ATa_COLON] = ACTIONS(314),
    [anon_sym_ATb_COLON] = ACTIONS(314),
    [anon_sym_ATB_COLON] = ACTIONS(314),
    [anon_sym_ATe_COLON] = ACTIONS(314),
    [anon_sym_ATF_COLON] = ACTIONS(314),
    [anon_sym_ATi_COLON] = ACTIONS(314),
    [anon_sym_ATk_COLON] = ACTIONS(314),
    [anon_sym_ATo_COLON] = ACTIONS(314),
    [anon_sym_ATr_COLON] = ACTIONS(314),
    [anon_sym_ATf_COLON] = ACTIONS(314),
    [anon_sym_ATs_COLON] = ACTIONS(314),
    [anon_sym_ATv_COLON] = ACTIONS(314),
    [anon_sym_ATx_COLON] = ACTIONS(314),
    [anon_sym_PIPE_DOT] = ACTIONS(314),
    [anon_sym_DOLLAR] = ACTIONS(316),
    [anon_sym_LPAREN] = ACTIONS(314),
    [anon_sym_SEMI] = ACTIONS(314),
    [anon_sym_GT] = ACTIONS(316),
    [anon_sym_GT_GT] = ACTIONS(314),
    [sym_html_redirect_operator] = ACTIONS(316),
    [sym_html_append_operator] = ACTIONS(314),
    [anon_sym_COMMA] = ACTIONS(314),
    [aux_sym_arg_identifier_token1] = ACTIONS(316),
    [anon_sym_SQUOTE] = ACTIONS(314),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(314),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(314),
    [anon_sym_CR] = ACTIONS(314),
    [sym_file_descriptor] = ACTIONS(314),
    [sym__concat] = ACTIONS(314),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(318),
    [anon_sym_TILDE] = ACTIONS(318),
    [anon_sym_PIPE] = ACTIONS(320),
    [anon_sym_PIPEH] = ACTIONS(318),
    [anon_sym_AT_AT_DOT] = ACTIONS(318),
    [anon_sym_AT_AT_EQ] = ACTIONS(318),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(318),
    [anon_sym_AT_AT] = ACTIONS(320),
    [anon_sym_AT_ATc_COLON] = ACTIONS(318),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(318),
    [anon_sym_AT_ATC] = ACTIONS(318),
    [anon_sym_AT_ATdbt] = ACTIONS(320),
    [anon_sym_AT_ATdbta] = ACTIONS(318),
    [anon_sym_AT_ATdbtb] = ACTIONS(318),
    [anon_sym_AT_ATdbts] = ACTIONS(318),
    [anon_sym_AT_ATt] = ACTIONS(318),
    [anon_sym_AT_ATb] = ACTIONS(318),
    [anon_sym_AT_ATi] = ACTIONS(320),
    [anon_sym_AT_ATii] = ACTIONS(318),
    [anon_sym_AT_ATiS] = ACTIONS(320),
    [anon_sym_AT_ATiSS] = ACTIONS(318),
    [anon_sym_AT_ATis] = ACTIONS(318),
    [anon_sym_AT_ATiz] = ACTIONS(318),
    [anon_sym_AT_ATf] = ACTIONS(318),
    [anon_sym_AT_ATF] = ACTIONS(318),
    [anon_sym_AT_ATom] = ACTIONS(318),
    [anon_sym_AT_ATdm] = ACTIONS(318),
    [anon_sym_AT_ATr] = ACTIONS(318),
    [anon_sym_AT_ATs_COLON] = ACTIONS(318),
    [anon_sym_AT] = ACTIONS(318),
    [anon_sym_AT_BANG] = ACTIONS(318),
    [anon_sym_AT_LPAREN] = ACTIONS(318),
    [anon_sym_RPAREN] = ACTIONS(318),
    [anon_sym_ATa_COLON] = ACTIONS(318),
    [anon_sym_ATb_COLON] = ACTIONS(318),
    [anon_sym_ATB_COLON] = ACTIONS(318),
    [anon_sym_ATe_COLON] = ACTIONS(318),
    [anon_sym_ATF_COLON] = ACTIONS(318),
    [anon_sym_ATi_COLON] = ACTIONS(318),
    [anon_sym_ATk_COLON] = ACTIONS(318),
    [anon_sym_ATo_COLON] = ACTIONS(318),
    [anon_sym_ATr_COLON] = ACTIONS(318),
    [anon_sym_ATf_COLON] = ACTIONS(318),
    [anon_sym_ATs_COLON] = ACTIONS(318),
    [anon_sym_ATv_COLON] = ACTIONS(318),
    [anon_sym_ATx_COLON] = ACTIONS(318),
    [anon_sym_PIPE_DOT] = ACTIONS(318),
    [anon_sym_DOLLAR] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(318),
    [anon_sym_SEMI] = ACTIONS(318),
    [anon_sym_GT] = ACTIONS(320),
    [anon_sym_GT_GT] = ACTIONS(318),
    [sym_html_redirect_operator] = ACTIONS(320),
    [sym_html_append_operator] = ACTIONS(318),
    [anon_sym_COMMA] = ACTIONS(318),
    [aux_sym_arg_identifier_token1] = ACTIONS(320),
    [anon_sym_SQUOTE] = ACTIONS(318),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(318),
    [anon_sym_BQUOTE] = ACTIONS(318),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(318),
    [anon_sym_CR] = ACTIONS(318),
    [sym_file_descriptor] = ACTIONS(318),
    [sym__spec_sep] = ACTIONS(318),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(322),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_TILDE] = ACTIONS(322),
    [anon_sym_PIPE] = ACTIONS(324),
    [anon_sym_PIPEH] = ACTIONS(322),
    [anon_sym_AT_AT_DOT] = ACTIONS(322),
    [anon_sym_AT_AT_EQ] = ACTIONS(322),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(322),
    [anon_sym_AT_AT] = ACTIONS(324),
    [anon_sym_AT_ATc_COLON] = ACTIONS(322),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(322),
    [anon_sym_AT_ATC] = ACTIONS(322),
    [anon_sym_AT_ATdbt] = ACTIONS(324),
    [anon_sym_AT_ATdbta] = ACTIONS(322),
    [anon_sym_AT_ATdbtb] = ACTIONS(322),
    [anon_sym_AT_ATdbts] = ACTIONS(322),
    [anon_sym_AT_ATt] = ACTIONS(322),
    [anon_sym_AT_ATb] = ACTIONS(322),
    [anon_sym_AT_ATi] = ACTIONS(324),
    [anon_sym_AT_ATii] = ACTIONS(322),
    [anon_sym_AT_ATiS] = ACTIONS(324),
    [anon_sym_AT_ATiSS] = ACTIONS(322),
    [anon_sym_AT_ATis] = ACTIONS(322),
    [anon_sym_AT_ATiz] = ACTIONS(322),
    [anon_sym_AT_ATf] = ACTIONS(322),
    [anon_sym_AT_ATF] = ACTIONS(322),
    [anon_sym_AT_ATom] = ACTIONS(322),
    [anon_sym_AT_ATdm] = ACTIONS(322),
    [anon_sym_AT_ATr] = ACTIONS(322),
    [anon_sym_AT_ATs_COLON] = ACTIONS(322),
    [anon_sym_AT] = ACTIONS(322),
    [anon_sym_AT_BANG] = ACTIONS(322),
    [anon_sym_AT_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(322),
    [anon_sym_ATa_COLON] = ACTIONS(322),
    [anon_sym_ATb_COLON] = ACTIONS(322),
    [anon_sym_ATB_COLON] = ACTIONS(322),
    [anon_sym_ATe_COLON] = ACTIONS(322),
    [anon_sym_ATF_COLON] = ACTIONS(322),
    [anon_sym_ATi_COLON] = ACTIONS(322),
    [anon_sym_ATk_COLON] = ACTIONS(322),
    [anon_sym_ATo_COLON] = ACTIONS(322),
    [anon_sym_ATr_COLON] = ACTIONS(322),
    [anon_sym_ATf_COLON] = ACTIONS(322),
    [anon_sym_ATs_COLON] = ACTIONS(322),
    [anon_sym_ATv_COLON] = ACTIONS(322),
    [anon_sym_ATx_COLON] = ACTIONS(322),
    [anon_sym_PIPE_DOT] = ACTIONS(322),
    [anon_sym_DOLLAR] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_SEMI] = ACTIONS(322),
    [anon_sym_GT] = ACTIONS(324),
    [anon_sym_GT_GT] = ACTIONS(322),
    [sym_html_redirect_operator] = ACTIONS(324),
    [sym_html_append_operator] = ACTIONS(322),
    [anon_sym_COMMA] = ACTIONS(322),
    [aux_sym_arg_identifier_token1] = ACTIONS(324),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(322),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(322),
    [anon_sym_CR] = ACTIONS(322),
    [sym_file_descriptor] = ACTIONS(322),
    [sym__concat] = ACTIONS(322),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(326),
    [anon_sym_DQUOTE] = ACTIONS(326),
    [anon_sym_TILDE] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_PIPEH] = ACTIONS(326),
    [anon_sym_AT_AT_DOT] = ACTIONS(326),
    [anon_sym_AT_AT_EQ] = ACTIONS(326),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(326),
    [anon_sym_AT_AT] = ACTIONS(328),
    [anon_sym_AT_ATc_COLON] = ACTIONS(326),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(326),
    [anon_sym_AT_ATC] = ACTIONS(326),
    [anon_sym_AT_ATdbt] = ACTIONS(328),
    [anon_sym_AT_ATdbta] = ACTIONS(326),
    [anon_sym_AT_ATdbtb] = ACTIONS(326),
    [anon_sym_AT_ATdbts] = ACTIONS(326),
    [anon_sym_AT_ATt] = ACTIONS(326),
    [anon_sym_AT_ATb] = ACTIONS(326),
    [anon_sym_AT_ATi] = ACTIONS(328),
    [anon_sym_AT_ATii] = ACTIONS(326),
    [anon_sym_AT_ATiS] = ACTIONS(328),
    [anon_sym_AT_ATiSS] = ACTIONS(326),
    [anon_sym_AT_ATis] = ACTIONS(326),
    [anon_sym_AT_ATiz] = ACTIONS(326),
    [anon_sym_AT_ATf] = ACTIONS(326),
    [anon_sym_AT_ATF] = ACTIONS(326),
    [anon_sym_AT_ATom] = ACTIONS(326),
    [anon_sym_AT_ATdm] = ACTIONS(326),
    [anon_sym_AT_ATr] = ACTIONS(326),
    [anon_sym_AT_ATs_COLON] = ACTIONS(326),
    [anon_sym_AT] = ACTIONS(326),
    [anon_sym_AT_BANG] = ACTIONS(326),
    [anon_sym_AT_LPAREN] = ACTIONS(326),
    [anon_sym_RPAREN] = ACTIONS(326),
    [anon_sym_ATa_COLON] = ACTIONS(326),
    [anon_sym_ATb_COLON] = ACTIONS(326),
    [anon_sym_ATB_COLON] = ACTIONS(326),
    [anon_sym_ATe_COLON] = ACTIONS(326),
    [anon_sym_ATF_COLON] = ACTIONS(326),
    [anon_sym_ATi_COLON] = ACTIONS(326),
    [anon_sym_ATk_COLON] = ACTIONS(326),
    [anon_sym_ATo_COLON] = ACTIONS(326),
    [anon_sym_ATr_COLON] = ACTIONS(326),
    [anon_sym_ATf_COLON] = ACTIONS(326),
    [anon_sym_ATs_COLON] = ACTIONS(326),
    [anon_sym_ATv_COLON] = ACTIONS(326),
    [anon_sym_ATx_COLON] = ACTIONS(326),
    [anon_sym_PIPE_DOT] = ACTIONS(326),
    [anon_sym_DOLLAR] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(326),
    [anon_sym_SEMI] = ACTIONS(326),
    [anon_sym_GT] = ACTIONS(328),
    [anon_sym_GT_GT] = ACTIONS(326),
    [sym_html_redirect_operator] = ACTIONS(328),
    [sym_html_append_operator] = ACTIONS(326),
    [anon_sym_COMMA] = ACTIONS(326),
    [aux_sym_arg_identifier_token1] = ACTIONS(328),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(326),
    [anon_sym_BQUOTE] = ACTIONS(326),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(326),
    [anon_sym_CR] = ACTIONS(326),
    [sym_file_descriptor] = ACTIONS(326),
    [sym__spec_sep] = ACTIONS(326),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DQUOTE,
    ACTIONS(228), 1,
      sym__eq_sep_key_identifier,
    ACTIONS(230), 1,
      anon_sym_SQUOTE,
    ACTIONS(232), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(168), 1,
      sym__eq_sep_key,
    STATE(169), 1,
      sym__eq_sep_key_concatenation,
    STATE(239), 1,
      sym_eq_sep_args,
    STATE(131), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
    ACTIONS(226), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(222), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [87] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(334), 1,
      sym__concat_pf_dot,
    STATE(96), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(332), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(330), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [162] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(338), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_arg_identifier_token1,
    ACTIONS(336), 54,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [233] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 1,
      sym__concat_pf_dot,
    STATE(96), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(342), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(340), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [308] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(115), 1,
      sym_pf_concatenation,
    ACTIONS(212), 2,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
    STATE(73), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(102), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
    ACTIONS(254), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(252), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [391] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(275), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_arg_identifier_token1,
    ACTIONS(273), 54,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [462] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(94), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(349), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [535] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(340), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [605] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [675] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(355), 1,
      sym__concat,
    STATE(107), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(353), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(351), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [749] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(359), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(357), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [819] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [889] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [959] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(365), 1,
      sym__concat,
    STATE(106), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(363), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(361), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1033] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(355), 1,
      sym__concat,
    STATE(106), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(370), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(368), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1107] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(363), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(361), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1176] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1245] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(374), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(372), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1314] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1383] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(378), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(376), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1452] = 7,
    ACTIONS(384), 1,
      sym_grep_specifier_identifier,
    ACTIONS(387), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BQUOTE,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(380), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(113), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(382), 53,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1528] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(397), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
      sym__eq_sep_key_identifier,
    ACTIONS(395), 52,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1596] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(353), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(351), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1664] = 8,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(403), 1,
      sym_grep_specifier_identifier,
    ACTIONS(405), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(407), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(409), 1,
      anon_sym_BQUOTE,
    ACTIONS(399), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(113), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(401), 52,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1742] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(220), 1,
      sym__concat_pf_dot,
    STATE(123), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(210), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(208), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1813] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(411), 1,
      sym__concat,
    STATE(118), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(281), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(279), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1884] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(418), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(129), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(416), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(414), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1955] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(273), 1,
      sym__eq_sep_concat,
    ACTIONS(424), 1,
      sym__concat,
    STATE(434), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(422), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(420), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2028] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(426), 1,
      sym__concat_pf_dot,
    STATE(130), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(332), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(330), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2099] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(428), 1,
      sym__concat,
    STATE(118), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(288), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(286), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2170] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(220), 1,
      sym__concat_pf_dot,
    STATE(128), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(432), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(430), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2241] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(428), 1,
      sym__concat,
    STATE(122), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(275), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(273), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2312] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(121), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(349), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2381] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(438), 1,
      sym__eq_sep_concat,
    STATE(126), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(436), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(434), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2452] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(445), 1,
      sym__eq_sep_concat,
    STATE(126), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(443), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(441), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2523] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(451), 1,
      sym__concat_pf_dot,
    STATE(128), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(449), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(447), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2594] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(458), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(129), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(456), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(454), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2665] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(461), 1,
      sym__concat_pf_dot,
    STATE(130), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(342), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(340), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2736] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(445), 1,
      sym__eq_sep_concat,
    STATE(127), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(466), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(464), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2807] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(472), 1,
      anon_sym_LPAREN,
    STATE(198), 1,
      sym_macro_call_full_content,
    ACTIONS(470), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(468), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2877] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(281), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(279), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2943] = 7,
    ACTIONS(380), 1,
      sym_file_descriptor,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(474), 1,
      sym_grep_specifier_identifier,
    ACTIONS(477), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(480), 1,
      anon_sym_BQUOTE,
    STATE(134), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(382), 52,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [3017] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(487), 1,
      anon_sym_COMMA,
    STATE(135), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(485), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(483), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3087] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3153] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3219] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(494), 1,
      sym__eq_sep_concat,
    STATE(157), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(492), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(490), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3289] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(322), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3355] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(500), 1,
      anon_sym_COMMA,
    STATE(135), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(498), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(496), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3425] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3491] = 8,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(399), 1,
      sym_file_descriptor,
    ACTIONS(405), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(502), 1,
      sym_grep_specifier_identifier,
    ACTIONS(504), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    STATE(134), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(401), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [3567] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(500), 1,
      anon_sym_COMMA,
    STATE(140), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(510), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(508), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3637] = 3,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(290), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(292), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3703] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(294), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3769] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(514), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(512), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3835] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(518), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_tmp_eval_arg_token1,
    ACTIONS(516), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3901] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(302), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3967] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(436), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(434), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4033] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4099] = 3,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(290), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(292), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4165] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(322), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4231] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4297] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(340), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4363] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4429] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(314), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4495] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(524), 1,
      sym__eq_sep_concat,
    STATE(157), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(522), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(520), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4565] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4631] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(302), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4697] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(294), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4763] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(300), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(298), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4829] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(306), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4895] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(359), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(357), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4961] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5027] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(290), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5093] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(531), 1,
      anon_sym_COLON,
    ACTIONS(529), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(527), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5160] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(399), 1,
      sym_file_descriptor,
    ACTIONS(405), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(502), 1,
      sym_grep_specifier_identifier,
    ACTIONS(504), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(134), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(401), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [5233] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(537), 1,
      anon_sym_EQ,
    ACTIONS(535), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(533), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5300] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(466), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(464), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5365] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(541), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(539), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5430] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(545), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(543), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5495] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(549), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(547), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5560] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(555), 1,
      anon_sym_COLON,
    ACTIONS(553), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(551), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5627] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(559), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(557), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5692] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(565), 1,
      anon_sym_COLON,
    ACTIONS(563), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(561), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5759] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(275), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(273), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5824] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(569), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(567), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5889] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(485), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(483), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5954] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(573), 1,
      anon_sym_TILDE,
    ACTIONS(575), 1,
      anon_sym_PIPE,
    ACTIONS(577), 1,
      anon_sym_PIPEH,
    ACTIONS(579), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(581), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(583), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(585), 1,
      anon_sym_AT_AT,
    ACTIONS(587), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(589), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(591), 1,
      anon_sym_AT_ATC,
    ACTIONS(593), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(595), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(597), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(599), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(601), 1,
      anon_sym_AT_ATt,
    ACTIONS(603), 1,
      anon_sym_AT_ATb,
    ACTIONS(605), 1,
      anon_sym_AT_ATi,
    ACTIONS(607), 1,
      anon_sym_AT_ATii,
    ACTIONS(609), 1,
      anon_sym_AT_ATiS,
    ACTIONS(611), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(613), 1,
      anon_sym_AT_ATis,
    ACTIONS(615), 1,
      anon_sym_AT_ATiz,
    ACTIONS(617), 1,
      anon_sym_AT_ATf,
    ACTIONS(619), 1,
      anon_sym_AT_ATF,
    ACTIONS(621), 1,
      anon_sym_AT_ATom,
    ACTIONS(623), 1,
      anon_sym_AT_ATdm,
    ACTIONS(625), 1,
      anon_sym_AT_ATr,
    ACTIONS(627), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(629), 1,
      anon_sym_AT,
    ACTIONS(631), 1,
      anon_sym_AT_BANG,
    ACTIONS(633), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(635), 1,
      anon_sym_ATa_COLON,
    ACTIONS(637), 1,
      anon_sym_ATb_COLON,
    ACTIONS(639), 1,
      anon_sym_ATB_COLON,
    ACTIONS(641), 1,
      anon_sym_ATe_COLON,
    ACTIONS(643), 1,
      anon_sym_ATF_COLON,
    ACTIONS(645), 1,
      anon_sym_ATi_COLON,
    ACTIONS(647), 1,
      anon_sym_ATk_COLON,
    ACTIONS(649), 1,
      anon_sym_ATo_COLON,
    ACTIONS(651), 1,
      anon_sym_ATr_COLON,
    ACTIONS(653), 1,
      anon_sym_ATf_COLON,
    ACTIONS(655), 1,
      anon_sym_ATs_COLON,
    ACTIONS(657), 1,
      anon_sym_ATv_COLON,
    ACTIONS(659), 1,
      anon_sym_ATx_COLON,
    ACTIONS(661), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(663), 1,
      anon_sym_GT,
    ACTIONS(665), 1,
      anon_sym_GT_GT,
    ACTIONS(667), 1,
      sym_html_redirect_operator,
    ACTIONS(669), 1,
      sym_html_append_operator,
    ACTIONS(671), 1,
      sym_file_descriptor,
    STATE(322), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
    ACTIONS(571), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [6119] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(522), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(520), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6184] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(675), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(673), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6248] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(679), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(677), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6312] = 3,
    ACTIONS(290), 1,
      sym_file_descriptor,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(292), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [6376] = 4,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(681), 1,
      aux_sym__interpret_stmt_token2,
    ACTIONS(131), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(133), 53,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [6442] = 3,
    ACTIONS(290), 1,
      sym_file_descriptor,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(292), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [6506] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(685), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(683), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6570] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(689), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(687), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6634] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(693), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(691), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6698] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(697), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(695), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6762] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(701), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(699), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6826] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(705), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(703), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6890] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(711), 1,
      anon_sym_EQ,
    ACTIONS(709), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(707), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [6956] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(715), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(713), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7020] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(719), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(717), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7084] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(723), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(721), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7148] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(723), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(721), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7212] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(727), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(725), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7276] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(731), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(729), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7340] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(735), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(733), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7404] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(739), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(737), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7468] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(745), 1,
      sym__concat_pf_dot,
    ACTIONS(743), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(741), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [7534] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(749), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(747), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7598] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(753), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(751), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7662] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(401), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(399), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7726] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(757), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(755), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7790] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(761), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(759), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7854] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(765), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(763), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7918] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(769), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(767), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7982] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(773), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(771), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8046] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(777), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(775), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8110] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(781), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(779), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8174] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(785), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(783), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8238] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(789), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(787), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8302] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(793), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(791), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8366] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(797), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(795), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8430] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(801), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(799), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8494] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(805), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(803), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8558] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(809), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(807), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8622] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(53), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(51), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8686] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(813), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(811), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8750] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(817), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(815), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8814] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(821), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(819), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8878] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(825), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(823), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8942] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(829), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(827), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9006] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(833), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(831), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9070] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(837), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(835), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9134] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(841), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(839), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9198] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(845), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(843), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9262] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(849), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(847), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9326] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(853), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(851), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9390] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(857), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(855), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9454] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(861), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(859), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9518] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(865), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(863), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9582] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(869), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(867), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9646] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(873), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(871), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9710] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9774] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9838] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9902] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(881), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(879), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9966] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(885), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(883), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10030] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10094] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(889), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(887), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10158] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(893), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(891), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10222] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(897), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(895), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10286] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(422), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(420), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10350] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(901), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(899), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10414] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(905), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(903), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10478] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10542] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(909), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(907), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10606] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(913), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(911), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10670] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(917), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(915), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10734] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(921), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(919), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10798] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(925), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(923), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10862] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(929), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(927), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10926] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10990] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(933), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(931), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11054] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11118] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(937), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(935), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11182] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(941), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(939), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11246] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(945), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(943), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11310] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(949), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(947), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11374] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(953), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(951), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11438] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11502] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(957), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(955), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11566] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(961), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(959), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11630] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(965), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(963), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11694] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11758] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(969), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(967), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11822] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(575), 1,
      anon_sym_PIPE,
    ACTIONS(577), 1,
      anon_sym_PIPEH,
    ACTIONS(579), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(581), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(583), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(585), 1,
      anon_sym_AT_AT,
    ACTIONS(587), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(589), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(591), 1,
      anon_sym_AT_ATC,
    ACTIONS(593), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(595), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(597), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(599), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(601), 1,
      anon_sym_AT_ATt,
    ACTIONS(603), 1,
      anon_sym_AT_ATb,
    ACTIONS(605), 1,
      anon_sym_AT_ATi,
    ACTIONS(607), 1,
      anon_sym_AT_ATii,
    ACTIONS(609), 1,
      anon_sym_AT_ATiS,
    ACTIONS(611), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(613), 1,
      anon_sym_AT_ATis,
    ACTIONS(615), 1,
      anon_sym_AT_ATiz,
    ACTIONS(617), 1,
      anon_sym_AT_ATf,
    ACTIONS(619), 1,
      anon_sym_AT_ATF,
    ACTIONS(621), 1,
      anon_sym_AT_ATom,
    ACTIONS(623), 1,
      anon_sym_AT_ATdm,
    ACTIONS(625), 1,
      anon_sym_AT_ATr,
    ACTIONS(627), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(629), 1,
      anon_sym_AT,
    ACTIONS(631), 1,
      anon_sym_AT_BANG,
    ACTIONS(633), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(635), 1,
      anon_sym_ATa_COLON,
    ACTIONS(637), 1,
      anon_sym_ATb_COLON,
    ACTIONS(639), 1,
      anon_sym_ATB_COLON,
    ACTIONS(641), 1,
      anon_sym_ATe_COLON,
    ACTIONS(643), 1,
      anon_sym_ATF_COLON,
    ACTIONS(645), 1,
      anon_sym_ATi_COLON,
    ACTIONS(647), 1,
      anon_sym_ATk_COLON,
    ACTIONS(649), 1,
      anon_sym_ATo_COLON,
    ACTIONS(651), 1,
      anon_sym_ATr_COLON,
    ACTIONS(653), 1,
      anon_sym_ATf_COLON,
    ACTIONS(655), 1,
      anon_sym_ATs_COLON,
    ACTIONS(657), 1,
      anon_sym_ATv_COLON,
    ACTIONS(659), 1,
      anon_sym_ATx_COLON,
    ACTIONS(661), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(663), 1,
      anon_sym_GT,
    ACTIONS(665), 1,
      anon_sym_GT_GT,
    ACTIONS(667), 1,
      sym_html_redirect_operator,
    ACTIONS(669), 1,
      sym_html_append_operator,
    ACTIONS(671), 1,
      sym_file_descriptor,
    ACTIONS(971), 1,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(322), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [11985] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(577), 1,
      anon_sym_PIPEH,
    ACTIONS(579), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(581), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(583), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(585), 1,
      anon_sym_AT_AT,
    ACTIONS(587), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(589), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(591), 1,
      anon_sym_AT_ATC,
    ACTIONS(593), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(595), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(597), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(599), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(601), 1,
      anon_sym_AT_ATt,
    ACTIONS(603), 1,
      anon_sym_AT_ATb,
    ACTIONS(605), 1,
      anon_sym_AT_ATi,
    ACTIONS(607), 1,
      anon_sym_AT_ATii,
    ACTIONS(609), 1,
      anon_sym_AT_ATiS,
    ACTIONS(611), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(613), 1,
      anon_sym_AT_ATis,
    ACTIONS(615), 1,
      anon_sym_AT_ATiz,
    ACTIONS(617), 1,
      anon_sym_AT_ATf,
    ACTIONS(619), 1,
      anon_sym_AT_ATF,
    ACTIONS(621), 1,
      anon_sym_AT_ATom,
    ACTIONS(623), 1,
      anon_sym_AT_ATdm,
    ACTIONS(625), 1,
      anon_sym_AT_ATr,
    ACTIONS(627), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(629), 1,
      anon_sym_AT,
    ACTIONS(631), 1,
      anon_sym_AT_BANG,
    ACTIONS(633), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(635), 1,
      anon_sym_ATa_COLON,
    ACTIONS(637), 1,
      anon_sym_ATb_COLON,
    ACTIONS(639), 1,
      anon_sym_ATB_COLON,
    ACTIONS(641), 1,
      anon_sym_ATe_COLON,
    ACTIONS(643), 1,
      anon_sym_ATF_COLON,
    ACTIONS(645), 1,
      anon_sym_ATi_COLON,
    ACTIONS(647), 1,
      anon_sym_ATk_COLON,
    ACTIONS(649), 1,
      anon_sym_ATo_COLON,
    ACTIONS(651), 1,
      anon_sym_ATr_COLON,
    ACTIONS(653), 1,
      anon_sym_ATf_COLON,
    ACTIONS(655), 1,
      anon_sym_ATs_COLON,
    ACTIONS(657), 1,
      anon_sym_ATv_COLON,
    ACTIONS(659), 1,
      anon_sym_ATx_COLON,
    ACTIONS(661), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(975), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(973), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [12134] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(577), 1,
      anon_sym_PIPEH,
    ACTIONS(579), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(581), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(583), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(585), 1,
      anon_sym_AT_AT,
    ACTIONS(587), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(589), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(591), 1,
      anon_sym_AT_ATC,
    ACTIONS(593), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(595), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(597), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(599), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(601), 1,
      anon_sym_AT_ATt,
    ACTIONS(603), 1,
      anon_sym_AT_ATb,
    ACTIONS(605), 1,
      anon_sym_AT_ATi,
    ACTIONS(607), 1,
      anon_sym_AT_ATii,
    ACTIONS(609), 1,
      anon_sym_AT_ATiS,
    ACTIONS(611), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(613), 1,
      anon_sym_AT_ATis,
    ACTIONS(615), 1,
      anon_sym_AT_ATiz,
    ACTIONS(617), 1,
      anon_sym_AT_ATf,
    ACTIONS(619), 1,
      anon_sym_AT_ATF,
    ACTIONS(621), 1,
      anon_sym_AT_ATom,
    ACTIONS(623), 1,
      anon_sym_AT_ATdm,
    ACTIONS(625), 1,
      anon_sym_AT_ATr,
    ACTIONS(627), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(629), 1,
      anon_sym_AT,
    ACTIONS(631), 1,
      anon_sym_AT_BANG,
    ACTIONS(633), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(635), 1,
      anon_sym_ATa_COLON,
    ACTIONS(637), 1,
      anon_sym_ATb_COLON,
    ACTIONS(639), 1,
      anon_sym_ATB_COLON,
    ACTIONS(641), 1,
      anon_sym_ATe_COLON,
    ACTIONS(643), 1,
      anon_sym_ATF_COLON,
    ACTIONS(645), 1,
      anon_sym_ATi_COLON,
    ACTIONS(647), 1,
      anon_sym_ATk_COLON,
    ACTIONS(649), 1,
      anon_sym_ATo_COLON,
    ACTIONS(651), 1,
      anon_sym_ATr_COLON,
    ACTIONS(653), 1,
      anon_sym_ATf_COLON,
    ACTIONS(655), 1,
      anon_sym_ATs_COLON,
    ACTIONS(657), 1,
      anon_sym_ATv_COLON,
    ACTIONS(659), 1,
      anon_sym_ATx_COLON,
    ACTIONS(661), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(979), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(977), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [12283] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(577), 1,
      anon_sym_PIPEH,
    ACTIONS(579), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(591), 1,
      anon_sym_AT_ATC,
    ACTIONS(593), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(595), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(597), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(599), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(601), 1,
      anon_sym_AT_ATt,
    ACTIONS(603), 1,
      anon_sym_AT_ATb,
    ACTIONS(605), 1,
      anon_sym_AT_ATi,
    ACTIONS(607), 1,
      anon_sym_AT_ATii,
    ACTIONS(609), 1,
      anon_sym_AT_ATiS,
    ACTIONS(611), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(613), 1,
      anon_sym_AT_ATis,
    ACTIONS(615), 1,
      anon_sym_AT_ATiz,
    ACTIONS(617), 1,
      anon_sym_AT_ATf,
    ACTIONS(619), 1,
      anon_sym_AT_ATF,
    ACTIONS(621), 1,
      anon_sym_AT_ATom,
    ACTIONS(623), 1,
      anon_sym_AT_ATdm,
    ACTIONS(625), 1,
      anon_sym_AT_ATr,
    ACTIONS(633), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(635), 1,
      anon_sym_ATa_COLON,
    ACTIONS(639), 1,
      anon_sym_ATB_COLON,
    ACTIONS(641), 1,
      anon_sym_ATe_COLON,
    ACTIONS(643), 1,
      anon_sym_ATF_COLON,
    ACTIONS(647), 1,
      anon_sym_ATk_COLON,
    ACTIONS(651), 1,
      anon_sym_ATr_COLON,
    ACTIONS(653), 1,
      anon_sym_ATf_COLON,
    ACTIONS(655), 1,
      anon_sym_ATs_COLON,
    ACTIONS(657), 1,
      anon_sym_ATv_COLON,
    ACTIONS(659), 1,
      anon_sym_ATx_COLON,
    ACTIONS(661), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(663), 1,
      anon_sym_GT,
    ACTIONS(665), 1,
      anon_sym_GT_GT,
    ACTIONS(667), 1,
      sym_html_redirect_operator,
    ACTIONS(669), 1,
      sym_html_append_operator,
    ACTIONS(671), 1,
      sym_file_descriptor,
    ACTIONS(981), 1,
      anon_sym_TILDE,
    ACTIONS(983), 1,
      anon_sym_PIPE,
    ACTIONS(985), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(987), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(989), 1,
      anon_sym_AT_AT,
    ACTIONS(991), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(993), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(995), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(997), 1,
      anon_sym_AT,
    ACTIONS(999), 1,
      anon_sym_AT_BANG,
    ACTIONS(1001), 1,
      anon_sym_ATb_COLON,
    ACTIONS(1003), 1,
      anon_sym_ATi_COLON,
    ACTIONS(1005), 1,
      anon_sym_ATo_COLON,
    ACTIONS(571), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(322), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [12446] = 4,
    ACTIONS(131), 1,
      sym_file_descriptor,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1007), 1,
      aux_sym__interpret_stmt_token2,
    ACTIONS(133), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12509] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1009), 1,
      anon_sym_EQ,
    ACTIONS(709), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(707), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12572] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1011), 1,
      sym__concat_pf_dot,
    ACTIONS(743), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(741), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12635] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(577), 1,
      anon_sym_PIPEH,
    ACTIONS(579), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(591), 1,
      anon_sym_AT_ATC,
    ACTIONS(593), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(595), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(597), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(599), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(601), 1,
      anon_sym_AT_ATt,
    ACTIONS(603), 1,
      anon_sym_AT_ATb,
    ACTIONS(605), 1,
      anon_sym_AT_ATi,
    ACTIONS(607), 1,
      anon_sym_AT_ATii,
    ACTIONS(609), 1,
      anon_sym_AT_ATiS,
    ACTIONS(611), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(613), 1,
      anon_sym_AT_ATis,
    ACTIONS(615), 1,
      anon_sym_AT_ATiz,
    ACTIONS(617), 1,
      anon_sym_AT_ATf,
    ACTIONS(619), 1,
      anon_sym_AT_ATF,
    ACTIONS(621), 1,
      anon_sym_AT_ATom,
    ACTIONS(623), 1,
      anon_sym_AT_ATdm,
    ACTIONS(625), 1,
      anon_sym_AT_ATr,
    ACTIONS(633), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(635), 1,
      anon_sym_ATa_COLON,
    ACTIONS(639), 1,
      anon_sym_ATB_COLON,
    ACTIONS(641), 1,
      anon_sym_ATe_COLON,
    ACTIONS(643), 1,
      anon_sym_ATF_COLON,
    ACTIONS(647), 1,
      anon_sym_ATk_COLON,
    ACTIONS(651), 1,
      anon_sym_ATr_COLON,
    ACTIONS(653), 1,
      anon_sym_ATf_COLON,
    ACTIONS(655), 1,
      anon_sym_ATs_COLON,
    ACTIONS(657), 1,
      anon_sym_ATv_COLON,
    ACTIONS(659), 1,
      anon_sym_ATx_COLON,
    ACTIONS(661), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(985), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(987), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(989), 1,
      anon_sym_AT_AT,
    ACTIONS(991), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(993), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(995), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(997), 1,
      anon_sym_AT,
    ACTIONS(999), 1,
      anon_sym_AT_BANG,
    ACTIONS(1001), 1,
      anon_sym_ATb_COLON,
    ACTIONS(1003), 1,
      anon_sym_ATi_COLON,
    ACTIONS(1005), 1,
      anon_sym_ATo_COLON,
    ACTIONS(975), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(973), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12781] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(577), 1,
      anon_sym_PIPEH,
    ACTIONS(579), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(591), 1,
      anon_sym_AT_ATC,
    ACTIONS(593), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(595), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(597), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(599), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(601), 1,
      anon_sym_AT_ATt,
    ACTIONS(603), 1,
      anon_sym_AT_ATb,
    ACTIONS(605), 1,
      anon_sym_AT_ATi,
    ACTIONS(607), 1,
      anon_sym_AT_ATii,
    ACTIONS(609), 1,
      anon_sym_AT_ATiS,
    ACTIONS(611), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(613), 1,
      anon_sym_AT_ATis,
    ACTIONS(615), 1,
      anon_sym_AT_ATiz,
    ACTIONS(617), 1,
      anon_sym_AT_ATf,
    ACTIONS(619), 1,
      anon_sym_AT_ATF,
    ACTIONS(621), 1,
      anon_sym_AT_ATom,
    ACTIONS(623), 1,
      anon_sym_AT_ATdm,
    ACTIONS(625), 1,
      anon_sym_AT_ATr,
    ACTIONS(633), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(635), 1,
      anon_sym_ATa_COLON,
    ACTIONS(639), 1,
      anon_sym_ATB_COLON,
    ACTIONS(641), 1,
      anon_sym_ATe_COLON,
    ACTIONS(643), 1,
      anon_sym_ATF_COLON,
    ACTIONS(647), 1,
      anon_sym_ATk_COLON,
    ACTIONS(651), 1,
      anon_sym_ATr_COLON,
    ACTIONS(653), 1,
      anon_sym_ATf_COLON,
    ACTIONS(655), 1,
      anon_sym_ATs_COLON,
    ACTIONS(657), 1,
      anon_sym_ATv_COLON,
    ACTIONS(659), 1,
      anon_sym_ATx_COLON,
    ACTIONS(661), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(985), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(987), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(989), 1,
      anon_sym_AT_AT,
    ACTIONS(991), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(993), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(995), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(997), 1,
      anon_sym_AT,
    ACTIONS(999), 1,
      anon_sym_AT_BANG,
    ACTIONS(1001), 1,
      anon_sym_ATb_COLON,
    ACTIONS(1003), 1,
      anon_sym_ATi_COLON,
    ACTIONS(1005), 1,
      anon_sym_ATo_COLON,
    ACTIONS(979), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(977), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12927] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(278), 1,
      aux_sym_statements_repeat1,
    ACTIONS(1017), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
    ACTIONS(1015), 5,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(1013), 18,
      sym__cmd_identifier,
      sym__help_stmt,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      aux_sym__interpret_stmt_token3,
      aux_sym__interpret_stmt_token4,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      anon_sym_PERCENT,
      anon_sym_env,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      sym_macro_identifier,
      aux_sym__dec_number_token1,
  [12966] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1024), 1,
      anon_sym_SEMI,
    STATE(279), 1,
      aux_sym__statements_singleline_repeat1,
    ACTIONS(1022), 5,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(1020), 17,
      sym__cmd_identifier,
      sym__help_stmt,
      anon_sym_DQUOTE,
      aux_sym__interpret_stmt_token3,
      aux_sym__interpret_stmt_token4,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      anon_sym_PERCENT,
      anon_sym_env,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      sym_macro_identifier,
      aux_sym__dec_number_token1,
  [13002] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1029), 5,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(1027), 17,
      sym__cmd_identifier,
      sym__help_stmt,
      anon_sym_DQUOTE,
      aux_sym__interpret_stmt_token3,
      aux_sym__interpret_stmt_token4,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      anon_sym_PERCENT,
      anon_sym_env,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      sym_macro_identifier,
      aux_sym__dec_number_token1,
  [13032] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1031), 1,
      anon_sym_RPAREN,
    ACTIONS(1033), 1,
      anon_sym_SEMI,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(458), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13084] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1037), 1,
      anon_sym_RPAREN,
    STATE(247), 1,
      sym_macro_call_content,
    STATE(347), 1,
      sym_concatenation,
    STATE(466), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13136] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1037), 1,
      anon_sym_RPAREN,
    STATE(196), 1,
      sym_macro_call_content,
    STATE(347), 1,
      sym_concatenation,
    STATE(466), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13188] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1039), 1,
      anon_sym_DQUOTE,
    ACTIONS(1042), 1,
      anon_sym_DOLLAR,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1048), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1054), 1,
      anon_sym_SQUOTE,
    ACTIONS(1057), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1060), 1,
      anon_sym_BQUOTE,
    STATE(347), 1,
      sym_concatenation,
    ACTIONS(183), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(284), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13235] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    ACTIONS(161), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(284), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13282] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(225), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13328] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(216), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13374] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(196), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13420] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(495), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13466] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(485), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13512] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(487), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13558] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(504), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13604] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(221), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13650] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(227), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13696] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(196), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13742] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(225), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13788] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(217), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13834] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(200), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13880] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(491), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13926] = 14,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1073), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1075), 1,
      anon_sym_SQUOTE,
    ACTIONS(1077), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1079), 1,
      anon_sym_BQUOTE,
    STATE(245), 1,
      sym__eq_sep_val_concatenation,
    STATE(246), 1,
      sym__eq_sep_val,
    STATE(449), 1,
      sym_arg,
    STATE(476), 1,
      sym_concatenation,
    STATE(120), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13974] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(200), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14020] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(216), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14066] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(218), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14112] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(500), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14158] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(218), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14204] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(217), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14250] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(221), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14296] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(227), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14342] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(230), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14384] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(252), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14426] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(224), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14468] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(229), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14510] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(231), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14552] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(232), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14594] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(222), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14636] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(226), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14678] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(207), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14720] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1073), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1075), 1,
      anon_sym_SQUOTE,
    ACTIONS(1077), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1079), 1,
      anon_sym_BQUOTE,
    STATE(176), 1,
      sym_concatenation,
    STATE(180), 1,
      sym_arg,
    STATE(124), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14762] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(220), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14804] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(228), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14846] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(251), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14888] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(347), 1,
      sym_concatenation,
    STATE(398), 1,
      sym_arg,
    STATE(326), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14930] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(253), 1,
      sym_arg,
    STATE(78), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14972] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(1081), 1,
      sym__concat,
    STATE(325), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(286), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14999] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(281), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      sym__concat,
    STATE(325), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(279), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15026] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(275), 1,
      anon_sym_DOLLAR,
    ACTIONS(1081), 1,
      sym__concat,
    STATE(324), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(273), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15053] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15075] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 1,
      anon_sym_DOLLAR,
    ACTIONS(302), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15097] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(137), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      anon_sym_DOLLAR,
    ACTIONS(143), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_SQUOTE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      aux_sym_arg_identifier_token1,
    STATE(331), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15133] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15155] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(281), 1,
      anon_sym_DOLLAR,
    ACTIONS(279), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15177] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 1,
      anon_sym_DOLLAR,
    ACTIONS(322), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15199] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 1,
      anon_sym_DOLLAR,
    ACTIONS(314), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15221] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(300), 1,
      anon_sym_DOLLAR,
    ACTIONS(298), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15243] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1086), 1,
      anon_sym_DQUOTE,
    ACTIONS(1088), 1,
      anon_sym_DOLLAR,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1092), 1,
      anon_sym_COMMA,
    ACTIONS(1094), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1096), 1,
      anon_sym_SQUOTE,
    ACTIONS(1098), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1100), 1,
      anon_sym_BQUOTE,
    STATE(462), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15279] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 1,
      anon_sym_DOLLAR,
    ACTIONS(306), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15301] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 1,
      anon_sym_DOLLAR,
    ACTIONS(310), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15323] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(167), 1,
      anon_sym_DQUOTE,
    ACTIONS(171), 1,
      anon_sym_DOLLAR,
    ACTIONS(173), 1,
      anon_sym_LPAREN,
    ACTIONS(175), 1,
      anon_sym_COMMA,
    ACTIONS(177), 1,
      anon_sym_SQUOTE,
    ACTIONS(179), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(181), 1,
      anon_sym_BQUOTE,
    ACTIONS(1102), 1,
      aux_sym_arg_identifier_token1,
    STATE(407), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15359] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 1,
      anon_sym_DOLLAR,
    ACTIONS(294), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15381] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1065), 1,
      anon_sym_DQUOTE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1073), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1075), 1,
      anon_sym_SQUOTE,
    ACTIONS(1077), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1079), 1,
      anon_sym_BQUOTE,
    STATE(133), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15417] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(99), 1,
      anon_sym_DOLLAR,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_SQUOTE,
    ACTIONS(107), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(109), 1,
      anon_sym_BQUOTE,
    ACTIONS(1063), 1,
      aux_sym_arg_identifier_token1,
    STATE(88), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15453] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(212), 1,
      anon_sym_DOLLAR,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(189), 1,
      sym_pf_args,
    STATE(74), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(102), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15488] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(212), 1,
      anon_sym_DOLLAR,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(265), 1,
      sym_pf_args,
    STATE(97), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(102), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15523] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(212), 1,
      anon_sym_DOLLAR,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(189), 1,
      sym_pf_args,
    STATE(97), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(102), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15558] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(212), 1,
      anon_sym_DOLLAR,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(265), 1,
      sym_pf_args,
    STATE(74), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(102), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15593] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(179), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(181), 1,
      anon_sym_BQUOTE,
    ACTIONS(1106), 1,
      anon_sym_DOLLAR,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    ACTIONS(1110), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(498), 1,
      sym_pf_args,
    STATE(352), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(370), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15628] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(275), 1,
      anon_sym_DOLLAR,
    ACTIONS(273), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15649] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(212), 1,
      anon_sym_DOLLAR,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(203), 1,
      sym_pf_args,
    STATE(97), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(102), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15684] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(236), 1,
      anon_sym_RPAREN,
    ACTIONS(1112), 1,
      anon_sym_DOLLAR,
    ACTIONS(1115), 1,
      anon_sym_LPAREN,
    ACTIONS(1118), 1,
      aux_sym_pf_arg_identifier_token1,
    ACTIONS(1121), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1124), 1,
      anon_sym_BQUOTE,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(349), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(370), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15719] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(212), 1,
      anon_sym_DOLLAR,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(203), 1,
      sym_pf_args,
    STATE(74), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(102), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15754] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(179), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(181), 1,
      anon_sym_BQUOTE,
    ACTIONS(1106), 1,
      anon_sym_DOLLAR,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    ACTIONS(1110), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(506), 1,
      sym_pf_args,
    STATE(352), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(370), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15789] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(179), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(181), 1,
      anon_sym_BQUOTE,
    ACTIONS(252), 1,
      anon_sym_RPAREN,
    ACTIONS(1106), 1,
      anon_sym_DOLLAR,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    ACTIONS(1110), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(349), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(370), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15824] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1127), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1129), 1,
      anon_sym_DOLLAR,
    ACTIONS(1131), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_BQUOTE,
    STATE(71), 1,
      sym_pf_dot_arg,
    STATE(104), 1,
      sym_pf_dot_concatenation,
    STATE(190), 1,
      sym_pf_new_args,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(274), 1,
      sym_pf_dot_args,
    STATE(99), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15860] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1127), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1129), 1,
      anon_sym_DOLLAR,
    ACTIONS(1131), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_BQUOTE,
    STATE(57), 1,
      sym_pf_dot_arg,
    STATE(104), 1,
      sym_pf_dot_concatenation,
    STATE(190), 1,
      sym_pf_new_args,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(192), 1,
      sym_pf_dot_args,
    STATE(99), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15896] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DQUOTE,
    ACTIONS(230), 1,
      anon_sym_SQUOTE,
    ACTIONS(232), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(234), 1,
      anon_sym_BQUOTE,
    ACTIONS(1135), 1,
      sym__eq_sep_key_identifier,
    STATE(168), 1,
      sym__eq_sep_key,
    STATE(169), 1,
      sym__eq_sep_key_concatenation,
    STATE(214), 1,
      sym_eq_sep_args,
    STATE(131), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15930] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1137), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR,
    ACTIONS(1141), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_BQUOTE,
    STATE(117), 1,
      sym_pf_dot_arg,
    STATE(141), 1,
      sym_pf_dot_concatenation,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(274), 1,
      sym_pf_dot_args,
    STATE(125), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15963] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1137), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR,
    ACTIONS(1141), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_BQUOTE,
    STATE(117), 1,
      sym_pf_dot_arg,
    STATE(141), 1,
      sym_pf_dot_concatenation,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(192), 1,
      sym_pf_dot_args,
    STATE(125), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15996] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(212), 1,
      anon_sym_DOLLAR,
    ACTIONS(214), 1,
      anon_sym_LPAREN,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(108), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [16021] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DQUOTE,
    ACTIONS(230), 1,
      anon_sym_SQUOTE,
    ACTIONS(232), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(234), 1,
      anon_sym_BQUOTE,
    ACTIONS(1145), 1,
      sym__eq_sep_key_identifier,
    STATE(149), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [16046] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(179), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(181), 1,
      anon_sym_BQUOTE,
    ACTIONS(1106), 1,
      anon_sym_DOLLAR,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    ACTIONS(1110), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(390), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [16071] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1137), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR,
    ACTIONS(1141), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_BQUOTE,
    STATE(141), 1,
      sym_pf_dot_concatenation,
    STATE(146), 1,
      sym_pf_dot_arg,
    STATE(125), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16098] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1147), 1,
      anon_sym_DQUOTE,
    ACTIONS(1149), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1151), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16122] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1159), 1,
      anon_sym_DOLLAR,
    ACTIONS(1157), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16138] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1149), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1161), 1,
      anon_sym_DQUOTE,
    ACTIONS(1151), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16162] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1149), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1163), 1,
      anon_sym_DQUOTE,
    ACTIONS(1151), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16186] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1149), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1165), 1,
      anon_sym_DQUOTE,
    ACTIONS(1151), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16210] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1167), 1,
      anon_sym_DQUOTE,
    ACTIONS(1169), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1171), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(365), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16234] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1177), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(362), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16258] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(363), 1,
      anon_sym_DOLLAR,
    ACTIONS(1179), 1,
      sym__concat,
    STATE(369), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(361), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16278] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(353), 1,
      anon_sym_DOLLAR,
    ACTIONS(1182), 1,
      sym__concat,
    STATE(381), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(351), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16298] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1186), 1,
      anon_sym_DOLLAR,
    ACTIONS(1184), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16314] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1188), 1,
      anon_sym_DQUOTE,
    ACTIONS(1190), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1196), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1199), 1,
      anon_sym_BQUOTE,
    ACTIONS(1193), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16338] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1202), 1,
      anon_sym_DQUOTE,
    ACTIONS(1204), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1206), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16362] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1208), 1,
      anon_sym_DQUOTE,
    ACTIONS(1210), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1212), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16386] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1214), 1,
      anon_sym_DQUOTE,
    ACTIONS(1216), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1218), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(366), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16410] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1149), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1220), 1,
      anon_sym_DQUOTE,
    ACTIONS(1151), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16434] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1224), 1,
      anon_sym_DOLLAR,
    ACTIONS(1222), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16450] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1228), 1,
      anon_sym_DOLLAR,
    ACTIONS(1226), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16466] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1232), 1,
      anon_sym_DOLLAR,
    ACTIONS(1230), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16482] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1149), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_DQUOTE,
    ACTIONS(1151), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16506] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(370), 1,
      anon_sym_DOLLAR,
    ACTIONS(1182), 1,
      sym__concat,
    STATE(369), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(368), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16526] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1236), 1,
      anon_sym_DQUOTE,
    ACTIONS(1238), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1240), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(380), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16550] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16565] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16580] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(288), 1,
      anon_sym_DOLLAR,
    ACTIONS(1242), 1,
      sym__concat,
    STATE(387), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(286), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16599] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(275), 1,
      anon_sym_DOLLAR,
    ACTIONS(1242), 1,
      sym__concat,
    STATE(385), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(273), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16618] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(281), 1,
      anon_sym_DOLLAR,
    ACTIONS(1244), 1,
      sym__concat,
    STATE(387), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(279), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16637] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1137), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR,
    ACTIONS(1141), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_BQUOTE,
    STATE(154), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16658] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(376), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16673] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(363), 1,
      anon_sym_DOLLAR,
    ACTIONS(361), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16688] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(504), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(1247), 1,
      sym_grep_specifier_identifier,
    ACTIONS(1249), 1,
      aux_sym_grep_specifier_token1,
    STATE(205), 1,
      sym_grep_specifier,
    STATE(142), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16711] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(374), 1,
      anon_sym_DOLLAR,
    ACTIONS(372), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16726] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(407), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(409), 1,
      anon_sym_BQUOTE,
    ACTIONS(1249), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1251), 1,
      sym_grep_specifier_identifier,
    STATE(205), 1,
      sym_grep_specifier,
    STATE(116), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16749] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1127), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1129), 1,
      anon_sym_DOLLAR,
    ACTIONS(1131), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_BQUOTE,
    STATE(100), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16770] = 7,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(504), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(506), 1,
      anon_sym_BQUOTE,
    ACTIONS(1249), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1253), 1,
      sym_grep_specifier_identifier,
    STATE(205), 1,
      sym_grep_specifier,
    STATE(167), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16793] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 1,
      anon_sym_DOLLAR,
    ACTIONS(306), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16807] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 1,
      anon_sym_DOLLAR,
    ACTIONS(322), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16821] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1255), 6,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [16833] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(353), 1,
      anon_sym_DOLLAR,
    ACTIONS(351), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16847] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 1,
      anon_sym_DOLLAR,
    ACTIONS(314), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16861] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 1,
      anon_sym_DOLLAR,
    ACTIONS(310), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16875] = 3,
    ACTIONS(290), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(292), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16889] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 1,
      anon_sym_DOLLAR,
    ACTIONS(302), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16903] = 3,
    ACTIONS(290), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(292), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16917] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 1,
      anon_sym_DOLLAR,
    ACTIONS(294), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16931] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(300), 1,
      anon_sym_DOLLAR,
    ACTIONS(298), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16945] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(281), 1,
      anon_sym_DOLLAR,
    ACTIONS(279), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16959] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1257), 1,
      ts_builtin_sym_end,
    STATE(408), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1259), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16974] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1262), 1,
      ts_builtin_sym_end,
    STATE(408), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1264), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16989] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(79), 1,
      ts_builtin_sym_end,
    STATE(412), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1264), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17004] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1266), 1,
      ts_builtin_sym_end,
    STATE(409), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1264), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17019] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1266), 1,
      ts_builtin_sym_end,
    STATE(408), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1264), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17034] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(275), 1,
      anon_sym_DOLLAR,
    ACTIONS(273), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [17047] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1268), 1,
      anon_sym_SQUOTE,
    ACTIONS(1270), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1272), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(421), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17063] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1274), 1,
      anon_sym_SQUOTE,
    ACTIONS(1276), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1278), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(426), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17079] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1257), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17089] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1280), 1,
      anon_sym_SQUOTE,
    ACTIONS(1282), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1284), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(419), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17105] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1286), 1,
      anon_sym_SQUOTE,
    ACTIONS(1288), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1291), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17121] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1294), 1,
      anon_sym_SQUOTE,
    ACTIONS(1296), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1298), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17137] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1296), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1298), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1300), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17153] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1296), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1298), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1302), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17169] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1296), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1298), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1304), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17185] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1306), 1,
      anon_sym_SQUOTE,
    ACTIONS(1308), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1310), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(428), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17201] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1312), 1,
      anon_sym_SQUOTE,
    ACTIONS(1314), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1316), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(422), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17217] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1318), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(119), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(143), 1,
      sym_tmp_eval_arg,
    STATE(223), 1,
      sym_tmp_eval_args,
  [17233] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1296), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1298), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1320), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17249] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1322), 1,
      anon_sym_SQUOTE,
    ACTIONS(1324), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1326), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(420), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17265] = 5,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1296), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1298), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1328), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17281] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1330), 1,
      anon_sym_RPAREN,
    ACTIONS(1332), 1,
      anon_sym_SEMI,
    STATE(431), 1,
      aux_sym_macro_content_repeat1,
  [17294] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1334), 1,
      anon_sym_RPAREN,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    STATE(446), 1,
      aux_sym__statements_singleline_repeat2,
  [17307] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1338), 1,
      anon_sym_RPAREN,
    ACTIONS(1340), 1,
      anon_sym_SEMI,
    STATE(431), 1,
      aux_sym_macro_content_repeat1,
  [17320] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(279), 1,
      sym__eq_sep_concat,
    ACTIONS(1343), 1,
      sym__concat,
    STATE(432), 1,
      aux_sym_concatenation_repeat1,
  [17333] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1332), 1,
      anon_sym_SEMI,
    ACTIONS(1346), 1,
      anon_sym_RPAREN,
    STATE(429), 1,
      aux_sym_macro_content_repeat1,
  [17346] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(286), 1,
      sym__eq_sep_concat,
    ACTIONS(424), 1,
      sym__concat,
    STATE(432), 1,
      aux_sym_concatenation_repeat1,
  [17359] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1332), 1,
      anon_sym_SEMI,
    ACTIONS(1346), 1,
      anon_sym_RPAREN,
    STATE(431), 1,
      aux_sym_macro_content_repeat1,
  [17372] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1348), 1,
      anon_sym_DOLLAR,
    ACTIONS(1350), 1,
      aux_sym_spec_arg_identifier_token1,
    STATE(90), 1,
      sym_spec_arg_identifier,
  [17385] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    ACTIONS(1352), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      aux_sym__statements_singleline_repeat2,
  [17398] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1354), 1,
      anon_sym_RPAREN,
    ACTIONS(1356), 1,
      anon_sym_SEMI,
    STATE(438), 1,
      aux_sym__statements_singleline_repeat2,
  [17411] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1354), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [17420] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1334), 1,
      anon_sym_BQUOTE,
    ACTIONS(1359), 1,
      anon_sym_SEMI,
    STATE(442), 1,
      aux_sym__statements_singleline_repeat2,
  [17433] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1318), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(119), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(178), 1,
      sym_tmp_eval_arg,
  [17446] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1359), 1,
      anon_sym_SEMI,
    ACTIONS(1361), 1,
      anon_sym_BQUOTE,
    STATE(448), 1,
      aux_sym__statements_singleline_repeat2,
  [17459] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1332), 1,
      anon_sym_SEMI,
    ACTIONS(1363), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      aux_sym_macro_content_repeat1,
  [17472] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1359), 1,
      anon_sym_SEMI,
    ACTIONS(1361), 1,
      anon_sym_BQUOTE,
    STATE(445), 1,
      aux_sym__statements_singleline_repeat2,
  [17485] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1352), 1,
      anon_sym_BQUOTE,
    ACTIONS(1359), 1,
      anon_sym_SEMI,
    STATE(448), 1,
      aux_sym__statements_singleline_repeat2,
  [17498] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    ACTIONS(1361), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      aux_sym__statements_singleline_repeat2,
  [17511] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    ACTIONS(1361), 1,
      anon_sym_RPAREN,
    STATE(437), 1,
      aux_sym__statements_singleline_repeat2,
  [17524] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1354), 1,
      anon_sym_BQUOTE,
    ACTIONS(1365), 1,
      anon_sym_SEMI,
    STATE(448), 1,
      aux_sym__statements_singleline_repeat2,
  [17537] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(494), 1,
      sym__eq_sep_concat,
    STATE(138), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
  [17547] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(302), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17555] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1368), 1,
      aux_sym__search_stmt_token1,
    STATE(250), 1,
      sym__search_stmt,
  [17565] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(290), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17573] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17581] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17589] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1370), 1,
      aux_sym__search_stmt_token1,
    STATE(250), 1,
      sym__search_stmt,
  [17599] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(314), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17607] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(290), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17615] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1372), 1,
      anon_sym_RPAREN,
    ACTIONS(1374), 1,
      anon_sym_SEMI,
  [17625] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17633] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1376), 1,
      anon_sym_GT,
    ACTIONS(1378), 1,
      anon_sym_GT_GT,
  [17643] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(322), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17651] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(279), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17659] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1338), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [17667] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(306), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17675] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
  [17682] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1382), 1,
      anon_sym_RPAREN,
  [17689] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
  [17696] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1386), 1,
      anon_sym_BQUOTE,
  [17703] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1388), 1,
      anon_sym_BQUOTE,
  [17710] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1390), 1,
      anon_sym_RPAREN,
  [17717] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1392), 1,
      anon_sym_BQUOTE,
  [17724] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
  [17731] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1396), 1,
      anon_sym_BQUOTE,
  [17738] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
  [17745] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1400), 1,
      anon_sym_BQUOTE,
  [17752] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(273), 1,
      sym__eq_sep_concat,
  [17759] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1402), 1,
      anon_sym_RPAREN,
  [17766] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1404), 1,
      anon_sym_BQUOTE,
  [17773] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1406), 1,
      anon_sym_RPAREN,
  [17780] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1408), 1,
      sym__concat,
  [17787] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1410), 1,
      sym__concat_pf_dot,
  [17794] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1412), 1,
      sym__concat,
  [17801] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1414), 1,
      anon_sym_BQUOTE,
  [17808] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1416), 1,
      anon_sym_RPAREN,
  [17815] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1418), 1,
      anon_sym_RPAREN,
  [17822] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1420), 1,
      anon_sym_BQUOTE,
  [17829] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1422), 1,
      anon_sym_RPAREN,
  [17836] = 2,
    ACTIONS(393), 1,
      sym__comment,
    ACTIONS(1424), 1,
      aux_sym_legacy_quoted_stmt_token1,
  [17843] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1426), 1,
      anon_sym_BQUOTE,
  [17850] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1428), 1,
      anon_sym_RPAREN,
  [17857] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1430), 1,
      anon_sym_RPAREN,
  [17864] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1432), 1,
      anon_sym_DOT,
  [17871] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1434), 1,
      anon_sym_BQUOTE,
  [17878] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1436), 1,
      anon_sym_RPAREN,
  [17885] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1438), 1,
      anon_sym_RPAREN,
  [17892] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1440), 1,
      ts_builtin_sym_end,
  [17899] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1442), 1,
      anon_sym_RPAREN,
  [17906] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1444), 1,
      anon_sym_RPAREN,
  [17913] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1446), 1,
      anon_sym_BQUOTE,
  [17920] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1448), 1,
      anon_sym_RPAREN,
  [17927] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1450), 1,
      sym__concat_pf_dot,
  [17934] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1452), 1,
      anon_sym_RPAREN,
  [17941] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1454), 1,
      anon_sym_DQUOTE,
  [17948] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
  [17955] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1458), 1,
      sym__concat,
  [17962] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
  [17969] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1462), 1,
      anon_sym_BQUOTE,
  [17976] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1464), 1,
      sym__concat_pf_dot,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(93)] = 0,
  [SMALL_STATE(94)] = 87,
  [SMALL_STATE(95)] = 162,
  [SMALL_STATE(96)] = 233,
  [SMALL_STATE(97)] = 308,
  [SMALL_STATE(98)] = 391,
  [SMALL_STATE(99)] = 462,
  [SMALL_STATE(100)] = 535,
  [SMALL_STATE(101)] = 605,
  [SMALL_STATE(102)] = 675,
  [SMALL_STATE(103)] = 749,
  [SMALL_STATE(104)] = 819,
  [SMALL_STATE(105)] = 889,
  [SMALL_STATE(106)] = 959,
  [SMALL_STATE(107)] = 1033,
  [SMALL_STATE(108)] = 1107,
  [SMALL_STATE(109)] = 1176,
  [SMALL_STATE(110)] = 1245,
  [SMALL_STATE(111)] = 1314,
  [SMALL_STATE(112)] = 1383,
  [SMALL_STATE(113)] = 1452,
  [SMALL_STATE(114)] = 1528,
  [SMALL_STATE(115)] = 1596,
  [SMALL_STATE(116)] = 1664,
  [SMALL_STATE(117)] = 1742,
  [SMALL_STATE(118)] = 1813,
  [SMALL_STATE(119)] = 1884,
  [SMALL_STATE(120)] = 1955,
  [SMALL_STATE(121)] = 2028,
  [SMALL_STATE(122)] = 2099,
  [SMALL_STATE(123)] = 2170,
  [SMALL_STATE(124)] = 2241,
  [SMALL_STATE(125)] = 2312,
  [SMALL_STATE(126)] = 2381,
  [SMALL_STATE(127)] = 2452,
  [SMALL_STATE(128)] = 2523,
  [SMALL_STATE(129)] = 2594,
  [SMALL_STATE(130)] = 2665,
  [SMALL_STATE(131)] = 2736,
  [SMALL_STATE(132)] = 2807,
  [SMALL_STATE(133)] = 2877,
  [SMALL_STATE(134)] = 2943,
  [SMALL_STATE(135)] = 3017,
  [SMALL_STATE(136)] = 3087,
  [SMALL_STATE(137)] = 3153,
  [SMALL_STATE(138)] = 3219,
  [SMALL_STATE(139)] = 3289,
  [SMALL_STATE(140)] = 3355,
  [SMALL_STATE(141)] = 3425,
  [SMALL_STATE(142)] = 3491,
  [SMALL_STATE(143)] = 3567,
  [SMALL_STATE(144)] = 3637,
  [SMALL_STATE(145)] = 3703,
  [SMALL_STATE(146)] = 3769,
  [SMALL_STATE(147)] = 3835,
  [SMALL_STATE(148)] = 3901,
  [SMALL_STATE(149)] = 3967,
  [SMALL_STATE(150)] = 4033,
  [SMALL_STATE(151)] = 4099,
  [SMALL_STATE(152)] = 4165,
  [SMALL_STATE(153)] = 4231,
  [SMALL_STATE(154)] = 4297,
  [SMALL_STATE(155)] = 4363,
  [SMALL_STATE(156)] = 4429,
  [SMALL_STATE(157)] = 4495,
  [SMALL_STATE(158)] = 4565,
  [SMALL_STATE(159)] = 4631,
  [SMALL_STATE(160)] = 4697,
  [SMALL_STATE(161)] = 4763,
  [SMALL_STATE(162)] = 4829,
  [SMALL_STATE(163)] = 4895,
  [SMALL_STATE(164)] = 4961,
  [SMALL_STATE(165)] = 5027,
  [SMALL_STATE(166)] = 5093,
  [SMALL_STATE(167)] = 5160,
  [SMALL_STATE(168)] = 5233,
  [SMALL_STATE(169)] = 5300,
  [SMALL_STATE(170)] = 5365,
  [SMALL_STATE(171)] = 5430,
  [SMALL_STATE(172)] = 5495,
  [SMALL_STATE(173)] = 5560,
  [SMALL_STATE(174)] = 5627,
  [SMALL_STATE(175)] = 5692,
  [SMALL_STATE(176)] = 5759,
  [SMALL_STATE(177)] = 5824,
  [SMALL_STATE(178)] = 5889,
  [SMALL_STATE(179)] = 5954,
  [SMALL_STATE(180)] = 6119,
  [SMALL_STATE(181)] = 6184,
  [SMALL_STATE(182)] = 6248,
  [SMALL_STATE(183)] = 6312,
  [SMALL_STATE(184)] = 6376,
  [SMALL_STATE(185)] = 6442,
  [SMALL_STATE(186)] = 6506,
  [SMALL_STATE(187)] = 6570,
  [SMALL_STATE(188)] = 6634,
  [SMALL_STATE(189)] = 6698,
  [SMALL_STATE(190)] = 6762,
  [SMALL_STATE(191)] = 6826,
  [SMALL_STATE(192)] = 6890,
  [SMALL_STATE(193)] = 6956,
  [SMALL_STATE(194)] = 7020,
  [SMALL_STATE(195)] = 7084,
  [SMALL_STATE(196)] = 7148,
  [SMALL_STATE(197)] = 7212,
  [SMALL_STATE(198)] = 7276,
  [SMALL_STATE(199)] = 7340,
  [SMALL_STATE(200)] = 7404,
  [SMALL_STATE(201)] = 7468,
  [SMALL_STATE(202)] = 7534,
  [SMALL_STATE(203)] = 7598,
  [SMALL_STATE(204)] = 7662,
  [SMALL_STATE(205)] = 7726,
  [SMALL_STATE(206)] = 7790,
  [SMALL_STATE(207)] = 7854,
  [SMALL_STATE(208)] = 7918,
  [SMALL_STATE(209)] = 7982,
  [SMALL_STATE(210)] = 8046,
  [SMALL_STATE(211)] = 8110,
  [SMALL_STATE(212)] = 8174,
  [SMALL_STATE(213)] = 8238,
  [SMALL_STATE(214)] = 8302,
  [SMALL_STATE(215)] = 8366,
  [SMALL_STATE(216)] = 8430,
  [SMALL_STATE(217)] = 8494,
  [SMALL_STATE(218)] = 8558,
  [SMALL_STATE(219)] = 8622,
  [SMALL_STATE(220)] = 8686,
  [SMALL_STATE(221)] = 8750,
  [SMALL_STATE(222)] = 8814,
  [SMALL_STATE(223)] = 8878,
  [SMALL_STATE(224)] = 8942,
  [SMALL_STATE(225)] = 9006,
  [SMALL_STATE(226)] = 9070,
  [SMALL_STATE(227)] = 9134,
  [SMALL_STATE(228)] = 9198,
  [SMALL_STATE(229)] = 9262,
  [SMALL_STATE(230)] = 9326,
  [SMALL_STATE(231)] = 9390,
  [SMALL_STATE(232)] = 9454,
  [SMALL_STATE(233)] = 9518,
  [SMALL_STATE(234)] = 9582,
  [SMALL_STATE(235)] = 9646,
  [SMALL_STATE(236)] = 9710,
  [SMALL_STATE(237)] = 9774,
  [SMALL_STATE(238)] = 9838,
  [SMALL_STATE(239)] = 9902,
  [SMALL_STATE(240)] = 9966,
  [SMALL_STATE(241)] = 10030,
  [SMALL_STATE(242)] = 10094,
  [SMALL_STATE(243)] = 10158,
  [SMALL_STATE(244)] = 10222,
  [SMALL_STATE(245)] = 10286,
  [SMALL_STATE(246)] = 10350,
  [SMALL_STATE(247)] = 10414,
  [SMALL_STATE(248)] = 10478,
  [SMALL_STATE(249)] = 10542,
  [SMALL_STATE(250)] = 10606,
  [SMALL_STATE(251)] = 10670,
  [SMALL_STATE(252)] = 10734,
  [SMALL_STATE(253)] = 10798,
  [SMALL_STATE(254)] = 10862,
  [SMALL_STATE(255)] = 10926,
  [SMALL_STATE(256)] = 10990,
  [SMALL_STATE(257)] = 11054,
  [SMALL_STATE(258)] = 11118,
  [SMALL_STATE(259)] = 11182,
  [SMALL_STATE(260)] = 11246,
  [SMALL_STATE(261)] = 11310,
  [SMALL_STATE(262)] = 11374,
  [SMALL_STATE(263)] = 11438,
  [SMALL_STATE(264)] = 11502,
  [SMALL_STATE(265)] = 11566,
  [SMALL_STATE(266)] = 11630,
  [SMALL_STATE(267)] = 11694,
  [SMALL_STATE(268)] = 11758,
  [SMALL_STATE(269)] = 11822,
  [SMALL_STATE(270)] = 11985,
  [SMALL_STATE(271)] = 12134,
  [SMALL_STATE(272)] = 12283,
  [SMALL_STATE(273)] = 12446,
  [SMALL_STATE(274)] = 12509,
  [SMALL_STATE(275)] = 12572,
  [SMALL_STATE(276)] = 12635,
  [SMALL_STATE(277)] = 12781,
  [SMALL_STATE(278)] = 12927,
  [SMALL_STATE(279)] = 12966,
  [SMALL_STATE(280)] = 13002,
  [SMALL_STATE(281)] = 13032,
  [SMALL_STATE(282)] = 13084,
  [SMALL_STATE(283)] = 13136,
  [SMALL_STATE(284)] = 13188,
  [SMALL_STATE(285)] = 13235,
  [SMALL_STATE(286)] = 13282,
  [SMALL_STATE(287)] = 13328,
  [SMALL_STATE(288)] = 13374,
  [SMALL_STATE(289)] = 13420,
  [SMALL_STATE(290)] = 13466,
  [SMALL_STATE(291)] = 13512,
  [SMALL_STATE(292)] = 13558,
  [SMALL_STATE(293)] = 13604,
  [SMALL_STATE(294)] = 13650,
  [SMALL_STATE(295)] = 13696,
  [SMALL_STATE(296)] = 13742,
  [SMALL_STATE(297)] = 13788,
  [SMALL_STATE(298)] = 13834,
  [SMALL_STATE(299)] = 13880,
  [SMALL_STATE(300)] = 13926,
  [SMALL_STATE(301)] = 13974,
  [SMALL_STATE(302)] = 14020,
  [SMALL_STATE(303)] = 14066,
  [SMALL_STATE(304)] = 14112,
  [SMALL_STATE(305)] = 14158,
  [SMALL_STATE(306)] = 14204,
  [SMALL_STATE(307)] = 14250,
  [SMALL_STATE(308)] = 14296,
  [SMALL_STATE(309)] = 14342,
  [SMALL_STATE(310)] = 14384,
  [SMALL_STATE(311)] = 14426,
  [SMALL_STATE(312)] = 14468,
  [SMALL_STATE(313)] = 14510,
  [SMALL_STATE(314)] = 14552,
  [SMALL_STATE(315)] = 14594,
  [SMALL_STATE(316)] = 14636,
  [SMALL_STATE(317)] = 14678,
  [SMALL_STATE(318)] = 14720,
  [SMALL_STATE(319)] = 14762,
  [SMALL_STATE(320)] = 14804,
  [SMALL_STATE(321)] = 14846,
  [SMALL_STATE(322)] = 14888,
  [SMALL_STATE(323)] = 14930,
  [SMALL_STATE(324)] = 14972,
  [SMALL_STATE(325)] = 14999,
  [SMALL_STATE(326)] = 15026,
  [SMALL_STATE(327)] = 15053,
  [SMALL_STATE(328)] = 15075,
  [SMALL_STATE(329)] = 15097,
  [SMALL_STATE(330)] = 15133,
  [SMALL_STATE(331)] = 15155,
  [SMALL_STATE(332)] = 15177,
  [SMALL_STATE(333)] = 15199,
  [SMALL_STATE(334)] = 15221,
  [SMALL_STATE(335)] = 15243,
  [SMALL_STATE(336)] = 15279,
  [SMALL_STATE(337)] = 15301,
  [SMALL_STATE(338)] = 15323,
  [SMALL_STATE(339)] = 15359,
  [SMALL_STATE(340)] = 15381,
  [SMALL_STATE(341)] = 15417,
  [SMALL_STATE(342)] = 15453,
  [SMALL_STATE(343)] = 15488,
  [SMALL_STATE(344)] = 15523,
  [SMALL_STATE(345)] = 15558,
  [SMALL_STATE(346)] = 15593,
  [SMALL_STATE(347)] = 15628,
  [SMALL_STATE(348)] = 15649,
  [SMALL_STATE(349)] = 15684,
  [SMALL_STATE(350)] = 15719,
  [SMALL_STATE(351)] = 15754,
  [SMALL_STATE(352)] = 15789,
  [SMALL_STATE(353)] = 15824,
  [SMALL_STATE(354)] = 15860,
  [SMALL_STATE(355)] = 15896,
  [SMALL_STATE(356)] = 15930,
  [SMALL_STATE(357)] = 15963,
  [SMALL_STATE(358)] = 15996,
  [SMALL_STATE(359)] = 16021,
  [SMALL_STATE(360)] = 16046,
  [SMALL_STATE(361)] = 16071,
  [SMALL_STATE(362)] = 16098,
  [SMALL_STATE(363)] = 16122,
  [SMALL_STATE(364)] = 16138,
  [SMALL_STATE(365)] = 16162,
  [SMALL_STATE(366)] = 16186,
  [SMALL_STATE(367)] = 16210,
  [SMALL_STATE(368)] = 16234,
  [SMALL_STATE(369)] = 16258,
  [SMALL_STATE(370)] = 16278,
  [SMALL_STATE(371)] = 16298,
  [SMALL_STATE(372)] = 16314,
  [SMALL_STATE(373)] = 16338,
  [SMALL_STATE(374)] = 16362,
  [SMALL_STATE(375)] = 16386,
  [SMALL_STATE(376)] = 16410,
  [SMALL_STATE(377)] = 16434,
  [SMALL_STATE(378)] = 16450,
  [SMALL_STATE(379)] = 16466,
  [SMALL_STATE(380)] = 16482,
  [SMALL_STATE(381)] = 16506,
  [SMALL_STATE(382)] = 16526,
  [SMALL_STATE(383)] = 16550,
  [SMALL_STATE(384)] = 16565,
  [SMALL_STATE(385)] = 16580,
  [SMALL_STATE(386)] = 16599,
  [SMALL_STATE(387)] = 16618,
  [SMALL_STATE(388)] = 16637,
  [SMALL_STATE(389)] = 16658,
  [SMALL_STATE(390)] = 16673,
  [SMALL_STATE(391)] = 16688,
  [SMALL_STATE(392)] = 16711,
  [SMALL_STATE(393)] = 16726,
  [SMALL_STATE(394)] = 16749,
  [SMALL_STATE(395)] = 16770,
  [SMALL_STATE(396)] = 16793,
  [SMALL_STATE(397)] = 16807,
  [SMALL_STATE(398)] = 16821,
  [SMALL_STATE(399)] = 16833,
  [SMALL_STATE(400)] = 16847,
  [SMALL_STATE(401)] = 16861,
  [SMALL_STATE(402)] = 16875,
  [SMALL_STATE(403)] = 16889,
  [SMALL_STATE(404)] = 16903,
  [SMALL_STATE(405)] = 16917,
  [SMALL_STATE(406)] = 16931,
  [SMALL_STATE(407)] = 16945,
  [SMALL_STATE(408)] = 16959,
  [SMALL_STATE(409)] = 16974,
  [SMALL_STATE(410)] = 16989,
  [SMALL_STATE(411)] = 17004,
  [SMALL_STATE(412)] = 17019,
  [SMALL_STATE(413)] = 17034,
  [SMALL_STATE(414)] = 17047,
  [SMALL_STATE(415)] = 17063,
  [SMALL_STATE(416)] = 17079,
  [SMALL_STATE(417)] = 17089,
  [SMALL_STATE(418)] = 17105,
  [SMALL_STATE(419)] = 17121,
  [SMALL_STATE(420)] = 17137,
  [SMALL_STATE(421)] = 17153,
  [SMALL_STATE(422)] = 17169,
  [SMALL_STATE(423)] = 17185,
  [SMALL_STATE(424)] = 17201,
  [SMALL_STATE(425)] = 17217,
  [SMALL_STATE(426)] = 17233,
  [SMALL_STATE(427)] = 17249,
  [SMALL_STATE(428)] = 17265,
  [SMALL_STATE(429)] = 17281,
  [SMALL_STATE(430)] = 17294,
  [SMALL_STATE(431)] = 17307,
  [SMALL_STATE(432)] = 17320,
  [SMALL_STATE(433)] = 17333,
  [SMALL_STATE(434)] = 17346,
  [SMALL_STATE(435)] = 17359,
  [SMALL_STATE(436)] = 17372,
  [SMALL_STATE(437)] = 17385,
  [SMALL_STATE(438)] = 17398,
  [SMALL_STATE(439)] = 17411,
  [SMALL_STATE(440)] = 17420,
  [SMALL_STATE(441)] = 17433,
  [SMALL_STATE(442)] = 17446,
  [SMALL_STATE(443)] = 17459,
  [SMALL_STATE(444)] = 17472,
  [SMALL_STATE(445)] = 17485,
  [SMALL_STATE(446)] = 17498,
  [SMALL_STATE(447)] = 17511,
  [SMALL_STATE(448)] = 17524,
  [SMALL_STATE(449)] = 17537,
  [SMALL_STATE(450)] = 17547,
  [SMALL_STATE(451)] = 17555,
  [SMALL_STATE(452)] = 17565,
  [SMALL_STATE(453)] = 17573,
  [SMALL_STATE(454)] = 17581,
  [SMALL_STATE(455)] = 17589,
  [SMALL_STATE(456)] = 17599,
  [SMALL_STATE(457)] = 17607,
  [SMALL_STATE(458)] = 17615,
  [SMALL_STATE(459)] = 17625,
  [SMALL_STATE(460)] = 17633,
  [SMALL_STATE(461)] = 17643,
  [SMALL_STATE(462)] = 17651,
  [SMALL_STATE(463)] = 17659,
  [SMALL_STATE(464)] = 17667,
  [SMALL_STATE(465)] = 17675,
  [SMALL_STATE(466)] = 17682,
  [SMALL_STATE(467)] = 17689,
  [SMALL_STATE(468)] = 17696,
  [SMALL_STATE(469)] = 17703,
  [SMALL_STATE(470)] = 17710,
  [SMALL_STATE(471)] = 17717,
  [SMALL_STATE(472)] = 17724,
  [SMALL_STATE(473)] = 17731,
  [SMALL_STATE(474)] = 17738,
  [SMALL_STATE(475)] = 17745,
  [SMALL_STATE(476)] = 17752,
  [SMALL_STATE(477)] = 17759,
  [SMALL_STATE(478)] = 17766,
  [SMALL_STATE(479)] = 17773,
  [SMALL_STATE(480)] = 17780,
  [SMALL_STATE(481)] = 17787,
  [SMALL_STATE(482)] = 17794,
  [SMALL_STATE(483)] = 17801,
  [SMALL_STATE(484)] = 17808,
  [SMALL_STATE(485)] = 17815,
  [SMALL_STATE(486)] = 17822,
  [SMALL_STATE(487)] = 17829,
  [SMALL_STATE(488)] = 17836,
  [SMALL_STATE(489)] = 17843,
  [SMALL_STATE(490)] = 17850,
  [SMALL_STATE(491)] = 17857,
  [SMALL_STATE(492)] = 17864,
  [SMALL_STATE(493)] = 17871,
  [SMALL_STATE(494)] = 17878,
  [SMALL_STATE(495)] = 17885,
  [SMALL_STATE(496)] = 17892,
  [SMALL_STATE(497)] = 17899,
  [SMALL_STATE(498)] = 17906,
  [SMALL_STATE(499)] = 17913,
  [SMALL_STATE(500)] = 17920,
  [SMALL_STATE(501)] = 17927,
  [SMALL_STATE(502)] = 17934,
  [SMALL_STATE(503)] = 17941,
  [SMALL_STATE(504)] = 17948,
  [SMALL_STATE(505)] = 17955,
  [SMALL_STATE(506)] = 17962,
  [SMALL_STATE(507)] = 17969,
  [SMALL_STATE(508)] = 17976,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_stmt_identifier, 1),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_last_stmt_identifier, 1),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 1),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 1),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 1),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_stmt, 1, .production_id = 2),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_stmt, 1, .production_id = 2),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt, 1, .production_id = 2),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt, 1, .production_id = 2),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_disable_stmt, 2, .production_id = 2),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_disable_stmt, 2, .production_id = 2),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_help_stmt, 1, .production_id = 2),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_help_stmt, 1, .production_id = 2),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_stmt, 2),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_stmt, 2),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_stmt, 2),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_stmt, 2),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 1, .production_id = 3),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 1, .production_id = 3),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_stmt, 1, .production_id = 2),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_stmt, 1, .production_id = 2),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_stmt, 1, .production_id = 2),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_stmt, 1, .production_id = 2),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 3),
  [159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 3),
  [161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_args, 1),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_args, 1),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 1, .production_id = 2),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 1, .production_id = 2),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(367),
  [188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(86),
  [193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(291),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(83),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(417),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(12),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(6),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 1),
  [210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 1),
  [212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt, 1, .production_id = 2),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt, 1, .production_id = 2),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(110),
  [243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(351),
  [246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(17),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(29),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_args, 1),
  [254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_args, 1),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_identifier, 1, .production_id = 1),
  [258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_identifier, 1, .production_id = 1),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specifiers, 1),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specifiers, 1),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 2),
  [268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_specifiers_repeat1, 2),
  [270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 2), SHIFT_REPEAT(480),
  [273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg, 1),
  [275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg, 1),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(341),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 2),
  [288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 2),
  [290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_substitution_arg, 3),
  [292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_substitution_arg, 3),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 2),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 2),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, .production_id = 7),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, .production_id = 7),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 2),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 2),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg_identifier, 1),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg_identifier, 1),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 3),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 3),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_with_paren, 3, .production_id = 18),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_with_paren, 3, .production_id = 18),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 3),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_specifiers_repeat1, 3),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 3),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 3),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spec_arg_identifier, 1),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_spec_arg_identifier, 1),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_concatenation, 2),
  [332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_concatenation, 2),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_identifier, 2, .production_id = 6),
  [338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_identifier, 2, .production_id = 6),
  [340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(394),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_arg, 1),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_arg, 1),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg, 1),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg, 1),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(358),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_concatenation, 2),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_concatenation, 2),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg_identifier, 1),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg_identifier, 1),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 19),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 19),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(113),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(15),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(14),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt_identifier, 1),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt_identifier, 1),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 1),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 1),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(340),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_arg, 1, .production_id = 7),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_arg, 1, .production_id = 7),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val, 1),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val, 1),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 2),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 2),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2), SHIFT_REPEAT(359),
  [441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2), SHIFT_REPEAT(492),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2), SHIFT_REPEAT(147),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(388),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key, 1),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key, 1),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_args, 1),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_args, 1),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(134),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(10),
  [480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(9),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2), SHIFT_REPEAT(441),
  [490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 2),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 2),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 1),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 1),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 1),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 1),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2), SHIFT_REPEAT(318),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_stmt, 2),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_stmt, 2),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 1),
  [535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 1),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 6, .production_id = 15),
  [541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 6, .production_id = 15),
  [543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 2, .production_id = 15),
  [545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 2, .production_id = 15),
  [547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 3, .production_id = 15),
  [549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 3, .production_id = 15),
  [551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_stmt, 2),
  [553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_stmt, 2),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 5, .production_id = 15),
  [559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 5, .production_id = 15),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_stmt, 2),
  [563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_stmt, 2),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 4, .production_id = 15),
  [569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 4, .production_id = 15),
  [571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fromto_stmt, 4),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fromto_stmt, 4),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bbs_stmt, 2),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_bbs_stmt, 2),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_legacy_quoted_stmt, 3, .production_id = 12),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_legacy_quoted_stmt, 3, .production_id = 12),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 3, .production_id = 13),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 3, .production_id = 13),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_content, 2),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_content, 2),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__Cf_args, 2),
  [697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__Cf_args, 2),
  [699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 14),
  [701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 14),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 14),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 14),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_register_stmt, 2),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_register_stmt, 2),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt_question, 2, .production_id = 8),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt_question, 2, .production_id = 8),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 9),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 9),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbgmap_stmt, 2),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbgmap_stmt, 2),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_args, 2),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_args, 2),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_content, 1),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_content, 1),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_stmt, 2, .production_id = 8),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_stmt, 2, .production_id = 8),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_stmt, 1, .production_id = 2),
  [743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_stmt, 1, .production_id = 2),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 2, .production_id = 8),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 2, .production_id = 8),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_cmd, 2, .production_id = 8),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_cmd, 2, .production_id = 8),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_stmt, 3, .production_id = 16),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_stmt, 3, .production_id = 16),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_stmt, 3),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe_stmt, 3),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_file_lines_stmt, 3),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_file_lines_stmt, 3),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_stmt, 3),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_stmt, 3),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_stmt, 3),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_stmt, 3),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_iomap_stmt, 2),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_iomap_stmt, 2),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_string_stmt, 2),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_string_stmt, 2),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 10),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 10),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__math_arged_stmt, 2, .production_id = 8),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__math_arged_stmt, 2, .production_id = 8),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_arged_stmt, 2, .production_id = 8),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pointer_arged_stmt, 2, .production_id = 8),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_stmt, 2, .production_id = 8),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_stmt, 2, .production_id = 8),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_step_stmt, 3),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_step_stmt, 3),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_seek_stmt, 3),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_seek_stmt, 3),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_blksz_stmt, 3),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_blksz_stmt, 3),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_arch_stmt, 3),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_arch_stmt, 3),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_bits_stmt, 3),
  [817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_bits_stmt, 3),
  [819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_nthi_stmt, 3),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_nthi_stmt, 3),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_stmt, 3),
  [825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_stmt, 3),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fs_stmt, 3),
  [829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fs_stmt, 3),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reli_stmt, 3),
  [833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reli_stmt, 3),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_kuery_stmt, 3),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_kuery_stmt, 3),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fd_stmt, 3),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fd_stmt, 3),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reg_stmt, 3),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reg_stmt, 3),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_file_stmt, 3),
  [849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_file_stmt, 3),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_string_stmt, 3),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_string_stmt, 3),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_value_stmt, 3),
  [857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_value_stmt, 3),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_hex_stmt, 3),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_hex_stmt, 3),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_symbol_stmt, 2),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_symbol_stmt, 2),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_segments_stmt, 2),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_segments_stmt, 2),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__last_stmt, 1, .production_id = 2),
  [873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__last_stmt, 1, .production_id = 2),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_stmt, 1, .production_id = 4),
  [877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_stmt, 1, .production_id = 4),
  [879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt, 2, .production_id = 8),
  [881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt, 2, .production_id = 8),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_enable_stmt, 2, .production_id = 2),
  [885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_enable_stmt, 2, .production_id = 2),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_args, 2),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_args, 2),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_stmt, 1, .production_id = 5),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_stmt, 1, .production_id = 5),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbta_stmt, 2),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbta_stmt, 2),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 3),
  [901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 3),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_full_content, 2),
  [905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_full_content, 2),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 2),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 2),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_hit_stmt, 4, .production_id = 20),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_hit_stmt, 4, .production_id = 20),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_stmt, 4),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_stmt, 4),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_stmt, 4),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_stmt, 4),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_stmt, 4),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_stmt, 4),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_stmt, 2, .production_id = 11),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_stmt, 2, .production_id = 11),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbtb_stmt, 2),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbtb_stmt, 2),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbts_stmt, 2),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbts_stmt, 2),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_threads_stmt, 2),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_threads_stmt, 2),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_stmt, 2, .production_id = 8),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_stmt, 2, .production_id = 8),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_sections_stmt, 2),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_sections_stmt, 2),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_instrs_stmt, 2),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_instrs_stmt, 2),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_stmt, 2, .production_id = 8),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_stmt, 2, .production_id = 8),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 21),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 21),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_import_stmt, 2),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_import_stmt, 2),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt, 2, .production_id = 8),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt, 2, .production_id = 8),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_offsetssizes_stmt, 3),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_offsetssizes_stmt, 3),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_stmt, 3),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_stmt, 3),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat1, 2),
  [1015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statements_repeat1, 2),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statements_repeat1, 2), SHIFT_REPEAT(278),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat1, 2),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_singleline_repeat1, 2),
  [1024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat1, 2), SHIFT_REPEAT(279),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dec_number, 1),
  [1029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dec_number, 1),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(375),
  [1042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(336),
  [1045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(292),
  [1048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(334),
  [1051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(336),
  [1054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(424),
  [1057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(18),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(19),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(329),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(392),
  [1115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(346),
  [1118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(392),
  [1121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(21),
  [1124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(25),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(360),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_search_identifier, 1),
  [1186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_search_identifier, 1),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2),
  [1190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(372),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(372),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(26),
  [1199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(24),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 2),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 2),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 1),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 1),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(338),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirect_stmt, 3, .production_id = 17),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 2),
  [1259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 2), SHIFT_REPEAT(5),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 3),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 2),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2),
  [1288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(418),
  [1291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(418),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 1),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_content_repeat1, 2),
  [1340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_content_repeat1, 2), SHIFT_REPEAT(34),
  [1343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(335),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 3),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2),
  [1356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2), SHIFT_REPEAT(33),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 2),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2), SHIFT_REPEAT(30),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1440] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rzcmd_external_scanner_create(void);
void tree_sitter_rzcmd_external_scanner_destroy(void *);
bool tree_sitter_rzcmd_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rzcmd_external_scanner_serialize(void *, char *);
void tree_sitter_rzcmd_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_rzcmd(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_rzcmd_external_scanner_create,
      tree_sitter_rzcmd_external_scanner_destroy,
      tree_sitter_rzcmd_external_scanner_scan,
      tree_sitter_rzcmd_external_scanner_serialize,
      tree_sitter_rzcmd_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
